/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/*****************************************************************************/
/* This is an automatically generated file. If you're not                    */
/* nsStrictTransportSecurityService.cpp, you shouldn't be #including it.     */
/*****************************************************************************/

#include "mozilla/StandardInteger.h"
const PRTime gPreloadListExpirationTime = INT64_C(1469272806077000);

class nsSTSPreload
{
  public:
    const char *mHost;
    const bool mIncludeSubdomains;
};

static const nsSTSPreload kSTSPreloadList[] = {
  { "0.me.uk", true },
  { "007sascha.de", true },
  { "0513c.com", true },
  { "0au.de", true },
  { "0knowledge.de", true },
  { "0p.no", true },
  { "0paste.com", true },
  { "0x.cx", true },
  { "0x0a.net", true },
  { "0x1337.eu", true },
  { "0x52.net", true },
  { "0x90.fi", true },
  { "0x90.io", true },
  { "0xa.in", true },
  { "0xee.eu", true },
  { "0xf00.ch", true },
  { "0xfc.de", true },
  { "1000minds.com", true },
  { "1011100.com", true },
  { "1017scribes.com", true },
  { "1022996493.rsc.cdn77.org", true },
  { "126ium.moe", true },
  { "1464424382.rsc.cdn77.org", true },
  { "14it.de", true },
  { "17hats.com", true },
  { "188trafalgar.ca", true },
  { "18f.gov", true },
  { "18f.gsa.gov", true },
  { "1972969867.rsc.cdn77.org", true },
  { "1a-diamantscheiben.de", true },
  { "1a-jva.de", true },
  { "1a-vermessung.at", true },
  { "1a-werkstattgeraete.de", true },
  { "1co-jp.net", true },
  { "1cover.com.au", true },
  { "1km.ro", true },
  { "1stcapital.com.sg", true },
  { "1whw.co.uk", true },
  { "1xcess.com", true },
  { "2048game.co.uk", true },
  { "21.co.uk", true },
  { "24ip.com", true },
  { "2600hq.com", true },
  { "28spots.net", true },
  { "2bis10.de", true },
  { "2brokegirls.org", true },
  { "2carpros.com", true },
  { "2e-systems.com", true },
  { "2gen.com", true },
  { "2nerds1bit.com", true },
  { "2or3.tk", true },
  { "2programmers.net", true },
  { "301.website", true },
  { "314chan.org", true },
  { "33-km.ru", true },
  { "3473-wiki.de", true },
  { "360gradus.com", true },
  { "368mibn.com", true },
  { "3chit.cf", true },
  { "3do3dont.com", true },
  { "3r.org.uk", true },
  { "3s-hosting.de", true },
  { "403.ch", true },
  { "42ms.org", true },
  { "4eyes.ch", true },
  { "4g-server.eu", true },
  { "4mm.org", true },
  { "4ourty2.org", true },
  { "4project.co.il", true },
  { "4sqsu.eu", true },
  { "5apps.com", true },
  { "6660111.ru", true },
  { "692b8c32.de", true },
  { "6969.us", true },
  { "7183.org", true },
  { "777coin.com", true },
  { "7kovrikov.ru", true },
  { "7sons.de", true },
  { "7thheavenrestaurant.com", true },
  { "808.lv", true },
  { "888sport.dk", true },
  { "888sport.it", true },
  { "8ack.de", true },
  { "911911.pw", true },
  { "91tianmi.com", true },
  { "960news.ca", true },
  { "99511.fi", true },
  { "9point6.com", true },
  { "a-plus.space", true },
  { "a2nutrition.com.au", true },
  { "aaeblog.com", true },
  { "aanmpc.com", true },
  { "aaron-gustafson.com", true },
  { "aaronkimmig.de", true },
  { "abacustech.co.jp", true },
  { "abcheck.se", true },
  { "abecodes.net", false },
  { "abeestrada.com", true },
  { "abiapp.net", true },
  { "abilitynet.org.uk", true },
  { "abilymp06.net", true },
  { "abioniere.de", true },
  { "abiturma.de", true },
  { "abmahnhelfer.de", false },
  { "abmgood.com", true },
  { "abou.to", true },
  { "aboutmyip.info", true },
  { "aboutmyproperty.ca", true },
  { "abrilect.com", true },
  { "abury.fr", true },
  { "abury.me", true },
  { "ac-town.com", true },
  { "acabadosboston.com", true },
  { "access-sofia.org", true },
  { "accountradar.com", true },
  { "accounts.firefox.com", true },
  { "accounts.google.com", true },
  { "acheconcursos.com.br", true },
  { "achenar.net", true },
  { "achromatisch.de", true },
  { "aclu.org", false },
  { "acnpacific.com", true },
  { "acorns.com", true },
  { "acr.im", true },
  { "active.hu", true },
  { "actserv.co.ke", true },
  { "acuica.co.uk", false },
  { "acus.gov", true },
  { "ad-notam.pt", true },
  { "adam-kostecki.de", true },
  { "adambyers.com", true },
  { "adamkostecki.de", true },
  { "adamradocz.com", true },
  { "adams.dk", true },
  { "adamstas.com", true },
  { "adayinthelifeof.nl", true },
  { "adblock.ovh", true },
  { "adblockextreme.com", true },
  { "adblockextreme.org", true },
  { "adboos.com", true },
  { "addaxpetroleum.com", true },
  { "adderall.space", true },
  { "adduono.com", true },
  { "addvocate.com", true },
  { "adevel.eu", true },
  { "adigitali.biz", true },
  { "adimaja.com", true },
  { "adjagu.org", true },
  { "adlershop.ch", true },
  { "admin.fedoraproject.org", true },
  { "admin.google.com", true },
  { "admin.stg.fedoraproject.org", true },
  { "admsel.ec", true },
  { "adopteunsiteflash.com", true },
  { "adorai.tk", true },
  { "adquisitio.co.uk", true },
  { "adquisitio.de", true },
  { "adquisitio.es", true },
  { "adquisitio.fr", true },
  { "adquisitio.it", true },
  { "adrl.ca", true },
  { "adsfund.org", true },
  { "advanced-online.eu", true },
  { "advancedseotool.it", true },
  { "advancis.net", true },
  { "adviespuntklokkenluiders.nl", true },
  { "aeon.co", true },
  { "aerolog.co", true },
  { "aes256.ru", true },
  { "aeyoun.com", true },
  { "affiliateroyale.com", true },
  { "affinitysync.com", true },
  { "aficotroceni.ro", true },
  { "afp548.com", true },
  { "afrodigital.uk", true },
  { "afuh.de", true },
  { "agalaxyfarfaraway.co.uk", true },
  { "ageg.ca", true },
  { "agenda-loto.net", true },
  { "agevio.com", true },
  { "agonswim.com", true },
  { "agroline.by", true },
  { "agwa.name", true },
  { "ahd.com", true },
  { "ahmerjamilkhan.org", true },
  { "ahoyconference.com", true },
  { "ahwatukeefoothillsmontessori.com", true },
  { "ahxxm.com", true },
  { "aids.gov", true },
  { "aie.de", true },
  { "aiesecarad.ro", true },
  { "aikido-linz.at", true },
  { "aikido-wels.at", true },
  { "aircomms.com", true },
  { "airlea.com", true },
  { "airsoft.ch", true },
  { "aishnair.com", true },
  { "aiticon.com", true },
  { "aivd.lol", true },
  { "ajouin.com", true },
  { "akachanikuji.com", true },
  { "akelius.de", true },
  { "akhilindurti.com", true },
  { "akhras.at", true },
  { "akombakom.net", true },
  { "akostecki.de", true },
  { "akselinurmio.fi", true },
  { "aktiv-naturheilmittel.at", true },
  { "aktiv-naturheilmittel.ch", true },
  { "aktiv-naturheilmittel.de", true },
  { "aladdin.ie", true },
  { "aladdinschools.appspot.com", true },
  { "alainwolf.ch", true },
  { "alainwolf.net", true },
  { "alaninkenya.org", true },
  { "alanlee.net", true },
  { "alanrickmanflipstable.com", true },
  { "alaricfavier.eu", true },
  { "alastyr.com", true },
  { "albertopimienta.com", true },
  { "albion2.org", true },
  { "alcazaar.com", true },
  { "aldes.co.za", true },
  { "aleax.me", true },
  { "alecpap.com", true },
  { "alela.fr", true },
  { "alenan.org", true },
  { "alex-ross.co.uk", true },
  { "alexandra-schulze.de", true },
  { "alexandre.sh", true },
  { "alexbaker.org", true },
  { "alexgaynor.net", true },
  { "alexhaydock.co.uk", true },
  { "alexhd.de", true },
  { "alexismeza.com", true },
  { "alexmerkel.com", true },
  { "alexn.org", true },
  { "alexsexton.com", true },
  { "alexvetter.de", true },
  { "alexyang.me", true },
  { "alfredxing.com", true },
  { "alkami.com", true },
  { "alkamitech.com", true },
  { "all-subtitles.com", true },
  { "all4os.com", true },
  { "allbenjoy.de", true },
  { "allcarepharmacy.com", true },
  { "allinnote.com", true },
  { "allinonecyprus.com", true },
  { "alltheducks.com", true },
  { "allthethings.co.nz", true },
  { "allthingswild.co.uk", true },
  { "almeria.fr", true },
  { "alocato.com", true },
  { "alpca.org", true },
  { "alpha-force.net", true },
  { "alphalabs.xyz", true },
  { "alphassl.de", true },
  { "alphatrash.de", true },
  { "alt.org", true },
  { "altedirect.com", true },
  { "altesses.eu", true },
  { "altestore.com", true },
  { "altfire.ca", true },
  { "altonblom.com", true },
  { "alza.cz", true },
  { "alza.de", true },
  { "alza.sk", true },
  { "alzashop.com", true },
  { "am3.se", true },
  { "ama.ne.jp", true },
  { "amaforums.org", true },
  { "amateri.com", true },
  { "amavis.org", true },
  { "amazing-gaming.fr", true },
  { "ambiq.nl", true },
  { "amdouglas.com", true },
  { "amdouglas.uk", true },
  { "americanbio.com", true },
  { "amerigroup.com", true },
  { "amerimarkdirect.com", true },
  { "amisharingstuff.com", true },
  { "amishsecurity.com", true },
  { "amoory.com", false },
  { "amri.nl", true },
  { "anadoluefessk.org", true },
  { "anadoluefessporkulubu.org", true },
  { "anagra.ms", true },
  { "anakros.me", true },
  { "ancientkarma.com", true },
  { "anderslind.dk", true },
  { "andisadhdspot.com", true },
  { "andreaboero.it", true },
  { "andreas-kluge.eu", true },
  { "andreasfeusi.ch", true },
  { "andreaskluge.eu", true },
  { "andreasolsson.se", true },
  { "andreigec.net", true },
  { "andrewbroekman.com", true },
  { "andrewimeson.com", true },
  { "andrewmichaud.beer", true },
  { "andrewmichaud.com", true },
  { "andrewmichaud.me", true },
  { "andrewsun.com", true },
  { "andrewtebert.com", true },
  { "andrewvoce.com", true },
  { "andrewx.net", true },
  { "andreypopp.com", true },
  { "andymartin.cc", true },
  { "andyuk.org", true },
  { "anedot.com", true },
  { "anedot.xyz", true },
  { "anetaben.nl", true },
  { "anfsanchezo.me", true },
  { "anghami.com", true },
  { "anglictinatabor.cz", true },
  { "angrapa.ru", true },
  { "angristan.fr", true },
  { "angularjs.org", true },
  { "animalnet.de", false },
  { "anime.my", false },
  { "animesfusion.com.br", true },
  { "animesharp.com", true },
  { "aniplus.cf", true },
  { "aniplus.gq", true },
  { "aniplus.ml", true },
  { "anitaalbersen.nl", true },
  { "anitube-nocookie.ch", true },
  { "anitube.ch", true },
  { "ankakaak.com", true },
  { "ankarakart.com.tr", true },
  { "ankaraprofesyonelnakliyat.com", true },
  { "ankaraprofesyonelnakliyat.com.tr", true },
  { "ankaraprofesyonelwebtasarim.com", true },
  { "ankarauzmanlarnakliyat.com", true },
  { "annahmeschluss.de", true },
  { "annevankesteren.com", true },
  { "annevankesteren.nl", true },
  { "annevankesteren.org", true },
  { "annuaire-photographe.fr", true },
  { "anonboards.com", true },
  { "anoncom.net", true },
  { "anonym-surfen.de", true },
  { "anook.com", true },
  { "another.ch", true },
  { "ansdell.net", true },
  { "anthenor.co.uk", true },
  { "antipolygraph.org", true },
  { "antocom.com", true },
  { "antoniomarques.eu", true },
  { "anyprime.net", true },
  { "anyways.at", true },
  { "anzeiger.ag", true },
  { "ao2.it", true },
  { "aojf.fr", true },
  { "aopedeure.nl", true },
  { "aosus.org", true },
  { "apachehaus.de", false },
  { "apadvantage.com", true },
  { "apeasternpower.com", true },
  { "aperturesciencelabs.de", true },
  { "api.cloudflare.com", false },
  { "api.intercom.io", true },
  { "api.lookout.com", false },
  { "api.simple.com", false },
  { "api.xero.com", false },
  { "apis.google.com", true },
  { "apn-einstellungen.de", true },
  { "apnakliyat.com", true },
  { "aponow.de", true },
  { "aposke.com", true },
  { "app.lookout.com", false },
  { "app.manilla.com", true },
  { "app.recurly.com", true },
  { "app.simpletax.ca", false },
  { "app.yinxiang.com", false },
  { "appart.ninja", true },
  { "appartementhaus-badria.de", true },
  { "appengine.google.com", true },
  { "appharbor.com", true },
  { "apple-watch-zubehoer.de", true },
  { "applez.xyz", true },
  { "appmobile.io", true },
  { "approbo.com", true },
  { "approlys.fr", true },
  { "apps-for-fishing.com", true },
  { "apps.facebook.com", false },
  { "apps.fedoraproject.org", true },
  { "apps.stg.fedoraproject.org", true },
  { "appson.co.uk", true },
  { "appuro.com", true },
  { "aprsdroid.org", true },
  { "aprz.de", true },
  { "apstudynotes.org", true },
  { "aquilaguild.com", true },
  { "aradulconteaza.ro", true },
  { "aranycsillag.net", true },
  { "arbitrarion.com", true },
  { "arbitrary.ch", true },
  { "arboworks.com", true },
  { "arbu.eu", true },
  { "archlinux.de", true },
  { "areafiftylan.nl", true },
  { "areatrend.com", true },
  { "arendburgers.nl", true },
  { "argh.io", true },
  { "arguggi.co.uk", true },
  { "arima.co.ke", true },
  { "aristocrates.co", true },
  { "arivo.com.br", false },
  { "arjandejong.eu", true },
  { "arlen.io", true },
  { "armingrodon.de", true },
  { "armor.com", true },
  { "armory.consulting", true },
  { "armory.supplies", false },
  { "arnaudfeld.de", true },
  { "arnor.org", true },
  { "aroonchande.com", true },
  { "arrmaforum.com", true },
  { "art2web.net", true },
  { "artegusto.ru", true },
  { "arteseideias.com.pt", true },
  { "articaexports.com", true },
  { "artifex21.com", true },
  { "artifex21.fr", true },
  { "artmoney.com", true },
  { "artofwhere.com", true },
  { "artspac.es", true },
  { "arturkohut.com", true },
  { "arty.name", true },
  { "arvamus.eu", true },
  { "aryasenna.net", true },
  { "arzaroth.com", true },
  { "as200753.com", true },
  { "as200753.net", true },
  { "as9178.net", true },
  { "asandu.eu", true },
  { "asasuou.pw", true },
  { "aserver.co", true },
  { "ask.fedoraproject.org", true },
  { "ask.stg.fedoraproject.org", true },
  { "askfit.cz", true },
  { "askmagicconch.com", true },
  { "askwhy.cz", true },
  { "askwhy.eu", true },
  { "asm-x.com", true },
  { "aspargesgaarden.no", true },
  { "aspires.co.jp", true },
  { "ass.org.au", true },
  { "assdecoeur.org", true },
  { "assekuranzjobs.de", true },
  { "astengox.com", true },
  { "asun.co", true },
  { "at.search.yahoo.com", false },
  { "atbeckett.com", true },
  { "atc.io", true },
  { "atg.soy", true },
  { "atgseed.co.uk", true },
  { "atgseed.uk", true },
  { "ath0.org", true },
  { "athenelive.com", true },
  { "atishchenko.com", true },
  { "atisoft.com.tr", true },
  { "atisoft.net", true },
  { "atisoft.net.tr", true },
  { "atisoft.web.tr", true },
  { "atlantichomes.com.au", true },
  { "atlantischild.hu", true },
  { "atlassian.net", true },
  { "atletika.hu", true },
  { "atlex.nl", true },
  { "atolm.net", true },
  { "atop.io", true },
  { "atte.fi", true },
  { "attorney.org.il", true },
  { "aucubin.moe", true },
  { "audisto.com", true },
  { "auditmatrix.com", true },
  { "auf-feindgebiet.de", true },
  { "augustian-life.cz", true },
  { "augustiner-kantorei-erfurt.de", true },
  { "augustiner-kantorei.de", true },
  { "aulo.in", false },
  { "aunali1.com", true },
  { "aurainfosec.com", true },
  { "aurainfosec.com.au", true },
  { "auraredeye.com", true },
  { "auraredshield.com", true },
  { "ausnah.me", true },
  { "ausschreibungen-suedtirol.it", true },
  { "aussiecable.org", true },
  { "auth.adult", true },
  { "authentication.io", true },
  { "authint.com", true },
  { "auto-anleitung.de", true },
  { "autokovrik-diskont.ru", true },
  { "autoledky.sk", true },
  { "avacariu.me", true },
  { "avalon-island.ru", true },
  { "avantmfg.com", true },
  { "avarty.com", true },
  { "avastantivirus.ro", true },
  { "avec-ou-sans-ordonnance.fr", true },
  { "aviacao.pt", true },
  { "axka.com", false },
  { "axrec.de", true },
  { "aylak.com", true },
  { "azabani.com", true },
  { "azirevpn.com", true },
  { "azzag.co.uk", true },
  { "azzorti.com", true },
  { "b-root-force.de", true },
  { "b2and.com", false },
  { "b303.me", true },
  { "b3orion.com", true },
  { "baalsworld.de", true },
  { "babarkata.com", true },
  { "babelfisch.eu", true },
  { "baby-click.de", true },
  { "babybee.ie", true },
  { "babyfotograf-schweiz.ch", true },
  { "babysaying.me", true },
  { "bacchanallia.com", true },
  { "backeby.eu", true },
  { "backscattering.de", true },
  { "backschues.net", true },
  { "badcronjob.com", true },
  { "badges.fedoraproject.org", true },
  { "badges.stg.fedoraproject.org", true },
  { "badhusky.com", true },
  { "badkamergigant.com", true },
  { "badlink.org", true },
  { "baer.im", true },
  { "baer.one", true },
  { "baff.lu", true },
  { "bagelsbakery.com", true },
  { "bah.im", true },
  { "baiker.info", true },
  { "baiyangliu.com", true },
  { "bajic.ch", true },
  { "bakaweb.fr", true },
  { "balboa.io", true },
  { "balcan-underground.net", true },
  { "balikonos.cz", true },
  { "balkonien.org", true },
  { "ball.holdings", true },
  { "ballotapi.com", true },
  { "bam.com.au", false },
  { "bananabandy.com", true },
  { "bananium.fr", true },
  { "bandrcrafts.com", true },
  { "bank.simple.com", false },
  { "bankcardoffer.com", true },
  { "bankersonline.com", true },
  { "bankin.com", true },
  { "banqingdiao.com", true },
  { "baofengtech.com", true },
  { "barbaros.info", true },
  { "barbu.family", true },
  { "barcodeberlin.com", true },
  { "barcoderealty.com", true },
  { "bardiharborow.com", true },
  { "barely.sexy", true },
  { "barqo.co", true },
  { "barrelhead.org", true },
  { "barrut.me", true },
  { "barslecht.com", true },
  { "barslecht.nl", true },
  { "bartel.ws", true },
  { "bartlamboo.nl", true },
  { "baruch.me", true },
  { "bashcode.ninja", true },
  { "basnieuwenhuizen.nl", true },
  { "basnoslovno.com.ua", true },
  { "basnoslovno.ru", true },
  { "bassh.net", true },
  { "bastianstalder.ch", true },
  { "baud.ninja", true },
  { "bautied.de", true },
  { "bayden.com", true },
  { "bayrisch-fuer-anfaenger.de", true },
  { "bbdos.ru", true },
  { "bbnx.net", true },
  { "bccx.com", true },
  { "bcdonadio.com", true },
  { "bcheng.cf", true },
  { "bckp.de", true },
  { "bcrook.com", false },
  { "bcsytv.com", true },
  { "bcvps.com", true },
  { "bdikaros-network.net", true },
  { "beachi.es", true },
  { "beaglewatch.com", true },
  { "beamitapp.com", true },
  { "beanjuice.me", true },
  { "beans-one.com", false },
  { "beardydave.com", true },
  { "beastowner.li", true },
  { "beautykat.ru", true },
  { "bebesurdoue.com", true },
  { "bedabox.com", true },
  { "bedeta.de", true },
  { "bedreid.dk", true },
  { "beeksnetwork.nl", true },
  { "beercandle.com", true },
  { "beframed.ch", true },
  { "beholdthehurricane.com", true },
  { "beier.io", true },
  { "beinad.com", true },
  { "beinad.ru", true },
  { "belcompany.nl", true },
  { "believablebook.com", true },
  { "bely-mishka.by", true },
  { "ben-energy.com", false },
  { "ben.ninja", true },
  { "benchling.com", true },
  { "bendechrai.com", true },
  { "bendemaree.com", true },
  { "bendingtheending.com", true },
  { "beneathvt.com", true },
  { "beneffy.com", true },
  { "benhartmann.de", true },
  { "benjamin.pe", true },
  { "benjamins.com", true },
  { "benk.press", true },
  { "benmatthews.com.au", true },
  { "benni1.eu", true },
  { "benno.frl", true },
  { "benschnarr.com", true },
  { "bentertain.de", true },
  { "bentley.link", true },
  { "bentrask.com", true },
  { "beranovi.com", true },
  { "bergstoneware.com", false },
  { "berlinleaks.com", true },
  { "bermeitinger.eu", true },
  { "berr.yt", true },
  { "berra.se", true },
  { "berst.cz", true },
  { "berthabailey.com", true },
  { "beryl.net", true },
  { "bespokestraps.com", true },
  { "best-wedding-quotes.com", true },
  { "besthost.cz", true },
  { "betaclean.fr", true },
  { "betafive.net", true },
  { "betaworx.de", true },
  { "betaworx.eu", true },
  { "betcafearena.ro", true },
  { "betonmoney.com", true },
  { "betpamm.com", true },
  { "betplanning.it", true },
  { "bettercrypto.org", true },
  { "betterhelp.com", true },
  { "bettrlifeapp.com", true },
  { "bettween.com", true },
  { "betulashop.ch", true },
  { "bevinsco.org", true },
  { "bexit-hosting.nl", true },
  { "bexit-security.eu", true },
  { "bexit-security.nl", true },
  { "bexit.nl", true },
  { "bexithosting.nl", true },
  { "beyondpricing.com", true },
  { "bfear.com", true },
  { "bfelob.gov", true },
  { "bfi.wien", true },
  { "bfw-online.de", true },
  { "bgmn.net", true },
  { "bgneuesheim.de", true },
  { "bhatia.at", true },
  { "bhuntr.com", true },
  { "biasmath.es", true },
  { "biathloncup.ru", true },
  { "bible.ru", true },
  { "bibleonline.ru", true },
  { "biddl.com", true },
  { "bieberium.de", true },
  { "bienici.com", true },
  { "bierbaumer.net", true },
  { "big-andy.co.uk", true },
  { "bigbluedoor.net", true },
  { "bigbrownpromotions.com.au", true },
  { "bigclassaction.com", true },
  { "biguixhe.net", true },
  { "bike-shack.com", true },
  { "bikiniseli.com", true },
  { "bildermachr.de", true },
  { "bildiri.ci", true },
  { "bildschirmflackern.de", true },
  { "billaud.eu.org", true },
  { "billigssl.dk", true },
  { "billin.net", true },
  { "billpro.com", true },
  { "bilrom.com", true },
  { "bimbo.com", true },
  { "bimbobakeriesusa.com", true },
  { "binaryabstraction.com", true },
  { "binaryevolved.com", true },
  { "biofam.ru", true },
  { "bionicspirit.com", true },
  { "biosignalanalytics.com", true },
  { "biosphere.cc", true },
  { "biou.me", true },
  { "bip.gov.sa", true },
  { "birdfeeder.online", true },
  { "birkman.com", true },
  { "birminghamsunset.com", true },
  { "bit-sentinel.com", true },
  { "bit.voyage", true },
  { "bit8.com", true },
  { "bitbucket.org", false },
  { "bitchan.it", true },
  { "bitcoin.asia", true },
  { "bitcoin.ch", true },
  { "bitcoin.co.nz", true },
  { "bitcoin.de", true },
  { "bitcoin.im", true },
  { "bitcoin.info", true },
  { "bitcoin.us", true },
  { "bitcoinbitcoin.com", true },
  { "bitcoinhk.org", true },
  { "bitcoinprivacy.net", true },
  { "bitcoinworld.me", true },
  { "bitcoinx.ro", true },
  { "bitfactory.ws", true },
  { "bitgo.com", true },
  { "bitlish.com", true },
  { "bitmex.com", true },
  { "bitminter.com", true },
  { "bitmon.net", true },
  { "bitnet.io", true },
  { "bitok.com", true },
  { "bitpod.de", true },
  { "bitshaker.net", true },
  { "bittersweetcandybowl.com", true },
  { "bizcms.com", true },
  { "bjornhelmersson.se", true },
  { "bjornjohansen.no", true },
  { "bl4ckb0x.com", true },
  { "bl4ckb0x.de", true },
  { "bl4ckb0x.info", true },
  { "bl4ckb0x.net", true },
  { "bl4ckb0x.org", true },
  { "blablacar.co.uk", true },
  { "blablacar.com", true },
  { "blablacar.com.tr", true },
  { "blablacar.com.ua", true },
  { "blablacar.de", true },
  { "blablacar.es", true },
  { "blablacar.fr", true },
  { "blablacar.hr", true },
  { "blablacar.hu", true },
  { "blablacar.in", true },
  { "blablacar.it", true },
  { "blablacar.mx", true },
  { "blablacar.nl", true },
  { "blablacar.pl", true },
  { "blablacar.pt", true },
  { "blablacar.ro", true },
  { "blablacar.rs", true },
  { "blablacar.ru", true },
  { "blackberrycentral.com", true },
  { "blackburn.link", true },
  { "blackdesertsp.com", true },
  { "blackdragoninc.org", true },
  { "blackhelicopters.net", true },
  { "blackpayment.ru", true },
  { "blaise.io", true },
  { "blastersklan.com", true },
  { "blauwwit.be", true },
  { "blazor.nl", true },
  { "blendle.com", true },
  { "blendle.nl", true },
  { "blessnet.jp", true },
  { "blha303.com.au", true },
  { "blindsexdate.nl", true },
  { "blinkenlight.co.uk", true },
  { "blinkenlight.com.au", true },
  { "blmiller.com", true },
  { "blockchain.info", true },
  { "blocksatz-medien.de", true },
  { "bloemendal.me", true },
  { "blog.cyveillance.com", true },
  { "blog.gov.uk", true },
  { "blog.gparent.org", true },
  { "blog.linode.com", false },
  { "blog.torproject.org", false },
  { "blognone.com", true },
  { "blogreen.org", true },
  { "blubbablasen.de", true },
  { "blue42.net", true },
  { "bluechilli.com", true },
  { "bluemosh.com", true },
  { "bluescloud.xyz", true },
  { "blumenfeldart.com", true },
  { "blumiges-fischbachtal.de", true },
  { "blupig.net", true },
  { "blurringexistence.net", true },
  { "bluserv.net", true },
  { "bm-trading.nl", true },
  { "bmoattachments.org", true },
  { "bmone.net", true },
  { "bnhlibrary.com", true },
  { "bobiji.com", true },
  { "bockenauer.at", true },
  { "bodyblog.nl", true },
  { "boeddhashop.nl", true },
  { "bohramt.de", true },
  { "boilesen.com", true },
  { "boiseonlinemall.com", true },
  { "bokeyy.com", true },
  { "bonapp.restaurant", true },
  { "bondskampeerder.nl", true },
  { "bonifacius.be", true },
  { "bonobo.cz", true },
  { "bookmein.in", true },
  { "bookofraonlinecasinos.com", true },
  { "bootjp.me", true },
  { "borchers-media.de", true },
  { "boringsecurity.net", true },
  { "boris.one", false },
  { "borisbesemer.com", true },
  { "borrelioz.com", true },
  { "borysek.net", true },
  { "bougeret.fr", true },
  { "bouncourseplanner.net", true },
  { "bouncyball.eu", false },
  { "bouncyballs.org", true },
  { "bowling.com", true },
  { "bownty.dk", true },
  { "boxcryptor.com", true },
  { "boxintense.com", true },
  { "boypoint.de", true },
  { "bpadvisors.eu", true },
  { "bpastudies.org", true },
  { "bqtoolbox.com", true },
  { "br.search.yahoo.com", false },
  { "bradbrockmeyer.com", true },
  { "bradkovach.com", true },
  { "brage.info", true },
  { "brainfork.ml", true },
  { "brainster.co", false },
  { "braintreegateway.com", true },
  { "brakemanpro.com", true },
  { "brakstad.org", true },
  { "bramvanaken.be", true },
  { "bran.cc", true },
  { "bran.land", true },
  { "branchzero.com", true },
  { "brandbuilderwebsites.com", true },
  { "brandon.so", true },
  { "brandred.net", true },
  { "brasalcosmetics.com", true },
  { "bratteng.me", true },
  { "bratteng.xyz", true },
  { "brd.ro", true },
  { "breeswish.org", true },
  { "bregnedalsystems.dk", true },
  { "breitbild-beamer.de", true },
  { "brianmwaters.net", true },
  { "brickoo.com", true },
  { "bridholm.se", true },
  { "brightstarkids.co.uk", false },
  { "brightstarkids.com.au", false },
  { "brightstarkids.net", false },
  { "brightstarkids.sg", false },
  { "brks.xyz", true },
  { "broadsheet.com.au", true },
  { "broersma.com", true },
  { "broeselei.at", true },
  { "bronevichok.ru", true },
  { "brossman.it", true },
  { "brossmanit.com", true },
  { "brownfieldstsc.org", true },
  { "brrr.fr", true },
  { "brunix.net", true },
  { "brunoramos.com", true },
  { "brunoramos.org", true },
  { "brunosouza.org", true },
  { "bryanquigley.com", true },
  { "bryn.xyz", true },
  { "bsalyzer.com", true },
  { "bsdtips.com", true },
  { "bsidessf.com", true },
  { "bsklabels.com", false },
  { "bsquared.org", true },
  { "btsoft.eu", true },
  { "buck.com", true },
  { "buddhistische-weisheiten.org", true },
  { "budgetalk.com", true },
  { "budskap.eu", true },
  { "buettgens.net", true },
  { "bugcrowd.com", true },
  { "bugginslab.co.uk", true },
  { "bugs.chromium.org", true },
  { "bugtrack.io", true },
  { "bugzil.la", true },
  { "bugzilla.mozilla.org", true },
  { "buiko.com", true },
  { "build.chromium.org", false },
  { "buildkite.com", true },
  { "bukkenfan.jp", true },
  { "bulktrade.de", true },
  { "bullbits.com", true },
  { "bulldog-hosting.de", true },
  { "bulmafox.com", true },
  { "bunbun.be", true },
  { "bund-von-theramore.de", true },
  { "bundaberg.com", true },
  { "bunsenlabs.org", true },
  { "bureaubolster.nl", true },
  { "burningcrash.de", true },
  { "burningflipside.com", true },
  { "burnworks.com", true },
  { "burtrum.me", true },
  { "burtrum.org", true },
  { "burzmali.com", true },
  { "business.facebook.com", false },
  { "business.lookout.com", false },
  { "businessfurs.info", true },
  { "businesshosting.nl", true },
  { "busold.ws", true },
  { "bustimes.org", true },
  { "butchersworkshop.com", true },
  { "buybaby.eu", true },
  { "buyinginvestmentproperty.com", true },
  { "buzzconcert.com", true },
  { "buzzconf.io", true },
  { "bvalle.com", true },
  { "bwcscorecard.org", true },
  { "bwear4all.de", true },
  { "bygningsregistrering.dk", true },
  { "bypro.xyz", true },
  { "byronwade.com", true },
  { "byrtz.de", true },
  { "bytejail.com", true },
  { "bytesofcode.de", true },
  { "bytesystems.com", true },
  { "bzv-fr.eu", true },
  { "c.cc", true },
  { "c16t.uk", true },
  { "c1yd3i.me", true },
  { "ca.gparent.org", true },
  { "ca.search.yahoo.com", false },
  { "cabarave.com", true },
  { "cabsites.com", true },
  { "cabusar.fr", true },
  { "cacaolalina.com", true },
  { "cackette.com", true },
  { "cadoth.net", true },
  { "caesarkabalan.com", true },
  { "caesreon.com", true },
  { "cafe-scientifique.org.ec", true },
  { "caffeinatedcode.com", true },
  { "cais.de", true },
  { "caizx.com", true },
  { "caja-pdf.es", true },
  { "cajunuk.co.uk", true },
  { "calaborlawnews.com", true },
  { "calculator-imt.com", true },
  { "calebmorris.com", true },
  { "calgoty.com", true },
  { "calibso.net", true },
  { "calix.com", true },
  { "call.me", false },
  { "callsigns.ca", true },
  { "calomel.org", true },
  { "calories.org", true },
  { "calvin.me", true },
  { "calvinallen.net", true },
  { "cambridgeanalytica.org", true },
  { "camconn.cc", true },
  { "camolist.com", true },
  { "camperverzekerd.nl", true },
  { "campfourpaws.com", true },
  { "campus-finance.com", true },
  { "canadalife.de", true },
  { "canadasmotorcycle.ca", true },
  { "canadiangamblingchoice.com", false },
  { "canarymod.net", true },
  { "cando.eu", true },
  { "candratech.com", true },
  { "canhazip.com", true },
  { "cannyfoxx.me", true },
  { "canyonshoa.com", true },
  { "canyoupwn.me", true },
  { "cao.gov", true },
  { "cao.la", true },
  { "capitalquadatv.org.nz", true },
  { "capitaltg.com", true },
  { "capper.de", true },
  { "capriccio.to", true },
  { "captchatheprize.com", true },
  { "carck.co.uk", true },
  { "cardrecovery.fr", true },
  { "cardstream.com", true },
  { "caremad.io", true },
  { "carey.li", true },
  { "carezone.com", false },
  { "cargobay.net", true },
  { "carlosalves.info", true },
  { "carnaticalifornia.com", true },
  { "carnildo.com", true },
  { "carsforbackpackers.com", true },
  { "carthage.edu", true },
  { "cartouche24.eu", true },
  { "cartucce24.it", true },
  { "casa-su.casa", true },
  { "cashlink.io", true },
  { "casinostest.com", true },
  { "casperpanel.com", true },
  { "cat-box.de", true },
  { "catinmay.com", true },
  { "cativa.net", true },
  { "catnapstudios.com", true },
  { "catnet.dk", false },
  { "catsmagic.pp.ua", true },
  { "cattivo.nl", true },
  { "cavac.at", true },
  { "caveclan.org", true },
  { "cavedroid.xyz", true },
  { "cbhq.net", true },
  { "ccayearbook.com", true },
  { "ccblog.de", true },
  { "ccja.ro", false },
  { "ccsys.com", true },
  { "cdlcenter.com", true },
  { "cdnb.co", true },
  { "cdt.org", true },
  { "cecipu.gob.cl", true },
  { "cejhon.cz", true },
  { "celec.gob.ec", true },
  { "celti.name", true },
  { "cementscience.com", true },
  { "centennialrewards.com", true },
  { "centerpereezd.ru", false },
  { "centillien.com", true },
  { "centralpoint.be", true },
  { "centralpoint.nl", true },
  { "centralstatecu.org", true },
  { "centricweb.com", true },
  { "centrobill.com", true },
  { "ceopedia.org", true },
  { "cerastar.com", true },
  { "cerebelo.info", true },
  { "cerfrance.fr", true },
  { "certcenter.com", true },
  { "certcenter.de", true },
  { "certible.com", true },
  { "certifi.io", true },
  { "certly.io", true },
  { "cervejista.com", true },
  { "cesal.net", true },
  { "cesobaly.cz", true },
  { "ceu.edu", true },
  { "cevrimici.com", true },
  { "cfa.gov", true },
  { "cfcnexus.org", true },
  { "cfetengineering.com", true },
  { "cfh.com", true },
  { "cfo.gov", true },
  { "cgbilling.com", true },
  { "cgtx.us", true },
  { "ch.search.yahoo.com", false },
  { "chahub.com", true },
  { "chainmonitor.com", true },
  { "chaletmanager.com", true },
  { "chamilo.org", true },
  { "changetip.com", true },
  { "chaos.fail", true },
  { "chaoschemnitz.de", true },
  { "chaosdorf.de", true },
  { "chaoswebs.net", true },
  { "charge.co", true },
  { "charlierogers.com", true },
  { "charmander.me", true },
  { "chatbot.me", true },
  { "chatear.social", true },
  { "chaulootz.com", true },
  { "chaz6.com", true },
  { "chazay.net", true },
  { "chcemvediet.sk", true },
  { "chch.it", true },
  { "cheapgeekts.com", false },
  { "check.torproject.org", false },
  { "checkout.google.com", true },
  { "checktype.com", true },
  { "checkyourmath.com", true },
  { "cheerflow.com", true },
  { "cheesetart.my", false },
  { "chenapartment.com", true },
  { "chepaofen.com", true },
  { "chfr.search.yahoo.com", false },
  { "chic-leather.com", true },
  { "chimeratool.com", true },
  { "chiphell.com", true },
  { "chippy.ch", false },
  { "chiralsoftware.com", true },
  { "chireiden.net", true },
  { "chiru.no", true },
  { "chit.search.yahoo.com", false },
  { "chloe.re", true },
  { "chocotough.nl", true },
  { "choosemypc.net", true },
  { "chorpinkpoemps.de", true },
  { "chrisbrown.id.au", true },
  { "chrisirwin.ca", true },
  { "chrisjean.com", true },
  { "chriskyrouac.com", true },
  { "chrismckee.co.uk", true },
  { "christiaanconover.com", true },
  { "christiaandruif.nl", true },
  { "christianbro.gq", true },
  { "christianliebel.com", true },
  { "christophheich.me", true },
  { "chrisupjohn.com", true },
  { "chriswarrick.com", true },
  { "chriswells.io", true },
  { "chrome-devtools-frontend.appspot.com", true },
  { "chrome.com", false },
  { "chrome.google.com", true },
  { "chromebooksforwork.com", true },
  { "chromiumcodereview.appspot.com", false },
  { "chrst.ph", true },
  { "chuckame.fr", true },
  { "chulado.com", true },
  { "chun.pro", true },
  { "ciat.no", true },
  { "cidbot.com", true },
  { "cienbeaute-lidl.fr", true },
  { "cig-dem.com", true },
  { "cigarblogs.net", true },
  { "cigarterminal.com", true },
  { "cimalando.eu", true },
  { "cimballa.com", true },
  { "cinefilzonen.se", true },
  { "cintdirect.com", true },
  { "cio.gov", true },
  { "cipherli.st", true },
  { "cirfi.com", true },
  { "cirope.com", true },
  { "cirrus0.de", true },
  { "ciscodude.net", true },
  { "ciscommerce.net", true },
  { "cittadesign.com", true },
  { "citya.com", true },
  { "ciubotaru.tk", true },
  { "ckleemann.de", true },
  { "cklie.de", true },
  { "ckliemann.com", true },
  { "ckliemann.net", true },
  { "cktennis.com", true },
  { "cl.search.yahoo.com", false },
  { "claimconnect.us", true },
  { "clan-ww.com", true },
  { "clanthor.com", true },
  { "clapping-rhymes.com", true },
  { "claralabs.com", true },
  { "clarkeaward.com", true },
  { "classdojo.com", true },
  { "classicday.nl", true },
  { "classicspublishing.com", true },
  { "clawe.de", true },
  { "cldly.com", true },
  { "clearkonjac.com", true },
  { "clearviewwealthprojector.com.au", true },
  { "clerkendweller.uk", true },
  { "clevertarget.ru", true },
  { "clevisto.com", true },
  { "clickclickphish.com", true },
  { "clickenergy.com.au", true },
  { "clickforclever.com", true },
  { "clickphish.com", true },
  { "climateinteractive.org", true },
  { "clintonbloodworth.com", true },
  { "clintwilson.technology", true },
  { "clipped4u.com", true },
  { "clmde.de", true },
  { "clockcaster.com", true },
  { "clockworksms.com", true },
  { "cloud-project.com", true },
  { "cloud.google.com", true },
  { "cloud.wtf", true },
  { "cloudapi.vc", true },
  { "cloudbolin.es", true },
  { "cloudflareonazure.com", true },
  { "cloudily.com", true },
  { "cloudimag.es", true },
  { "cloudmigrator365.com", true },
  { "cloudns.com.au", true },
  { "cloudpagesforwork.com", true },
  { "cloudpebble.net", true },
  { "cloudsecurityalliance.org", true },
  { "cloudspace-analytics.com", true },
  { "cloudstoragemaus.com", true },
  { "cloudstorm.me", true },
  { "cloudstrike.co", true },
  { "cloudup.com", true },
  { "clu-in.org", true },
  { "clubmate.rocks", true },
  { "clubmini.jp", true },
  { "clvrwebdesign.com", true },
  { "clycat.ru", true },
  { "clywedogmaths.co.uk", true },
  { "cmacacias.ch", true },
  { "cmdline.org", true },
  { "cmlachapelle.ch", true },
  { "cmlancy.ch", true },
  { "cmplainpalais.ch", true },
  { "cmsbattle.com", true },
  { "cmscafe.ru", true },
  { "cnam.net", true },
  { "cnlic.com", true },
  { "co.search.yahoo.com", false },
  { "co50.com", true },
  { "cobalt.io", false },
  { "cocaine.ninja", true },
  { "cocker.cc", false },
  { "cocoaheads.at", true },
  { "codabix.com", true },
  { "codabix.de", true },
  { "codabix.net", true },
  { "code-poets.co.uk", true },
  { "code.facebook.com", false },
  { "code.fm", true },
  { "code.google.com", true },
  { "code67.com", true },
  { "codeforce.io", true },
  { "codelayer.ca", true },
  { "codeplay.org", true },
  { "codepoints.net", true },
  { "codepref.com", true },
  { "codepult.com", true },
  { "codepx.com", true },
  { "codereview.appspot.com", false },
  { "codereview.chromium.org", false },
  { "codeux.com", true },
  { "codewild.de", true },
  { "codewiththepros.org", true },
  { "codingforspeed.com", true },
  { "codyevanscomputer.com", true },
  { "coffee-mamenoki.jp", true },
  { "cogent.cc", true },
  { "cogumelosmagicos.org", true },
  { "coiffeurschnittstelle.ch", true },
  { "coinapult.com", true },
  { "coinbase.com", true },
  { "coindam.com", false },
  { "coinessa.com", true },
  { "cojo.eu", true },
  { "coldawn.com", true },
  { "coldfff.com", true },
  { "coldhak.ca", true },
  { "collabornation.net", true },
  { "collies.eu", true },
  { "collinmbarrett.com", true },
  { "collinsartworks.com", true },
  { "colognegaming.net", true },
  { "coloradocomputernetworking.net", true },
  { "coloringnotebook.com", true },
  { "colorlib.com", true },
  { "com.cc", true },
  { "comarkinstruments.net", true },
  { "combatshield.cz", true },
  { "comdurav.com", true },
  { "comercialtrading.eu", true },
  { "comfortticket.de", true },
  { "comhack.com", true },
  { "comicspines.com", true },
  { "comitesaustria.at", true },
  { "comiteshopping.com", true },
  { "commencepayments.com", true },
  { "comodo.nl", true },
  { "compalytics.com", true },
  { "comparamejor.com", true },
  { "compareandrecycle.co.uk", true },
  { "compareinsurance.com.au", true },
  { "comparejewelleryprices.co.uk", true },
  { "comparetravelinsurance.com.au", true },
  { "compeuphoria.com", true },
  { "compiledworks.com", true },
  { "completionist.audio", true },
  { "completionist.me", true },
  { "compucorner.com.mx", true },
  { "compucorner.mx", true },
  { "compuscan.co.za", true },
  { "computeremergency.com.au", false },
  { "comssa.org.au", true },
  { "concentrade.de", true },
  { "config.schokokeks.org", false },
  { "conformal.com", true },
  { "connect.ua", false },
  { "connectingconcepts.com", true },
  { "connext.de", true },
  { "conrad-kostecki.de", true },
  { "consciousandglamorous.com", true },
  { "consciousbrand.co", true },
  { "console.support", true },
  { "consonare.de", true },
  { "constructdigital.net", true },
  { "constructionjobs.com", true },
  { "consul.io", true },
  { "consumersentinel.gov", true },
  { "contarkos.xyz", true },
  { "content-api-dev.azurewebsites.net", true },
  { "continuumgaming.com", false },
  { "contributor.google.com", true },
  { "controlcenter.gigahost.dk", true },
  { "conversiones.com", true },
  { "convert.zone", true },
  { "converter.ml", true },
  { "cookinglife.nl", false },
  { "cookmedical.com", false },
  { "cool110.tk", true },
  { "coolaj86.com", true },
  { "coopens.com", true },
  { "coore.jp", true },
  { "copperhead.co", true },
  { "cor-ser.es", true },
  { "coralproject.net", true },
  { "core.mx", true },
  { "core4system.de", true },
  { "coreless-stretchfilm.com", true },
  { "cornercircle.co.uk", true },
  { "coronelpicanha.com.br", true },
  { "corruption-mc.net", true },
  { "corruption-rsps.net", true },
  { "corruption-server.net", true },
  { "cortexitrecruitment.com", true },
  { "coryadum.com", true },
  { "costablancavoorjou.com", true },
  { "cotonea.de", true },
  { "coughlan.de", true },
  { "count.sh", true },
  { "countermail.com", true },
  { "countybankdel.com", true },
  { "couragewhispers.ca", true },
  { "coursera.org", true },
  { "courtlistener.com", true },
  { "covenantoftheriver.org", true },
  { "coverduck.ru", true },
  { "covoiturage.fr", false },
  { "cowboyim.com", true },
  { "cozmaadrian.ro", true },
  { "cpvmatch.eu", true },
  { "cqchome.com", true },
  { "cracker.in.th", true },
  { "crackingking.com", false },
  { "cradlepointecm.com", true },
  { "craftbeerbarn.co.uk", true },
  { "craftinginredlipstick.com", true },
  { "cravelyrics.com", true },
  { "crazydomains.ae", true },
  { "crazydomains.co.nz", true },
  { "crazydomains.co.uk", true },
  { "crazydomains.com.au", true },
  { "crazydomains.in", true },
  { "crazyhotseeds.com", true },
  { "crbug.com", false },
  { "creditkarma.com", true },
  { "creep.im", true },
  { "crendontech.com", true },
  { "crepererum.net", true },
  { "crestasantos.com", true },
  { "crestoncottage.com", true },
  { "criena.net", false },
  { "crimson.no", true },
  { "critical.today", true },
  { "criticalaim.com", true },
  { "crizk.com", true },
  { "crl-autos.com", true },
  { "crm.onlime.ch", false },
  { "crosscom.ch", true },
  { "crossfitblackwater.com", true },
  { "crosssec.com", true },
  { "crow.tw", true },
  { "crowdjuris.com", true },
  { "crowdsupply.com", true },
  { "crudysql.com", true },
  { "crute.me", true },
  { "cruzr.xyz", true },
  { "crypt.guru", true },
  { "cryptify.eu", true },
  { "crypto.graphics", true },
  { "cryptobells.com", false },
  { "cryptobin.co", true },
  { "cryptobin.org", true },
  { "cryptocon.org", true },
  { "cryptography.io", true },
  { "cryptoisnotacrime.org", true },
  { "cryptolab.pro", true },
  { "cryptoparty.at", true },
  { "cryptoparty.dk", true },
  { "cryptopartyatx.org", true },
  { "cryptopartyutah.org", true },
  { "cryptopush.com", true },
  { "cryptoseb.pw", true },
  { "crystalchandelierservices.com", true },
  { "crystalclassics.co.uk", true },
  { "csacongress.org", true },
  { "csapak.com", true },
  { "cselzer.com", true },
  { "csfs.org.uk", true },
  { "csgokings.eu", true },
  { "csokolade.hu", true },
  { "cspbuilder.info", true },
  { "cspvalidator.org", true },
  { "cssu.in", true },
  { "csuw.net", true },
  { "csvape.com", true },
  { "cthomas.work", true },
  { "cthulhuden.com", true },
  { "ctns.de", true },
  { "ctoforhire.com.au", true },
  { "cube.de", true },
  { "cubewano.com", true },
  { "cubua.com", true },
  { "cuibonobo.com", true },
  { "cuisinezest.com", true },
  { "culinae.nl", true },
  { "cupcake.io", true },
  { "cupcake.is", true },
  { "curiosity-driven.org", true },
  { "curlybracket.co.uk", true },
  { "curlyroots.com", true },
  { "curroapp.com", true },
  { "curtacircuitos.com.br", false },
  { "curveweb.co.uk", true },
  { "custe.rs", true },
  { "custodyxchange.com", true },
  { "customd.com", true },
  { "cutorrent.com", true },
  { "cuvva.co", true },
  { "cvjm-memmingen.de", true },
  { "cvmu.jp", true },
  { "cvr.dk", true },
  { "cvsoftub.com", true },
  { "cvursache.com", true },
  { "cwagner.me", true },
  { "cyanogenmod.xxx", true },
  { "cyberfrancais.ro", true },
  { "cyberianhusky.com", true },
  { "cyberkov.com", true },
  { "cyberoptic.de", true },
  { "cyberpunk.ca", true },
  { "cybersecuritychallenge.be", true },
  { "cybershambles.com", true },
  { "cybozu.com", true },
  { "cybozulive.com", true },
  { "cycleluxembourg.lu", true },
  { "cydia-search.io", true },
  { "cygnius.net", true },
  { "cyon.ch", true },
  { "cyph.com", true },
  { "cyph.im", true },
  { "cyph.video", true },
  { "cyphertite.com", true },
  { "cyprus-company-service.com", true },
  { "czakey.net", true },
  { "czbix.com", true },
  { "czk.mk", true },
  { "czlx.co", true },
  { "d-designerin.de", true },
  { "d3xt3r01.tk", true },
  { "d42.no", true },
  { "dachb0den.net", true },
  { "dadons-laserdiscs.com", true },
  { "daduke.org", true },
  { "daemon.xin", true },
  { "dailyenglishchallenge.com", true },
  { "daimadi.com", true },
  { "dairyshrine.org", true },
  { "dakrib.net", true },
  { "dale-electric.com", true },
  { "dalfiume.it", true },
  { "dalingk.co", true },
  { "dallmeier.net", true },
  { "danaketh.com", true },
  { "daniel-ruf.de", true },
  { "danielalvarez.net", true },
  { "danielcowie.me", true },
  { "danieltollot.de", true },
  { "danielverlaan.nl", true },
  { "danjesensky.com", true },
  { "dank.ninja", true },
  { "dankim.de", true },
  { "dannyrohde.de", true },
  { "danonsecurity.com", true },
  { "danpiel.net", false },
  { "danrl.de", true },
  { "danskoferie.dk", true },
  { "danw.io", true },
  { "daphne.informatik.uni-freiburg.de", true },
  { "daplie.com", true },
  { "darchoods.net", false },
  { "dargasia.is", true },
  { "dario.im", true },
  { "darioturchetti.me", true },
  { "dark-x.cf", true },
  { "darkag.ovh", true },
  { "darkdestiny.ch", true },
  { "darkengine.io", true },
  { "darkhole.cn", true },
  { "darkkeepers.dk", true },
  { "darknebula.space", false },
  { "darknode.in", true },
  { "darkpony.ru", true },
  { "darkserver.fedoraproject.org", true },
  { "darkserver.stg.fedoraproject.org", true },
  { "darkshop.nl", true },
  { "darkside.re", true },
  { "darksideof.it", true },
  { "darlo.co.uk", true },
  { "darom.jp", true },
  { "darrenm.net", true },
  { "darwinkel.net", true },
  { "dash-board.jp", false },
  { "dash.rocks", true },
  { "dashboard.yt", true },
  { "data-abundance.com", true },
  { "data.haus", true },
  { "data.qld.gov.au", false },
  { "data102.com", true },
  { "datacalle.com", true },
  { "datacandy.com", true },
  { "datapun.ch", true },
  { "dataretention.solutions", true },
  { "datascience.cafe", true },
  { "datasharesystem.com", true },
  { "datasnitch.co.uk", true },
  { "datatekniikka.com", false },
  { "datatekniikka.fi", false },
  { "dateno1.com", false },
  { "datorb.com", false },
  { "datortipsen.se", true },
  { "datsound.ru", true },
  { "daveoc64.co.uk", true },
  { "davevelopment.net", true },
  { "david-schiffmann.de", true },
  { "david.kitchen", true },
  { "davidandersson.se", true },
  { "davidgow.net", true },
  { "davidgrudl.com", true },
  { "davidlyness.com", true },
  { "davidmcevoy.org.uk", true },
  { "davidmessenger.co.uk", true },
  { "davidnoren.com", true },
  { "davidreinhardt.de", true },
  { "davidscherzer.at", true },
  { "davisroi.com", true },
  { "daylightpirates.org", true },
  { "dbgamestudio.com", true },
  { "dbmteam.com", true },
  { "dbx.ovh", true },
  { "dc585.info", true },
  { "dccode.gov", true },
  { "dcpower.eu", true },
  { "ddatsh.com", true },
  { "dden.ca", false },
  { "ddhosted.com", true },
  { "de-medici.nl", true },
  { "de-spil.be", true },
  { "de.search.yahoo.com", false },
  { "deadbeef.ninja", true },
  { "dealbanana.com", true },
  { "dealbanana.it", true },
  { "dealcruiser.nl", true },
  { "dealpass.no", true },
  { "deanmorgan.org", true },
  { "decafu.co", true },
  { "decoder.link", true },
  { "decomplify.com", true },
  { "dedeo.tk", true },
  { "dedicatutiempo.es", true },
  { "dedimax.de", true },
  { "dedmorozrzn.ru", true },
  { "dee.pe", true },
  { "deepbluecrafting.co.uk", true },
  { "deepcovelabs.net", true },
  { "deeprecce.com", true },
  { "deepserve.info", true },
  { "deer.team", true },
  { "defcon.org", true },
  { "degeberg.com", true },
  { "degroetenvanrosaline.nl", true },
  { "deight.co", true },
  { "deinballon.de", true },
  { "dekasan.ru", true },
  { "delfic.org", true },
  { "deliciisanatoase.ro", true },
  { "deliverance.co.uk", false },
  { "dementiapraecox.de", true },
  { "demo.swedbank.se", true },
  { "democracy.io", true },
  { "democracychronicles.com", true },
  { "demomanca.com", true },
  { "demuzere.be", true },
  { "demuzere.com", true },
  { "demuzere.eu", true },
  { "demuzere.net", true },
  { "denh.am", true },
  { "denisjean.fr", true },
  { "dennisdoes.net", true },
  { "denniskoot.nl", true },
  { "dennogumi.org", true },
  { "dentistglasgow.com", true },
  { "denverprophit.us", true },
  { "depechemode-live.com", true },
  { "dequehablamos.es", true },
  { "dereferenced.net", true },
  { "derhil.de", true },
  { "derp.army", true },
  { "derreichesack.com", true },
  { "dersoundhunter.de", true },
  { "derwolfe.net", true },
  { "desmaakvanplanten.be", true },
  { "destinationbijoux.fr", true },
  { "detectify.com", false },
  { "detector.exposed", true },
  { "detoxsinutritie.ro", true },
  { "detteflies.com", true },
  { "detutorial.com", true },
  { "deuxsolutions.com", true },
  { "devb.nl", true },
  { "devdoodle.net", true },
  { "developer.mydigipass.com", false },
  { "developers.facebook.com", false },
  { "developfx.com", true },
  { "developmentaid.org", true },
  { "devh.net", true },
  { "deviltracks.net", true },
  { "deviltraxxx.de", true },
  { "devinfo.net", false },
  { "devklog.net", true },
  { "devlux.ch", true },
  { "devnsec.com", true },
  { "devolution.ws", true },
  { "devopps.me", true },
  { "devopsconnected.com", true },
  { "devstaff.gr", true },
  { "dewalch.net", true },
  { "dfranke.com", true },
  { "dgeex.eu", true },
  { "dhautefeuille.eu", true },
  { "dhauwer.nl", true },
  { "dhuy.net", true },
  { "diamante.ro", true },
  { "dibiphp.com", true },
  { "dicgaming.net", true },
  { "dick.red", true },
  { "didacte.com", true },
  { "diddens.de", true },
  { "die-besten-weisheiten.de", true },
  { "die-blahuts.de", true },
  { "die-partei-reutlingen.de", true },
  { "diegelernten.de", true },
  { "diegerbers.de", true },
  { "dienstplan.one", true },
  { "dietrich.cx", true },
  { "dighans.com", true },
  { "digital1st.co.uk", true },
  { "digitalehandtekeningen.nl", true },
  { "digitalnonplus.com", true },
  { "digitalskillswap.com", true },
  { "digitkon.com", true },
  { "digminecraft.com", true },
  { "dijkmanmuziek.nl", false },
  { "dillonkorman.com", true },
  { "dime-staging.com", true },
  { "dime.io", true },
  { "dinge.xyz", true },
  { "dinkum.online", true },
  { "dinube.com", true },
  { "diodeled.com", true },
  { "directme.ga", true },
  { "dirkwolf.de", true },
  { "discofitta.com", true },
  { "disconformity.net", true },
  { "discoveringdocker.com", true },
  { "dise-online.de", true },
  { "disinclined.org", true },
  { "disking.co.uk", true },
  { "disorderboutique.com", true },
  { "disruptivelabs.net", true },
  { "disruptivelabs.org", true },
  { "dissimulo.me", true },
  { "dist.torproject.org", false },
  { "distinctivephotography.com.au", true },
  { "dittvertshus.no", true },
  { "divegearexpress.com", true },
  { "diversityflags.com", true },
  { "divingwithnic.com", true },
  { "dixmag.com", true },
  { "diybook.at", true },
  { "diycc.org", true },
  { "dizorg.net", true },
  { "dk.search.yahoo.com", false },
  { "dkds.us", true },
  { "dl.google.com", true },
  { "dlc.viasinc.com", true },
  { "dlemper.de", true },
  { "dlscomputers.com.au", true },
  { "dm.lookout.com", false },
  { "dm.mylookout.com", false },
  { "dmlogic.com", true },
  { "dmxledlights.com", true },
  { "dn42.eu", true },
  { "dndtools.net", true },
  { "dnmlab.it", true },
  { "dnscrypt.org", true },
  { "dnscurve.io", true },
  { "dnsman.se", true },
  { "dobet.in", true },
  { "doc.python.org", true },
  { "docemeldoces.com", true },
  { "docid.io", true },
  { "docket.news", true },
  { "docloh.de", true },
  { "docs.google.com", true },
  { "docs.python.org", true },
  { "doctorwho.cz", true },
  { "docucopies.com", true },
  { "doesmycodehavebugs.today", true },
  { "doeswindowssuckforeveryoneorjustme.com", true },
  { "dogan.ch", false },
  { "dogespeed.ga", true },
  { "dogoodbehappyllc.com", true },
  { "doktorsitesi.com", false },
  { "dokuboard.com", true },
  { "dolphin-cloud.com", true },
  { "dolphin-hosting.com", true },
  { "dolphin-it.de", true },
  { "dolphincorp.co.uk", true },
  { "domainexpress.de", true },
  { "domainkauf.de", true },
  { "domains.google.com", true },
  { "domainstaff.com", true },
  { "domfee.com", true },
  { "domhaase.me", true },
  { "dominikkulaga.pl", false },
  { "domodedovo.travel", true },
  { "donmez.uk", true },
  { "donmez.ws", true },
  { "donner-reuschel.de", true },
  { "donnons.org", true },
  { "donotcall.gov", true },
  { "donthedragonwilson.com", true },
  { "dopost.it", true },
  { "dorianharmans.nl", true },
  { "dorianmuthig.com", true },
  { "doridian.com", true },
  { "doridian.de", true },
  { "doridian.net", true },
  { "doridian.org", true },
  { "dot.ro", true },
  { "dotbigbang.com", true },
  { "dotbox.org", true },
  { "dotsiam.com", true },
  { "doublefun.net", true },
  { "dougferris.id.au", true },
  { "dovecotadmin.org", true },
  { "dovetailnow.com", true },
  { "downsouthweddings.com.au", true },
  { "doyoucheck.com", true },
  { "dpd.com.pl", true },
  { "dpsg-roden.de", true },
  { "dragon-chem.eu", true },
  { "dragonisles.net", true },
  { "dragons-of-highlands.cz", true },
  { "dragonschool.org", true },
  { "drahcro.uk", true },
  { "drakefortreasurer.sexy", true },
  { "drakeluce.com", true },
  { "dramaticpeople.com", true },
  { "dranek.com", true },
  { "draw.uy", true },
  { "drawesome.uy", true },
  { "drdevil.ru", true },
  { "dreadbyte.com", true },
  { "dreamsforabetterworld.com.au", true },
  { "dreamtechie.com", true },
  { "dreid.org", true },
  { "dreizwosechs.de", true },
  { "driesjtuver.nl", true },
  { "drive.google.com", true },
  { "drivenes.net", true },
  { "driving-lessons.co.uk", true },
  { "drkmtrx.xyz", true },
  { "droidwiki.de", true },
  { "dronepit.dk", true },
  { "dropbox.com", true },
  { "dropboxer.net", true },
  { "drpetervoigt.de", true },
  { "drtroyhendrickson.com", true },
  { "drugagodba.si", true },
  { "drumbandesperanto.nl", true },
  { "drumbe.at", true },
  { "drupal.org", true },
  { "dsebastien.net", true },
  { "dsol.hu", true },
  { "dubrovskiy.net", true },
  { "dubrovskiy.pro", true },
  { "duckduckstart.com", true },
  { "ducohosting.com", true },
  { "duesee.org", true },
  { "dukun.de", true },
  { "dumino.bg", true },
  { "dunea.nl", true },
  { "duria.de", true },
  { "durys.be", true },
  { "dutchrank.com", true },
  { "dutchrank.nl", true },
  { "dutchwanderers.nl", true },
  { "duuu.ch", true },
  { "dvbris.co.uk", true },
  { "dvbris.com", true },
  { "dvorupotocnych.sk", true },
  { "dvwc.org", true },
  { "dycontrol.de", true },
  { "dyeager.org", true },
  { "dylanscott.com.au", true },
  { "dymersion.com", true },
  { "dynaloop.net", true },
  { "dynamicnet.net", true },
  { "dynamicsnetwork.net", true },
  { "dyrenesverden.no", true },
  { "dziekonski.com", true },
  { "dzimejl.sk", true },
  { "dzlibs.io", true },
  { "e-kontakti.fi", true },
  { "e-typ.eu", true },
  { "e.mail.ru", true },
  { "eagletechz.com.br", true },
  { "eagleyecs.com", true },
  { "earmarks.gov", true },
  { "easy-rpg.org", true },
  { "easykonto.de", true },
  { "easyplane.it", true },
  { "easysimplecrm.com", false },
  { "eatlowcarb.de", true },
  { "eatsleeprepeat.net", true },
  { "eauclairecommerce.com", true },
  { "eb7.jp", true },
  { "ebankcbt.com", true },
  { "ebanking.indovinabank.com.vn", true },
  { "ebp2p.com", true },
  { "ebpglobal.com", true },
  { "ecake.in", true },
  { "ecco-verde.com", true },
  { "ecdn.cz", true },
  { "ecfs.link", true },
  { "ecg.fr", false },
  { "echomanchester.net", true },
  { "echopaper.com", true },
  { "echosixmonkey.com", true },
  { "eckel.co", true },
  { "ecnetworker.com", true },
  { "ecobee.com", false },
  { "ecogen.com.au", true },
  { "ecogen.net.au", true },
  { "econsumer.gov", true },
  { "ecosystem.atlassian.net", true },
  { "ecrimex.net", true },
  { "ectora.com", true },
  { "ecupcafe.com", false },
  { "ed.gs", true },
  { "edakoe.ru", true },
  { "edati.lv", true },
  { "edcphenix.tk", true },
  { "eddmixpanel.com", true },
  { "edesseglabor.hu", true },
  { "edgereinvent.com", true },
  { "ediscomp.sk", true },
  { "edissecurity.sk", true },
  { "edit.yahoo.com", false },
  { "edix.ru", true },
  { "edoss.co.za", true },
  { "edp-collaborative.com", true },
  { "edpubs.gov", true },
  { "educationunlimited.com", true },
  { "educator-one.com", true },
  { "eduid.se", true },
  { "eduif.nl", true },
  { "eduroam.no", true },
  { "edxg.de", true },
  { "edyou.eu", true },
  { "eelsden.net", true },
  { "eelzak.nl", true },
  { "eeqj.com", true },
  { "eery.de", true },
  { "ef.gy", true },
  { "eff.org", true },
  { "efficienthealth.com", true },
  { "egfl.org.uk", true },
  { "egit.co", true },
  { "ego4u.com", true },
  { "ego4u.de", true },
  { "ehipaa.com", true },
  { "ehipaadev.com", true },
  { "eichornenterprises.com", true },
  { "eimacs.com", true },
  { "einaros.is", true },
  { "einheizpreis.de", true },
  { "einsatzstellenverwaltung.de", true },
  { "eksisozluk.com", true },
  { "ekzarta.ru", true },
  { "elars.de", true },
  { "elbetech.net", true },
  { "elearningpilot.com", true },
  { "electricant.com", true },
  { "electricant.nl", true },
  { "electricianforum.co.uk", true },
  { "electronic-ignition-system.com", true },
  { "electronicfasteners.com", true },
  { "eleicoes2016.com.br", true },
  { "elektropost.org", true },
  { "element-43.com", true },
  { "elemental.software", true },
  { "elementalrobotics.com", true },
  { "elemenx.com", true },
  { "elenag.ga", true },
  { "elephpant.cz", true },
  { "elglobo.com.mx", true },
  { "elgosblanc.com", true },
  { "eligible.com", true },
  { "eligrey.com", true },
  { "elisa.ee", false },
  { "elite12.de", true },
  { "elitefishtank.com", false },
  { "elitegameservers.net", true },
  { "elitehosting.de", true },
  { "ellegaard.dk", true },
  { "elliquiy.com", true },
  { "elliriehl.at", true },
  { "ellsinger.me", true },
  { "elmermx.ch", true },
  { "elnan.do", true },
  { "elpo.net", true },
  { "elsamakhin.com", true },
  { "elvidence.com.au", true },
  { "emailhunter.co", true },
  { "emailprivacytester.com", true },
  { "emaily.eu", true },
  { "emanuelduss.ch", true },
  { "embracethedarkness.co.uk", true },
  { "emilong.com", true },
  { "emilyhorsman.com", true },
  { "emilyshepherd.me", true },
  { "emirabiz.com", false },
  { "empleostampico.com", false },
  { "empowerdb.com", true },
  { "emptypath.com", true },
  { "en-maktoob.search.yahoo.com", false },
  { "encircleapp.com", true },
  { "encredible.de", true },
  { "encredible.org", true },
  { "encryptallthethings.net", true },
  { "encrypted.google.com", true },
  { "end.io", true },
  { "end.pp.ua", true },
  { "endlessdark.net", true },
  { "endlesshorizon.net", true },
  { "endlesstone.com", true },
  { "endofnet.org", true },
  { "enecoshop.nl", true },
  { "enefan.jp", true },
  { "energiekeurplus.nl", true },
  { "energy-drink-magazin.de", true },
  { "engelundlicht.ch", true },
  { "englerts.de", true },
  { "englishbulgaria.net", true },
  { "englishclub.com", true },
  { "englishforums.com", true },
  { "enjen.net", true },
  { "enorekcah.com", true },
  { "enquos.com", true },
  { "enskat.de", true },
  { "enskatson-sippe.de", true },
  { "ensured.com", true },
  { "ensured.nl", true },
  { "enteente.club", true },
  { "enteente.com", true },
  { "enteente.xyz", true },
  { "enterprisey.enterprises", true },
  { "entersynapse.com", false },
  { "entrepreneur.or.id", true },
  { "entropia.de", false },
  { "envelope.co.nz", true },
  { "enveloppenopmaat.nl", true },
  { "enviam.de", true },
  { "envygeeks.com", true },
  { "envygeeks.io", true },
  { "eoldb.org", true },
  { "eopugetsound.org", true },
  { "epanurse.com", true },
  { "epay.bg", true },
  { "epublibre.org", true },
  { "eq8.net.au", true },
  { "eqorg.com", true },
  { "equate.net.au", true },
  { "equatetechnologies.com.au", true },
  { "erawanarifnugroho.com", true },
  { "ericdiao.com", true },
  { "eriix.org", true },
  { "erisrenee.com", true },
  { "ernesto.at", true },
  { "erp-band.ru", true },
  { "erp.band", true },
  { "erpband.ru", true },
  { "erpcargo.com", true },
  { "errolz.com", true },
  { "errors.zenpayroll.com", false },
  { "ersindemirtas.com", true },
  { "eru.me", true },
  { "es.search.yahoo.com", false },
  { "escalate.eu", true },
  { "escapees.com", true },
  { "esg-abi2001.de", true },
  { "esko.bar", true },
  { "eskriett.com", true },
  { "esoa.net", true },
  { "esocweb.com", true },
  { "espanol.search.yahoo.com", false },
  { "espci.fr", true },
  { "espgg.org", true },
  { "espra.com", true },
  { "esquonic.com", true },
  { "essoduke.org", true },
  { "estan.cn", true },
  { "esteam.se", true },
  { "estilos.com.pe", true },
  { "etaes.eu", true },
  { "eternitylove.us", true },
  { "etha.nz", true },
  { "ethack.org", true },
  { "ethanfaust.com", true },
  { "ethercalc.com", true },
  { "ethercalc.org", true },
  { "etherpad.fr", true },
  { "ethicaldata.co.uk", true },
  { "ethicalexploiting.com", true },
  { "ethitter.com", true },
  { "ethlan.fr", true },
  { "etula.ga", true },
  { "euanbaines.com", true },
  { "eugenekay.com", true },
  { "eulenleben.de", true },
  { "eulerpi.io", true },
  { "euph.eu", true },
  { "europop.com", true },
  { "euroshop.or.at", true },
  { "eurostrategy.vn.ua", true },
  { "eurotramp.com", true },
  { "ev-zertifikate.de", true },
  { "eva.cz", true },
  { "evalesc.com", true },
  { "evasovova.cz", true },
  { "evdenevenakliyatankara.pw", true },
  { "everhome.de", true },
  { "everwaking.com", true },
  { "everylab.org", true },
  { "everythingkitchens.com", false },
  { "eveseat.net", true },
  { "eveshamglass.co.uk", true },
  { "evilized.de", true },
  { "evomon.com", true },
  { "evossd.tk", true },
  { "evrial.com", true },
  { "evstatus.com", true },
  { "ewe2.ninja", true },
  { "ewie.name", true },
  { "exceltobarcode.com", true },
  { "excessamerica.com", true },
  { "exekutori.com", true },
  { "exeria.de", true },
  { "exfiles.cz", true },
  { "exiahost.com", true },
  { "exno.co", true },
  { "exon.io", true },
  { "expatads.com", true },
  { "experienceoz.com.au", true },
  { "expertmile.com", true },
  { "explodie.org", true },
  { "expo-asia.ru", true },
  { "expo-designers.com", true },
  { "express-vpn.com", true },
  { "expressfinance.co.za", true },
  { "expresshosting.org", true },
  { "expressvpn.com", true },
  { "expxkcd.com", true },
  { "extendwings.com", true },
  { "extracobanks.com", true },
  { "extranetpuc.com.br", true },
  { "eyasc.nl", true },
  { "eydesignguidelines.com", true },
  { "eytosh.net", true },
  { "eyyit.com", true },
  { "ezrefurb.co.uk", true },
  { "f-droid.org", true },
  { "f-thie.de", true },
  { "f00.ca", true },
  { "f2f.cash", true },
  { "fa-works.com", true },
  { "fabhub.io", true },
  { "fabianasantiago.com", true },
  { "fabienbaker.com", true },
  { "fableforge.nl", true },
  { "fabse.net", true },
  { "facebook.com", false },
  { "factor.cc", false },
  { "factuursturen.be", true },
  { "factuursturen.nl", true },
  { "faeriecakes.be", true },
  { "fahrenwal.de", true },
  { "fahrenwalde.de", true },
  { "failproof.be", true },
  { "fairbill.com", true },
  { "faizan.net", true },
  { "faktura.pl", true },
  { "fakturoid.cz", true },
  { "falconvintners.com", true },
  { "falkp.no", true },
  { "fallenangeldrinks.co.uk", true },
  { "fallenangeldrinks.com", true },
  { "fallenangeldrinks.eu", true },
  { "fallenangelspirits.co.uk", true },
  { "fallenangelspirits.com", true },
  { "fallenangelspirits.uk", true },
  { "fallenspirits.co.uk", true },
  { "familie-sander.rocks", true },
  { "familiegrottendieck.de", true },
  { "familieholme.de", true },
  { "familjenfrodlund.se", true },
  { "fandomservices.com", true },
  { "fangs.ink", true },
  { "fanvoice.com", true },
  { "faq.lookout.com", false },
  { "fargtorget.se", true },
  { "farmacialaboratorio.it", true },
  { "fasdoutreach.ca", true },
  { "fashion.net", true },
  { "faspirits.co.uk", true },
  { "faspirits.com", true },
  { "fassadenverkleidung24.de", true },
  { "fastaim.de", true },
  { "fastcomcorp.com", true },
  { "fastcomcorp.net", true },
  { "fastmail.com", false },
  { "fastopen.ml", true },
  { "fatherhood.gov", true },
  { "fatlossguide.xyz", true },
  { "fatox.de", true },
  { "fatzebra.com.au", false },
  { "faucetbox.com", true },
  { "fawkex.me", true },
  { "fayolle.info", true },
  { "fbox.li", true },
  { "fca-tools.com", true },
  { "fdj.im", true },
  { "fdsys.gov", false },
  { "fearsomegaming.com", true },
  { "fecik.sk", true },
  { "federalregister.gov", true },
  { "federicomigliavacca.it", true },
  { "fedorahosted.org", true },
  { "fedorapeople.org", true },
  { "fedrtc.org", true },
  { "feedbin.com", false },
  { "feedthebot.com", true },
  { "feel.aero", true },
  { "feen.us", true },
  { "feezmodo.com", true },
  { "feirlane.org", true },
  { "feliwyn.fr", true },
  { "felixrr.pro", true },
  { "feminists.co", true },
  { "fenno.net", true },
  { "fenteo.com", true },
  { "feragon.net", true },
  { "ferienhaus-polchow-ruegen.de", false },
  { "fetch.co.uk", true },
  { "fewo-thueringer-wald.de", true },
  { "fexco.com", true },
  { "ff-bad-hoehenstadt.de", true },
  { "ffbans.org", true },
  { "fhcdn.xyz", true },
  { "fi.google.com", true },
  { "fi.search.yahoo.com", false },
  { "fidanza.eu", true },
  { "fidelapp.com", true },
  { "fierlafijn.net", true },
  { "fierman.eu", true },
  { "fierman.net", true },
  { "fierman.us", true },
  { "fiftyshadesofluca.ml", true },
  { "fightr.co", true },
  { "figuurzagers.nl", true },
  { "fiilr.com", true },
  { "fiken.no", true },
  { "fiksel.info", true },
  { "fikt.space", true },
  { "file-pdf.it", true },
  { "filedir.com", false },
  { "filip-prochazka.com", true },
  { "filippo.io", true },
  { "fillmysuitca.se", true },
  { "filoo.de", true },
  { "finalgear.com", true },
  { "finanzkontor.net", true },
  { "finditez.com", true },
  { "findyour.diet", true },
  { "finenet.com.tw", true },
  { "finfev.de", true },
  { "finkelstein.fr", true },
  { "finn.io", true },
  { "fionamcbride.com", true },
  { "firebaseio-demo.com", true },
  { "firebaseio.com", true },
  { "firebirdrangecookers.com", true },
  { "firecore.com", false },
  { "firefart.at", false },
  { "firemail.io", true },
  { "fireorbit.de", true },
  { "firevap.org", true },
  { "firexarxa.de", true },
  { "firma-offshore.com", true },
  { "firmapi.com", true },
  { "firstchoicecandy.com", true },
  { "firstderm.com", true },
  { "firstlook.org", true },
  { "fischers.cc", true },
  { "fish-hook.ru", true },
  { "fitkram.cz", true },
  { "fizz.buzz", true },
  { "fj.simple.com", false },
  { "flaemig42.de", true },
  { "flags.ninja", true },
  { "flagspot.net", true },
  { "flajshans.cz", true },
  { "flamer-scene.com", false },
  { "flamewall.net", false },
  { "flamingcow.tv", true },
  { "flamingkeys.com", true },
  { "flamme-von-anor.de", true },
  { "flanco.ro", true },
  { "flat.io", true },
  { "flawlesscowboy.xyz", true },
  { "fless.co.uk", true },
  { "fletchto99.com", true },
  { "fleximus.org", false },
  { "flexport.com", true },
  { "flipagram.com", false },
  { "flirchi.com", false },
  { "flocktofedora.org", true },
  { "floobits.com", true },
  { "floorball-haunwoehr.de", true },
  { "floort.net", true },
  { "florian-schlachter.de", true },
  { "florianmitrea.uk", true },
  { "floridaescapes.co.uk", true },
  { "floridafieros.org", true },
  { "florismouwen.com", true },
  { "floskelwolke.de", true },
  { "flouartistique.ch", true },
  { "flow.su", true },
  { "flowersandclouds.com", true },
  { "flowlo.me", true },
  { "flra.gov", true },
  { "flukethoughts.com", true },
  { "flushstudios.com", true },
  { "fluxent.de", true },
  { "fluxfingers.net", true },
  { "fly.moe", true },
  { "flynn.io", true },
  { "fmarchal.fr", true },
  { "fnb-griffinonline.com", true },
  { "fniephaus.com", true },
  { "focusmark.jp", true },
  { "folv.es", true },
  { "food4health.guide", true },
  { "foodacademy.capetown", true },
  { "foodiebox.no", true },
  { "foodwise.marketing", true },
  { "footballmapped.com", true },
  { "foray-jero.me", true },
  { "fordbydesign.com", true },
  { "forewordreviews.com", true },
  { "forextimes.ru", true },
  { "forgix.com", true },
  { "formationseeker.com", true },
  { "formationsfactory.co.uk", false },
  { "formazioneopen.it", true },
  { "formula.cf", true },
  { "foro.io", false },
  { "forodeespanol.com", true },
  { "fortnine.ca", true },
  { "fortress.sk", true },
  { "forum.linode.com", false },
  { "forum.quantifiedself.com", false },
  { "fossewaygardencentre.co.uk", true },
  { "fotofaerie.net", true },
  { "fotostudio-schweiz.ch", true },
  { "fotowolfy.com", true },
  { "foxelbox.com", true },
  { "fpy.cz", true },
  { "fr.search.yahoo.com", false },
  { "fr33d0m.link", true },
  { "frack.nl", true },
  { "fralef.me", false },
  { "francevpn.xyz", true },
  { "frangor.info", true },
  { "frankhaala.com", true },
  { "frankierprofi.de", true },
  { "franta.biz", true },
  { "franta.email", true },
  { "franzt.ovh", true },
  { "fraye.net", true },
  { "frederik-braun.com", true },
  { "fredvoyage.fr", true },
  { "free.com.tw", true },
  { "freeboson.org", true },
  { "freedom.press", false },
  { "freekdevries.nl", true },
  { "freelance.boutique", true },
  { "freelance.nl", true },
  { "freenetproject.org", true },
  { "freeshell.de", true },
  { "freesitemapgenerator.com", true },
  { "freesounding.com", true },
  { "freesounding.ru", true },
  { "freethought.org.au", true },
  { "freeweibo.com", true },
  { "freifunk-essen.de", true },
  { "freifunk-luenen.de", true },
  { "freiwurst.net", true },
  { "freqlabs.com", true },
  { "fresh-hotel.org", true },
  { "freshdns.nl", true },
  { "fretscha.com", true },
  { "fridolinka.cz", true },
  { "friendica.ch", true },
  { "frillip.com", true },
  { "frippz.se", true },
  { "fritzrepair.com", true },
  { "frly.de", true },
  { "frob.nl", true },
  { "frogatto.com", true },
  { "froggstack.de", true },
  { "fromscratch.rocks", true },
  { "fronteers.nl", true },
  { "frontmin.com", true },
  { "froxlor.support", true },
  { "frtr.gov", true },
  { "fruchthof24.de", true },
  { "fruitusers.com", true },
  { "frusky.de", true },
  { "fsapubs.gov", true },
  { "fsfi.is", true },
  { "ftccomplaintassistant.gov", true },
  { "fteproxy.org", true },
  { "fugle.de", true },
  { "fuglede.dk", true },
  { "fukushima-web.com", true },
  { "fumo.se", true },
  { "functions-online.com", true },
  { "funderburg.me", true },
  { "fundingempire.com", true },
  { "funnyang.com", true },
  { "funrun.com", true },
  { "furkancaliskan.com", true },
  { "furry.be", true },
  { "furry.dk", true },
  { "futos.de", true },
  { "fuzzing-project.org", true },
  { "fx5.de", true },
  { "fzn.io", true },
  { "g-m-w.eu", true },
  { "g-marketing.ro", true },
  { "g2a.co", true },
  { "g4w.co", true },
  { "g5led.nl", true },
  { "gabber.scot", true },
  { "gaichon.com", true },
  { "gaiserik.com", true },
  { "gallery44.org", true },
  { "gam3rs.de", true },
  { "gamajo.com", true },
  { "gambit.pro", true },
  { "gambitnash.co.uk", true },
  { "gambitnash.com", true },
  { "gambitprint.com", true },
  { "game-files.net", true },
  { "gamecollector.be", true },
  { "gamegix.com", true },
  { "gameink.net", true },
  { "gamenected.com", true },
  { "gamenected.de", true },
  { "gamercredo.com", true },
  { "gamercredo.net", true },
  { "gamers-life.fr", true },
  { "gamesurferapp.com", true },
  { "gamingzoneservers.com", true },
  { "gamishou.fr", true },
  { "gamoloco.com", true },
  { "gampenhof.de", true },
  { "gancedo.com.es", true },
  { "garagegoossens.be", true },
  { "garbage-juice.com", true },
  { "garron.net", true },
  { "garyjones.co.uk", true },
  { "gatilagata.com.br", true },
  { "gaussorgues.me", true },
  { "gautvedt.no", true },
  { "gavick.com", true },
  { "gaytorrent.ru", true },
  { "gc-mc.de", true },
  { "gc.net", true },
  { "gcs-ventures.com", true },
  { "gcsepod.com", true },
  { "ge3k.net", true },
  { "geblitzt.de", true },
  { "gechr.io", true },
  { "geek-hub.de", true },
  { "geekandi.com", true },
  { "geekwu.org", true },
  { "geeky.software", true },
  { "gehaowu.com", true },
  { "gelog-software.de", true },
  { "gemeinfreie-lieder.de", true },
  { "gendrin.com", true },
  { "genehome.com.au", true },
  { "generali-worldwide.com", true },
  { "generic.cx", true },
  { "genossen.ru", true },
  { "genshiken-itb.org", true },
  { "genshiken.org", true },
  { "genslerwisp.com", true },
  { "genuu.com", true },
  { "genuxation.com", true },
  { "genuxtsg.com", true },
  { "genxbeats.com", true },
  { "genxnotes.com", true },
  { "geoip.fedoraproject.org", true },
  { "geoip.stg.fedoraproject.org", true },
  { "georgemaschke.com", true },
  { "georgemaschke.net", true },
  { "geraintwhite.co.uk", true },
  { "gerardozamudio.mx", true },
  { "gerencianet.com.br", false },
  { "gereon.ch", true },
  { "gernert-server.de", true },
  { "geschwinder.net", true },
  { "gesiwista.net", true },
  { "get-asterisk.ru", true },
  { "get-erp.ru", true },
  { "get.zenpayroll.com", false },
  { "getbox.me", true },
  { "getbutterfly.com", true },
  { "getcloak.com", false },
  { "getcolor.com", true },
  { "getdash.io", true },
  { "getdigitized.net", true },
  { "geterp.ru", true },
  { "getfedora.org", true },
  { "getfittedstore.com", true },
  { "gethttpsforfree.com", true },
  { "getinternet.de", true },
  { "getlolaccount.com", true },
  { "getmango.com", true },
  { "getnikola.com", true },
  { "getremembrall.com", true },
  { "getsello.com", false },
  { "getspire.com", true },
  { "getsport.mobi", true },
  { "getts.ro", true },
  { "getvdownloader.com", true },
  { "gfhgiro.nl", true },
  { "gfm.tech", true },
  { "gfournier.ca", true },
  { "ggp2.com", true },
  { "ggx.us", true },
  { "gha.st", true },
  { "gheorghesarcov.ga", true },
  { "gheorghesarcov.tk", true },
  { "ghostblog.info", true },
  { "giacomopelagatti.it", true },
  { "giftservices.nl", true },
  { "gifzilla.net", false },
  { "gigacloud.org", true },
  { "gigacog.com", true },
  { "gijsbertus.com", true },
  { "gilcloud.com", true },
  { "gintenreiter-photography.com", true },
  { "github.com", true },
  { "github.party", false },
  { "giveattheoffice.org", true },
  { "givingnexus.org", true },
  { "gizzo.sk", true },
  { "gjspunk.de", true },
  { "glasgestaltung.biz", true },
  { "glass.google.com", true },
  { "glasschmuck-millefiori.de", true },
  { "glentakahashi.com", true },
  { "glidingshop.cz", true },
  { "glittersjabloon.nl", true },
  { "globalcomix.com", true },
  { "globalexpert.co.nz", true },
  { "globalinstitutefortraining.org.au", true },
  { "globalittech.com", false },
  { "globalperspectivescanada.com", true },
  { "globuli-info.de", true },
  { "glossopnorthendafc.co.uk", true },
  { "glubbforum.de", true },
  { "gm-assicurazioni.it", true },
  { "gmail.com", false },
  { "gmcd.co", true },
  { "gmdu.net", true },
  { "gmta.nl", true },
  { "gmw-hannover.de", true },
  { "gmw-ingenieurbuero.de", true },
  { "gnetwork.eu", true },
  { "go-zh.org", true },
  { "go.ax", true },
  { "go.xero.com", false },
  { "goabonga.com", true },
  { "goalsetup.com", true },
  { "goaltree.ch", true },
  { "goat.xyz", true },
  { "goben.ch", true },
  { "gocardless.com", true },
  { "godesigner.ru", true },
  { "goerner.me", true },
  { "gofigure.fr", false },
  { "gogenenglish.com", true },
  { "goggs.eu", true },
  { "gokmenguresci.com", true },
  { "goldendata.io", true },
  { "goldenhillsoftware.com", true },
  { "goldmark.com.au", true },
  { "goldpreisfinder.at", true },
  { "golfscape.com", true },
  { "gonzalosanchez.mx", true },
  { "gooby.co", true },
  { "googlemail.com", false },
  { "googleplex.com", true },
  { "gopay.cz", true },
  { "gordonobrecht.com", true },
  { "gorschenin.com", true },
  { "goshop.cz", true },
  { "gosuland.org", true },
  { "gotech.com.eg", true },
  { "gothamlimo.com", true },
  { "goto.google.com", true },
  { "gotocloud.ru", true },
  { "gotspot.com", true },
  { "governorhub.com", true },
  { "govtrack.us", true },
  { "gowe.wang", true },
  { "gpfclan.de", true },
  { "gplintegratedit.com", true },
  { "gpo.gov", false },
  { "gps.com.br", true },
  { "gpsfix.cz", true },
  { "gr.search.yahoo.com", false },
  { "gra2.com", true },
  { "graavaapi.elasticbeanstalk.com", true },
  { "grace-wan.com", true },
  { "gracedays.org", true },
  { "gracesofgrief.com", true },
  { "graciousmay.com", true },
  { "grafitec.ru", true },
  { "grafmurr.de", true },
  { "graingert.co.uk", true },
  { "grandcapital.id", true },
  { "grandcapital.ru", true },
  { "grandlinecsk.ru", true },
  { "grandmasfridge.org", true },
  { "grannyshouse.de", true },
  { "grantedby.me", true },
  { "granth.io", true },
  { "granular.ag", true },
  { "graph.no", true },
  { "gravitechthai.com", true },
  { "gravito.nl", true },
  { "gravity-net.de", true },
  { "graymalk.in", true },
  { "grazetech.com", true },
  { "grc.com", false },
  { "grcnode.co.uk", true },
  { "greatfire.org", true },
  { "greatnet.de", true },
  { "greedbutt.com", true },
  { "greenpeace-magazin.de", true },
  { "greenpeace.berlin", true },
  { "greenroach.ru", true },
  { "greensolid.biz", true },
  { "greenteamtwente.nl", true },
  { "gregmilton.com", true },
  { "gregmilton.org", true },
  { "gregorytlee.me", true },
  { "grepular.com", true },
  { "gresak.io", true },
  { "grh.am", true },
  { "grieg.no", true },
  { "griegfoundation.no", true },
  { "griegshipbrokers.no", true },
  { "griesser2.de", true },
  { "grigalanzsoftware.com", true },
  { "grimm-gastrobedarf.de", true },
  { "grimneko.de", true },
  { "gripopgriep.net", true },
  { "gritte.ch", true },
  { "grizzlys.com", true },
  { "grocock.me.uk", true },
  { "groetzner.net", true },
  { "grog.pw", true },
  { "groovydisk.com", true },
  { "gropp.org", true },
  { "groseb.net", true },
  { "grossmann.gr", true },
  { "groszek.pl", true },
  { "groth.im", true },
  { "groth.xyz", true },
  { "groups.google.com", true },
  { "grsecurity.net", true },
  { "grunex.com", true },
  { "grytics.com", true },
  { "gs-net.at", true },
  { "gsm-map.com", true },
  { "gtanda.tk", true },
  { "gtlfsonlinepay.com", true },
  { "gtmasterclub.it", false },
  { "gtmetrix.com", true },
  { "gtraxapp.com", true },
  { "gudini.net", true },
  { "guevener.de", true },
  { "guffr.it", true },
  { "gugga.dk", false },
  { "guguke.net", true },
  { "guidetoiceland.is", false },
  { "guillaumeperrin.io", true },
  { "guineapigmustach.es", true },
  { "guntbert.net", true },
  { "gunwatch.co.uk", true },
  { "guphi.net", true },
  { "gurochan.ch", true },
  { "gurom.lv", true },
  { "guru-naradi.cz", true },
  { "gurusupe.com", true },
  { "gussi.is", true },
  { "guthabenkarten-billiger.de", true },
  { "guvernalternativa.ro", true },
  { "gvt2.com", true },
  { "gvt3.com", true },
  { "gw2treasures.com", true },
  { "gwtest.us", true },
  { "gyboche.com", true },
  { "gyboche.science", true },
  { "gyz.io", true },
  { "gz-architekten.de", true },
  { "h-jo.net", true },
  { "h2check.org", true },
  { "habarisoft.com", true },
  { "hablemosdetecnologia.com.ve", false },
  { "hachre.de", false },
  { "hack.cz", true },
  { "hack.li", true },
  { "hackcraft.net", true },
  { "hackenkunjeleren.nl", true },
  { "hackenturet.dk", true },
  { "hacker.one", true },
  { "hackernet.se", true },
  { "hackerone-user-content.com", true },
  { "hackerone.com", true },
  { "hackerpoints.com", true },
  { "hackest.org", true },
  { "hackit.im", true },
  { "hackthissite.org", true },
  { "hadleighswimmingclub.co.uk", true },
  { "hadzic.co", true },
  { "hafniatimes.com", true },
  { "haircrazy.com", true },
  { "haitschi.com", true },
  { "haitschi.de", true },
  { "haitschi.net", true },
  { "haitschi.org", true },
  { "hakase.kr", true },
  { "haktec.de", true },
  { "haku.moe", false },
  { "hallmarkestates.ca", true },
  { "halo.fr", true },
  { "haman.nl", true },
  { "hana.ondemand.com", true },
  { "handmadetutorials.ro", true },
  { "hangouts.google.com", true },
  { "hannover-banditen.de", true },
  { "hansvaneijsden.com", true },
  { "haozi.me", true },
  { "happycoder.net", true },
  { "happygadget.me", true },
  { "happylifestyle.com", true },
  { "happyteamlabs.com", true },
  { "happytiger.eu", true },
  { "happyukgo.com", true },
  { "harbor-light.net", true },
  { "hardeman.nu", true },
  { "hardertimes.com", true },
  { "hardfalcon.net", true },
  { "hardh.at", true },
  { "hardline.xyz", true },
  { "harmoney.co.nz", true },
  { "harmoney.com", true },
  { "harmonycosmetic.com", true },
  { "harringtonca.com", true },
  { "harrisonsdirect.co.uk", true },
  { "harristony.com", true },
  { "harvestapp.com", true },
  { "harvester.fr", false },
  { "haselsteiner.me", true },
  { "hash-list.com", true },
  { "hashiconf.com", true },
  { "hashicorp.com", true },
  { "hashnode.com", true },
  { "hashplex.com", true },
  { "hashru.nl", true },
  { "haste.ch", true },
  { "hastherebeenamassshooting.today", true },
  { "hatoko.net", true },
  { "haucke.xyz", true },
  { "haufschild.de", true },
  { "hauntedfishtank.com", true },
  { "hausverbrauch.de", true },
  { "haveeruexaminer.com", true },
  { "haveibeenpwned.com", true },
  { "havelland-obstler.de", true },
  { "hawkeyeinsight.com", true },
  { "haxo.nl", false },
  { "hboeck.de", true },
  { "hbpowell.com", true },
  { "hcie.pl", true },
  { "hd-offensive.at", true },
  { "hda.me", true },
  { "hdc.cz", true },
  { "hdeaves.uk", true },
  { "hdfgroup.org", true },
  { "hdm.io", true },
  { "hds-lan.de", true },
  { "hduin.xyz", true },
  { "hdwallpapers.net", true },
  { "head.org", true },
  { "healthcare.gov", false },
  { "healtheffectsofasbestos.com", true },
  { "healthfoam.com", true },
  { "healthiercompany.com", true },
  { "heartsucker.com", true },
  { "heathmanners.com", true },
  { "heavystresser.com", true },
  { "hec.global", true },
  { "hegen.com.pl", true },
  { "heh.ee", true },
  { "heha.co", false },
  { "heid.ws", true },
  { "heijblok.com", true },
  { "hejahanif.se", true },
  { "hejsupport.se", true },
  { "hele.cz", true },
  { "helgakristoffer.com", true },
  { "helgakristoffer.wedding", true },
  { "helichat.de", true },
  { "helix.am", true },
  { "helloacm.com", true },
  { "helloanselm.com", true },
  { "help.simpletax.ca", false },
  { "helpadmin.net", true },
  { "helpconnect.com.au", true },
  { "helpium.de", true },
  { "helpmebuild.com", true },
  { "hemdal.se", true },
  { "hemlockhillscabinrentals.com", true },
  { "hencagon.com", true },
  { "hennymerkel.com", true },
  { "henok.eu", true },
  { "henriknoerr.com", true },
  { "henriksen.is", true },
  { "henrock.net", true },
  { "henryphan.com", true },
  { "heppler.net", true },
  { "herbandpat.org", true },
  { "herbert.io", true },
  { "herocentral.de", true },
  { "herpaderp.net", true },
  { "herrsmith.com", true },
  { "herzbotschaft.de", true },
  { "hetmer.com", true },
  { "heute-kaufen.de", true },
  { "heutger.net", true },
  { "hex2013.com", true },
  { "hexicurity.com", true },
  { "hexo.io", true },
  { "hexony.com", true },
  { "heyfringe.com", true },
  { "heyguevara.com", true },
  { "hg.python.org", true },
  { "hhhdb.com", true },
  { "hhmmmm.de", true },
  { "hicn.gq", true },
  { "hicoria.com", true },
  { "hiddenmail.xyz", true },
  { "highseer.com", true },
  { "highvelocitydesign.com", true },
  { "hiisukun.com", true },
  { "hikariempire.com", true },
  { "hilahdih.cz", true },
  { "hilti.co.jp", true },
  { "hilti.co.uk", true },
  { "hilti.com", true },
  { "hilti.com.au", true },
  { "hilti.com.hk", true },
  { "hilti.com.sg", true },
  { "hilti.de", true },
  { "hilti.es", true },
  { "hilti.fi", true },
  { "hilti.fr", true },
  { "hilti.it", true },
  { "hilti.ru", true },
  { "hiphop.ren", true },
  { "hiphopconvention.nl", true },
  { "hipstercat.fr", true },
  { "hirake55.com", true },
  { "hisbrucker.net", true },
  { "history.google.com", false },
  { "hittipps.com", true },
  { "hiv.gov", true },
  { "hjw-kunstwerk.de", true },
  { "hk.search.yahoo.com", false },
  { "hlavacek.us", true },
  { "hledejpravnika.cz", true },
  { "hmm.nyc", false },
  { "hmsseahawk.com", true },
  { "hobby-gamerz-community.de", true },
  { "hobbyspeed.com", true },
  { "hochhaus.us", true },
  { "hodne.io", true },
  { "hohm.in", true },
  { "holifestival-freyung.de", true },
  { "holisticon.de", true },
  { "hollowrap.com", true },
  { "holmesian.org", true },
  { "holofono.com", true },
  { "holymoly.lu", true },
  { "homads.com", false },
  { "homecareassociatespa.com", true },
  { "homehunting.pt", true },
  { "homeseller.co.uk", true },
  { "homeseller.com", true },
  { "homeyou.com", true },
  { "hompus.nl", true },
  { "hondart.cz", true },
  { "honeybadger.io", false },
  { "honoo.com", true },
  { "hoodoo.io", true },
  { "hoodoo.tech", true },
  { "hopewellproperties.co.uk", true },
  { "hopps.me", true },
  { "horza.org", true },
  { "hoshinplan.com", true },
  { "hoshisato.com", true },
  { "hostanalyticsconsulting.com", true },
  { "hostedbgp.net", true },
  { "hostedtalkgadget.google.com", true },
  { "hostelite.com", true },
  { "hostgarou.com", true },
  { "hostingactive.it", true },
  { "hostingfj.com", true },
  { "hostinghelp.guru", true },
  { "hostinginnederland.nl", true },
  { "hostix.de", true },
  { "hotchillibox.co.za", true },
  { "hotchillibox.com", true },
  { "hotelmap.com", true },
  { "hoton.in", true },
  { "housingstudents.org.uk", true },
  { "hovie.at", true },
  { "howrandom.org", true },
  { "howsmyssl.com", true },
  { "howsmytls.com", true },
  { "hozana.si", false },
  { "hpac-portal.com", true },
  { "hpisavageforum.com", true },
  { "hpkp-faq.de", true },
  { "hqhost.net", true },
  { "hrackydomino.cz", true },
  { "hranicka.cz", true },
  { "hrbatypes.cz", true },
  { "hrobert.hu", true },
  { "hroschyk.cz", true },
  { "hs-group.net", true },
  { "hsir.me", true },
  { "hsmr.cc", true },
  { "hsr.gov", true },
  { "hsts.date", true },
  { "htaccessbook.com", true },
  { "html5.org", true },
  { "htmlacademy.ru", true },
  { "httpsecurityreport.com", true },
  { "httpswatch.com", true },
  { "huaxueba.com", true },
  { "huffduffer.com", true },
  { "hugocollignon.fr", false },
  { "humankode.com", true },
  { "humblefinances.com", true },
  { "humpteedumptee.in", true },
  { "hund.io", true },
  { "hupp.se", true },
  { "huren.nl", true },
  { "hurricanelabs.com", true },
  { "husakbau.at", true },
  { "hushfile.it", true },
  { "husky.xyz", true },
  { "huskybutt.dog", true },
  { "huskyinc.us", true },
  { "hx53.de", true },
  { "hymerscollege.co.uk", true },
  { "hyper-text.org", true },
  { "i10z.com", true },
  { "i5y.co.uk", true },
  { "iactu.info", true },
  { "iainsimms.me", true },
  { "iamcarrico.com", true },
  { "iamokay.nl", true },
  { "ian.sh", true },
  { "ianix.com", true },
  { "iban.is", true },
  { "ibarf.nl", true },
  { "ibron.co", true },
  { "icarlos.net", true },
  { "icebat.dyndns.org", true },
  { "ichronos.net", true },
  { "icq-project.net", true },
  { "ictinforensics.org", true },
  { "id-co.in", true },
  { "id-conf.com", false },
  { "id.atlassian.com", true },
  { "id.fedoraproject.org", false },
  { "id.mayfirst.org", false },
  { "id.search.yahoo.com", false },
  { "id0-rsa.pub", true },
  { "idaspis.com", true },
  { "ideadozz.hu", true },
  { "ideation-inc.co.jp", true },
  { "ideaweb.de", true },
  { "identitytheft.gov", true },
  { "idgsupply.com", true },
  { "idlekernel.com", true },
  { "idndx.com", true },
  { "idoc24.com", true },
  { "idolf.dk", true },
  { "idontplaydarts.com", true },
  { "idvl.de", true },
  { "iec.pe", true },
  { "ies.id.lv", true },
  { "ieval.ro", true },
  { "ifcfg.me", true },
  { "ifconfig.co", true },
  { "iflare.de", true },
  { "ifleurs.com", true },
  { "ifoss.me", true },
  { "ifxor.com", true },
  { "igforums.com", true },
  { "iggprivate.com", true },
  { "iggsoft.com", true },
  { "iggsoftware.com", true },
  { "igotoffer.com", true },
  { "igrivi.com", true },
  { "ihrlotto.de", true },
  { "ihsbsd.me", true },
  { "iirii.com", true },
  { "iispeed.com", true },
  { "ijohan.nl", true },
  { "ijsclubtilburg.nl", true },
  { "ikeyless.com", true },
  { "ikk.me", true },
  { "ikkatsu-satei.jp", true },
  { "iklive.org", true },
  { "ikvts.de", true },
  { "ikwilguidobellen.nl", true },
  { "ilbuongiorno.it", true },
  { "ilhadocaranguejo.com.br", true },
  { "ilikerainbows.co", true },
  { "ilikerainbows.co.uk", false },
  { "illorenese.fr", true },
  { "ilrg.com", true },
  { "iluvscotland.co.uk", true },
  { "im-c-shop.com", true },
  { "imagefu.com", true },
  { "imagescostumes.com", true },
  { "imaginary.ca", true },
  { "imagr.io", true },
  { "imbrian.org", true },
  { "imedikament.de", true },
  { "imeds.pl", true },
  { "imgg.es", true },
  { "imirhil.fr", true },
  { "imjiangtao.com", true },
  { "imlonghao.com", true },
  { "immaterium.de", true },
  { "immigrationdirect.com.au", true },
  { "immortals-co.com", true },
  { "immoverkauf24.at", true },
  { "immoverkauf24.de", true },
  { "immunicity.info", true },
  { "imoni-blog.net", true },
  { "impex.com.bd", true },
  { "imququ.com", true },
  { "imreh.net", true },
  { "imrejonk.nl", true },
  { "imusic.dk", true },
  { "in-depthoutdoors.com", true },
  { "in.search.yahoo.com", false },
  { "in.xero.com", false },
  { "inb4.us", true },
  { "inbitcoin.it", true },
  { "inbounder.io", true },
  { "inbox.google.com", true },
  { "inboxen.org", true },
  { "incendiary-arts.com", true },
  { "incparadise.net", true },
  { "indiecert.net", false },
  { "indievelopment.nl", true },
  { "indovinabank.com.vn", true },
  { "indusfastremit-us.com", true },
  { "indusfastremit.com", true },
  { "indust.me", false },
  { "indybay.org", true },
  { "infcof.com", true },
  { "infilock.com", true },
  { "infinitusgaming.eu", true },
  { "influxus.com", false },
  { "infogrfx.com", true },
  { "informatik.zone", true },
  { "informnapalm.org", true },
  { "infosenior.ch", true },
  { "iniiter.com", true },
  { "inios.fr", true },
  { "initq.net", false },
  { "initrd.net", true },
  { "injigo.com", true },
  { "inkbunny.net", true },
  { "inksay.com", true },
  { "inleaked.com", true },
  { "inmyarea.com", true },
  { "innophate-security.com", true },
  { "innophate-security.nl", true },
  { "innovaptor.at", true },
  { "innovaptor.com", true },
  { "insane.zone", true },
  { "insideaudit.com", true },
  { "insighti.com", true },
  { "insighti.eu", true },
  { "insighti.org", true },
  { "insighti.sk", true },
  { "inspiroinc.com", true },
  { "instant-hack.com", true },
  { "instant.io", true },
  { "instasex.ch", true },
  { "instela.com", true },
  { "institutoflordelavida.com", true },
  { "institutolancaster.com", true },
  { "intarweb.ca", true },
  { "integrationinc.com", false },
  { "integromat.com", true },
  { "intel.li", true },
  { "interaffairs.com", true },
  { "interasistmen.se", true },
  { "interfug.de", true },
  { "interisaudit.com", true },
  { "interlun.com", true },
  { "internetbank.swedbank.se", true },
  { "internetbugbounty.org", true },
  { "internetcasinos.de", true },
  { "internethering.de", true },
  { "interviewpipeline.co.uk", true },
  { "intim-uslugi-kazan.net", true },
  { "intramanager.dk", true },
  { "intranetsec.fr", true },
  { "intxt.net", true },
  { "inusasha.de", true },
  { "investorforms.com", true },
  { "invictusmc.uk", true },
  { "inwestcorp.se", true },
  { "inzdr.com", true },
  { "iocheck.com", false },
  { "iodu.re", true },
  { "ionas-law.ro", false },
  { "ionlabs.kr", true },
  { "ip-life.net", true },
  { "ip6.li", true },
  { "ipcfg.me", true },
  { "ipconsulting.se", true },
  { "ipledgeonline.org", true },
  { "ipomue.com", false },
  { "iprice.co.id", true },
  { "iprice.hk", true },
  { "iprice.my", true },
  { "iprice.ph", true },
  { "iprice.sg", true },
  { "iprice.vn", true },
  { "ipricethailand.com", true },
  { "iprim.ru", true },
  { "ipsec.pl", true },
  { "ipswitch.com.tw", true },
  { "ipv6-adresse.dk", true },
  { "ipv6-handbuch.de", true },
  { "ipv6cloud.club", true },
  { "iqboxy.com", true },
  { "iqualtech.com", true },
  { "iranianlawschool.com", true },
  { "irazimina.ru", true },
  { "ircmett.de", true },
  { "iready.ro", true },
  { "irgit.pl", true },
  { "iridiumbrowser.de", true },
  { "iridiumflare.de", true },
  { "irische-segenswuensche.info", true },
  { "irmag.ru", true },
  { "ironfistdesign.com", true },
  { "isaacman.tech", true },
  { "iseulde.com", true },
  { "isimonbrown.co.uk", true },
  { "isincheck.com", true },
  { "isitamor.pm", true },
  { "isitchristmas.com", true },
  { "isitup.org", true },
  { "iskaron.de", true },
  { "islandhosting.com", true },
  { "isletech.net", true },
  { "isogen5.com", true },
  { "isondo.com", true },
  { "isopres.de", true },
  { "isqrl.de", true },
  { "isreedyintheuk.com", true },
  { "issuesofconcern.in", true },
  { "istanbul.systems", true },
  { "istdieweltschonuntergegangen.de", true },
  { "istheapplestoredown.com", true },
  { "istorrent.is", true },
  { "it-schwerin.de", true },
  { "it.search.yahoo.com", false },
  { "itdashboard.gov", true },
  { "itechgeek.com", true },
  { "iterror.co", true },
  { "itfh.eu", true },
  { "itinsight.hu", true },
  { "itludens.com", true },
  { "itpol.dk", true },
  { "itriskltd.com", true },
  { "its-gutachten.de", true },
  { "its4living.com", true },
  { "itsadog.co.uk", true },
  { "itsagadget.com", true },
  { "itsg-faq.de", true },
  { "itshost.ru", true },
  { "ivancacic.com", true },
  { "ivk.website", true },
  { "ivpn.net", true },
  { "iwalton.com", true },
  { "iwannarefill.com", true },
  { "iwizerunek.pl", true },
  { "ix8.ru", true },
  { "izdiwho.com", true },
  { "j-lsolutions.com", true },
  { "j-navi.com", true },
  { "j0s.eu", true },
  { "j3e.de", true },
  { "jaba.hosting", true },
  { "jabber.at", true },
  { "jacekowski.org", true },
  { "jackdelik.de", true },
  { "jackf.me", true },
  { "jackfahnestock.com", true },
  { "jackyyf.com", false },
  { "jacobhaug.com", true },
  { "jacobparry.ca", false },
  { "jacobphono.com", true },
  { "jacuzziprozone.com", true },
  { "jagerman.com", true },
  { "jagido.de", true },
  { "jahliveradio.com", false },
  { "jahofmann.de", true },
  { "jakenbake.com", true },
  { "jakub-boucek.cz", true },
  { "jakubboucek.cz", true },
  { "james.je", true },
  { "jamesbradach.com", true },
  { "jamesburton.london", true },
  { "jamesbywater.co.uk", true },
  { "jamesbywater.com", true },
  { "jamesbywater.me", true },
  { "jamesbywater.me.uk", true },
  { "jamesbywater.uk", true },
  { "jamesconroyfinn.com", true },
  { "jamesdoell.com", true },
  { "jameshost.net", true },
  { "jamesmaurer.com", true },
  { "jamesmilazzo.com", true },
  { "jamesmorrison.me", true },
  { "jamesrains.com", true },
  { "jamielinux.com", true },
  { "jamiemagee.co.uk", true },
  { "jamiemagee.dk", true },
  { "jamon.ca", true },
  { "jamonsilva.com", true },
  { "janario.me", true },
  { "janoberst.com", true },
  { "janokacer.sk", true },
  { "jaot.info", true },
  { "japaniac.de", true },
  { "jaqen.ch", true },
  { "jaroslavtrsek.cz", true },
  { "jasonamorrow.com", true },
  { "jasonrobinson.me", true },
  { "jasperhammink.com", true },
  { "jastoria.pl", true },
  { "jav-collective.com", true },
  { "jayharris.ca", true },
  { "jayschulman.com", true },
  { "jayscoaching.com", true },
  { "jayshao.com", true },
  { "jazzanet.com", true },
  { "jazzncheese.com", true },
  { "jbbd.fr", true },
  { "jbn.mx", true },
  { "jbradaric.me", true },
  { "jcaicedo.tk", true },
  { "jcoscia.com", true },
  { "jcraft.us", true },
  { "jctf.io", true },
  { "jdubya.info", true },
  { "jean-remy.ch", true },
  { "jeff393.com", true },
  { "jeffcasavant.com", false },
  { "jefftickle.com", true },
  { "jelly.cz", true },
  { "jelmer.co.uk", true },
  { "jelmer.uk", true },
  { "jenjoit.de", true },
  { "jennedebleser.com", false },
  { "jennybeaned.com", true },
  { "jennythebaker.com", true },
  { "jensenbanden.no", true },
  { "jeremiahbenes.com", true },
  { "jeremyness.com", true },
  { "jetmirshatri.com", true },
  { "jetsetcharge.com", true },
  { "jetsieswerda.nl", true },
  { "jettlarue.com", true },
  { "jettshome.org", false },
  { "jeugdkans.nl", true },
  { "jfreitag.de", true },
  { "jgid.de", true },
  { "jh-media.eu", false },
  { "jhalderm.com", true },
  { "jhburton.co.uk", true },
  { "jhburton.uk", true },
  { "jhejderup.me", true },
  { "jie.dance", true },
  { "jikken.de", true },
  { "jimshaver.net", true },
  { "jinbo123.com", false },
  { "jira.com", true },
  { "jirav.io", true },
  { "jitsi.org", false },
  { "jka.io", true },
  { "jkb.pics", true },
  { "jkbuster.com", true },
  { "jkrippen.com", true },
  { "jlkhosting.com", true },
  { "jmdekker.it", true },
  { "jmedved.com", true },
  { "jmk.hu", true },
  { "jn1.me", true },
  { "joakimalgroy.com", true },
  { "jobbkk.com", true },
  { "jobmob.co.il", true },
  { "jobss.co.uk", true },
  { "jodyboucher.com", true },
  { "joelj.org", true },
  { "joepitt.co.uk", true },
  { "joerss.at", true },
  { "jogorama.com.br", true },
  { "johannes.io", true },
  { "johannes.wtf", true },
  { "johners.me", true },
  { "johngallias.com", true },
  { "johnguant.com", true },
  { "johnhgaunt.com", true },
  { "johnmichel.org", true },
  { "johnrom.com", true },
  { "johnverkerk.com", true },
  { "jonasgroth.se", true },
  { "jonaskjodt.com", true },
  { "jonaswitmer.ch", true },
  { "jonathan-apps.com", true },
  { "jondevin.com", true },
  { "jonfor.net", true },
  { "jonlabelle.com", true },
  { "jonn.me", true },
  { "jonnybarnes.uk", true },
  { "jonpads.com", true },
  { "joostrijneveld.nl", true },
  { "jopsens.de", true },
  { "jordanhamilton.me", true },
  { "joretapo.fr", true },
  { "jorgemesa.me", true },
  { "josefjanosec.com", true },
  { "josephrees.uk", true },
  { "joshgrancell.com", true },
  { "joshi.su", true },
  { "joworld.net", true },
  { "joyofcookingandbaking.com", true },
  { "jpbike.cz", true },
  { "jr5devdoug.xyz", true },
  { "jr5devdouglas.xyz", true },
  { "jr5proxdoug.xyz", true },
  { "jrc9.ca", true },
  { "jrgold.me", true },
  { "jrmd.io", true },
  { "jstore.ch", true },
  { "jugendsuenden.info", true },
  { "juhakoho.com", true },
  { "julianmeyer.de", true },
  { "juliansimioni.com", true },
  { "jultube.de", true },
  { "jump.wtf", true },
  { "junaos.xyz", true },
  { "junethack.net", true },
  { "juniwalk.cz", true },
  { "junkdrome.org", true },
  { "junqtion.com", false },
  { "jupp0r.de", true },
  { "jurriaan.ninja", true },
  { "justchunks.net", true },
  { "justyy.com", true },
  { "jvoice.net", true },
  { "jwilsson.com", true },
  { "jwilsson.me", true },
  { "jwnotifier.org", true },
  { "k-dev.de", true },
  { "kachlikova2.cz", true },
  { "kaheim.de", true },
  { "kahopoon.net", true },
  { "kaileymslusser.com", true },
  { "kairion.de", true },
  { "kaisers.de", true },
  { "kakao-karten.de", true },
  { "kakaravaara.fi", true },
  { "kalender.com", true },
  { "kalevlamps.co.uk", true },
  { "kalmar.com", true },
  { "kaloix.de", true },
  { "kamcvicit.sk", true },
  { "kamisama.xyz", true },
  { "kamitech.ch", true },
  { "kamixa.se", true },
  { "kana.me", true },
  { "kanehusky.com", true },
  { "kaneo-gmbh.de", true },
  { "kanna.cf", true },
  { "kanotijd.nl", true },
  { "kantankye.nl", true },
  { "kantanmt.com", true },
  { "kantorosobisty.pl", true },
  { "kanzashi.com", true },
  { "kaplatz.is", true },
  { "kapseli.net", true },
  { "kapucini.si", false },
  { "karaoketonight.com", true },
  { "karateka.org", true },
  { "kardize24.pl", true },
  { "karguine.in", true },
  { "karmaplatform.com", true },
  { "karmaspa.se", true },
  { "kartonmodellbau.org", true },
  { "kassa.at", true },
  { "katekligys.com", true },
  { "katericke.com", true },
  { "katka.info", true },
  { "katyl.info", true },
  { "kau-boys.com", true },
  { "kau-boys.de", true },
  { "kaufberatung.community", true },
  { "kausch.at", true },
  { "kavovary-kava.cz", true },
  { "kawaii.io", false },
  { "kawaiiku.com", true },
  { "kawaiiku.de", true },
  { "kazandaemon.ru", true },
  { "kba-online.de", true },
  { "kbcequitas.hu", true },
  { "kbit.dk", true },
  { "kbjorklu.com", true },
  { "kcolford.com", true },
  { "kd-plus.pp.ua", true },
  { "kdex.de", true },
  { "kdyby.org", true },
  { "ke7tlf.us", true },
  { "keaysmillwork.com", true },
  { "kedarastudios.com", true },
  { "keeleysam.com", true },
  { "keeleysam.me", true },
  { "keepa.com", true },
  { "keepclean.me", true },
  { "keeperapp.com", true },
  { "keepersecurity.com", true },
  { "kefaloniatoday.com", true },
  { "keganthorrez.com", true },
  { "keke-shop.ch", true },
  { "kekku.li", true },
  { "kengilmour.com", true },
  { "kenners.org", true },
  { "keops-spine.fr", true },
  { "keops-spine.us", true },
  { "kerksanders.nl", true },
  { "kermadec.com", true },
  { "kermadec.net", true },
  { "kernel-error.de", true },
  { "kernl.us", true },
  { "keskeces.com", true },
  { "kesteren.com", true },
  { "kesteren.org", true },
  { "ketosecology.co.uk", true },
  { "kevinapease.com", true },
  { "kevinbusse.de", true },
  { "kevincox.ca", true },
  { "keybase.io", true },
  { "keycdn.com", true },
  { "keyerror.com", true },
  { "kg-rating.com", true },
  { "khanovaskola.cz", true },
  { "khetzal.info", true },
  { "khipu.com", true },
  { "khmath.com", true },
  { "ki-on.net", true },
  { "kiano.net", true },
  { "kick-in.nl", true },
  { "kickass.al", true },
  { "kiebel.de", true },
  { "kikuzuki.org", true },
  { "kilianvalkhof.com", true },
  { "kilobyte22.de", true },
  { "kimmel.com", true },
  { "kinderbasar-luhe.de", true },
  { "kinderbuecher-kostenlos.de", true },
  { "kinderwagen-test24.de", true },
  { "kindleworth.com", true },
  { "kindof.ninja", true },
  { "kingant.net", true },
  { "kinganywhere.eu", true },
  { "kingmanhall.org", true },
  { "kinsights.com", false },
  { "kintone.com", true },
  { "kintore.tv", true },
  { "kirara.eu", true },
  { "kirei.se", true },
  { "kirkovsky.com", true },
  { "kirschbaum.me", true },
  { "kirstin-peters.de", true },
  { "kisalt.im", true },
  { "kissart.net", true },
  { "kissflow.com", true },
  { "kitakemon.com", true },
  { "kitsostech.com", true },
  { "kitsta.com", true },
  { "kjaermaxi.me", true },
  { "kjarrval.is", true },
  { "kksg.com", true },
  { "klarmobil-empfehlen.de", true },
  { "klasfauseweh.de", true },
  { "klatschreime.de", true },
  { "klausbrinch.dk", false },
  { "klausimas.lt", true },
  { "klauwd.com", true },
  { "klaxn.com", true },
  { "kle.cz", true },
  { "kleidertauschpartys.de", true },
  { "kleppe.co", true },
  { "kleteckova.cz", true },
  { "klicktojob.de", true },
  { "kliemann.me", true },
  { "klif1.nl", true },
  { "klingeletest.de", true },
  { "km-net.pl", true },
  { "kmkz.jp", true },
  { "knapen.io", true },
  { "knip.ch", true },
  { "knowledgehook.com", true },
  { "knygos.lt", true },
  { "kodokushi.fr", true },
  { "koen.io", true },
  { "koenrouwhorst.nl", true },
  { "koenvdheuvel.me", false },
  { "koerperimpuls.ch", true },
  { "kojima-life.co.jp", true },
  { "kojipkgs.fedoraproject.org", true },
  { "kokenmetaanbiedingen.nl", true },
  { "kollawat.me", true },
  { "kolmann.eu", true },
  { "komandakovalchuk.com", false },
  { "komoju.com", true },
  { "konata.us", true },
  { "konijntjes.nl", true },
  { "konklone.com", true },
  { "konsertoversikt.no", true },
  { "koop-bremen.de", true },
  { "koopjesnel.nl", true },
  { "koot.nl", true },
  { "korinar.com", true },
  { "kornersafe.com", true },
  { "korobi.io", true },
  { "korobkovsky.ru", true },
  { "kosho.org", true },
  { "kostya.net", false },
  { "kotonehoko.net", true },
  { "koukni.cz", true },
  { "kpdyer.com", true },
  { "kpebetka.net", true },
  { "kpinvest.eu", true },
  { "krachtinverbinding.nl", true },
  { "kradalby.no", true },
  { "kraft.im", true },
  { "kraiwan.com", true },
  { "kraiwon.com", true },
  { "kraken.io", true },
  { "krasota.ru", false },
  { "kream.io", true },
  { "kreativstrecke.de", true },
  { "kreavis.com", true },
  { "kredietpaspoort.nl", true },
  { "kredite.sale", true },
  { "kredite24.de", true },
  { "kriegskindernothilfe.de", true },
  { "kriegt.es", true },
  { "krisstarkey.co.uk", true },
  { "kristikala.nl", true },
  { "kristofferkoch.com", true },
  { "krizek.cc", true },
  { "krmela.com", true },
  { "kroetenfuchs.de", true },
  { "kroodle.nl", true },
  { "kropkait.pl", true },
  { "krypsys.com", true },
  { "krypteia.org", true },
  { "kryptera.se", true },
  { "kryx.de", true },
  { "ks-watch.de", true },
  { "kschv-rdeck.de", true },
  { "kubik-rubik.de", true },
  { "kum.com", true },
  { "kumachan.biz", true },
  { "kumasanda.jp", true },
  { "kummerlaender.eu", true },
  { "kunstundunrat.de", true },
  { "kuponrazzi.com", true },
  { "kuppingercole.com", true },
  { "kupschke.net", true },
  { "kura.io", false },
  { "kurehun.org", true },
  { "kurtmclester.com", true },
  { "kuwago.io", true },
  { "kwidz.fr", true },
  { "kwikmed.eu", true },
  { "kyanite.co", true },
  { "kybi.sk", true },
  { "kylinj.com", true },
  { "kynaston.org.uk", true },
  { "kynastonwedding.co.uk", true },
  { "labrador-retrievers.com.au", true },
  { "labradorpuppiesforsalebyregisteredlabradorbreeders.com", true },
  { "labs.directory", true },
  { "labs.moscow", true },
  { "lacasseroy.com", true },
  { "lacentral.com", true },
  { "lacledeslan.com", true },
  { "lacledeslan.ninja", true },
  { "lafkor.de", true },
  { "lagerauftrag.info", true },
  { "laglab.org", true },
  { "lagoza.name", true },
  { "lainchan.org", true },
  { "lakhesis.net", true },
  { "lalaya.fr", true },
  { "lambda-complex.org", true },
  { "lambdafive.co.uk", true },
  { "lamboo.be", true },
  { "laminine.info", true },
  { "lana.swedbank.se", true },
  { "lancejames.com", true },
  { "land.nrw", true },
  { "langatang.com", true },
  { "langenbach.rocks", true },
  { "langendries.eu", true },
  { "langguth.io", true },
  { "langhun.me", true },
  { "laobox.fr", true },
  { "lapetition.be", true },
  { "lapidge.net", true },
  { "largescaleforums.com", true },
  { "larrysalibra.com", true },
  { "larsklene.nl", true },
  { "lasercloud.ml", true },
  { "laserfuchs.de", true },
  { "lashstuff.com", true },
  { "lask.in", true },
  { "lasst-uns-beten.de", true },
  { "lastpass.com", false },
  { "latenitefilms.com", false },
  { "lateralsecurity.com", true },
  { "latitude42technology.com", true },
  { "latrine.cz", true },
  { "laukstein.com", true },
  { "launchkey.com", true },
  { "lavalite.de", true },
  { "lavine.ch", true },
  { "lavval.com", true },
  { "lawformt.com", true },
  { "laxatus.com", true },
  { "laylo.nl", true },
  { "lazurit.com", true },
  { "lb-toner.de", true },
  { "lbayer.com", true },
  { "ldarby.me.uk", true },
  { "leadbook.ru", true },
  { "leakedminecraft.net", true },
  { "leanclub.org", true },
  { "learntube.cz", true },
  { "leatherfurnitureexpo.com", true },
  { "ledhouse.sk", true },
  { "leedev.org", true },
  { "leerliga.de", true },
  { "lega-dental.com", true },
  { "legendofkrystal.com", true },
  { "legoutdesplantes.be", true },
  { "lehighmathcircle.org", true },
  { "leibniz-remscheid.de", true },
  { "leifdreizler.com", true },
  { "leinir.dk", true },
  { "lellyboi.ml", true },
  { "lemoine.at", true },
  { "lemp.io", true },
  { "lence.net", true },
  { "leninalbertop.com.ve", true },
  { "lenn1.de", true },
  { "lenzw.de", true },
  { "leob.in", false },
  { "leolana.com", true },
  { "leominstercu.com", false },
  { "leonardcamacho.me", true },
  { "leonax.net", true },
  { "leonklingele.de", true },
  { "leonmahler.consulting", true },
  { "lepont.pl", true },
  { "leppis-it.de", true },
  { "lerner.moscow", true },
  { "lerp.me", true },
  { "les-corsaires.net", true },
  { "lesdouceursdeliyana.com", true },
  { "lesperlesdunet.fr", true },
  { "letustravel.tk", true },
  { "levendwater.org", true },
  { "levert.ch", true },
  { "levinus.de", true },
  { "lewis.li", true },
  { "lewisjuggins.co.uk", true },
  { "lexway.pk", true },
  { "lhalbert.xyz", true },
  { "liaillustr.at", true },
  { "libertyrp.org", true },
  { "libfte.org", true },
  { "libraryfreedomproject.org", false },
  { "libreboot.org", true },
  { "librelamp.com", true },
  { "libscode.com", true },
  { "libsodium.org", true },
  { "liceserv.com", true },
  { "lichtspot.de", true },
  { "liebel.org", true },
  { "lifeinitsownway.com", true },
  { "light.mail.ru", true },
  { "lighting-centres.co.uk", true },
  { "lightme.us", true },
  { "lightpaste.com", true },
  { "lightspeed.com", false },
  { "lillepuu.com", true },
  { "lilpwny.com", true },
  { "limeyeti.com", true },
  { "limitededitioncomputers.com", true },
  { "limitededitionsolutions.com", true },
  { "limpid.nl", true },
  { "limpido.it", true },
  { "lindberg.io", true },
  { "lingolia.com", true },
  { "linguatrip.com", false },
  { "link.ba", true },
  { "linkages.org", true },
  { "linkenheil.org", true },
  { "linkmaker.co.uk", true },
  { "linkonaut.net", true },
  { "linode.com", false },
  { "linorman1997.me", true },
  { "linpx.com", true },
  { "linux-admin-california.com", true },
  { "linux.cn", true },
  { "linux.fi", true },
  { "linuxbierwanderung.com", true },
  { "linuxcommand.ru", true },
  { "linuxgeek.ro", true },
  { "linuxlounge.net", true },
  { "linuxmonitoring.net", true },
  { "linx.li", true },
  { "linzgau.de", true },
  { "liquid.cz", true },
  { "liquidcomm.net", true },
  { "liquorsanthe.in", true },
  { "liris-beautywelt.de", true },
  { "listafirmelor.com", true },
  { "lists.fedoraproject.org", true },
  { "lists.mayfirst.org", false },
  { "lists.stg.fedoraproject.org", true },
  { "litchidova.nl", true },
  { "litespeed.io", true },
  { "lithesalar.se", true },
  { "little.pw", true },
  { "litvideoserver.de", true },
  { "liud.im", true },
  { "livedemo.io", true },
  { "liveforspeed.se", true },
  { "livej.am", true },
  { "livekaarten.nl", true },
  { "liverewrite.com", true },
  { "livnev.me", true },
  { "ljs.io", true },
  { "lloyd-day.me", true },
  { "lmddgtfy.net", true },
  { "lmintlcx.com", true },
  { "lmmtfy.io", true },
  { "lmsptfy.com", true },
  { "lntu.org", true },
  { "lnx.li", true },
  { "loancompare.co.za", true },
  { "lobste.rs", true },
  { "localbandz.com", true },
  { "localchum.com", true },
  { "lockify.com", true },
  { "locktheirphone.com", true },
  { "locomore.com", true },
  { "locomotive.ca", true },
  { "lodash.com", true },
  { "loftboard.eu", true },
  { "logement-saisonnier.com", true },
  { "logentries.com", false },
  { "logfile.at", true },
  { "logicsale.com", true },
  { "logicsale.de", true },
  { "logicsale.fr", true },
  { "logicsale.it", true },
  { "login.corp.google.com", true },
  { "login.launchpad.net", true },
  { "login.persona.org", true },
  { "login.sapo.pt", true },
  { "login.ubuntu.com", true },
  { "login.xero.com", false },
  { "login.yahoo.com", false },
  { "loginseite.com", true },
  { "lognot.net", true },
  { "logopaediereinhard.de", true },
  { "logopoeia.com", true },
  { "lokaal.org", true },
  { "loli.bz", true },
  { "lolicore.ch", true },
  { "lolpatrol.de", true },
  { "lonal.com", true },
  { "lookout.com", false },
  { "lookyman.net", true },
  { "loony.info", true },
  { "loopstart.org", true },
  { "lore.azurewebsites.net", true },
  { "lostinsecurity.com", true },
  { "lothai.re", false },
  { "loucanfixit.com", true },
  { "lovelifelovelive.com", true },
  { "lovemomiji.com", true },
  { "loveto.at", true },
  { "lovingearth.net", true },
  { "lpak.nl", true },
  { "lpm-uk.com", true },
  { "lrhstsa.com", true },
  { "ls-a.org", true },
  { "ltn-tom-morel.fr", true },
  { "luchscheider.de", true },
  { "lucielavickova.com", true },
  { "ludwig.im", true },
  { "luehne.de", true },
  { "luelistan.net", true },
  { "lufthansaexperts.com", true },
  { "lugbb.org", true },
  { "luis-checa.com", true },
  { "lukas.im", true },
  { "lukasberan.cz", true },
  { "lukasunger.cz", true },
  { "lukasunger.net", true },
  { "lukasztkacz.com", true },
  { "lumi.do", false },
  { "lumiere.com", true },
  { "lunakit.org", true },
  { "lunarift.com", true },
  { "lunarshark.com", true },
  { "luneta.nearbuysystems.com", false },
  { "lunix.io", true },
  { "luom.net", true },
  { "lustrumxi.nl", true },
  { "luther.fi", true },
  { "luukklene.nl", true },
  { "luxwatch.com", true },
  { "lv0.it", true },
  { "lvrsystems.com", true },
  { "lymia.moe", true },
  { "lyness.io", true },
  { "lynkos.com", true },
  { "lyst.co.uk", true },
  { "lyx.dk", true },
  { "lzzr.me", true },
  { "m.facebook.com", false },
  { "m.mail.ru", true },
  { "m.nu", true },
  { "m0wef.uk", true },
  { "ma2t.com", true },
  { "maarten.nyc", true },
  { "maartenvandekamp.nl", true },
  { "mac-torrents.me", true },
  { "macchaberrycream.com", true },
  { "macgeneral.de", true },
  { "mach-politik.ch", true },
  { "machbach.com", true },
  { "macker.io", true },
  { "maclemon.at", true },
  { "macleod.io", true },
  { "maco.org.uk", true },
  { "madars.org", true },
  { "madebymagnitude.com", true },
  { "madeitwor.se", true },
  { "madnetwork.org", true },
  { "madrants.net", true },
  { "madtec.de", true },
  { "maelstrom.ninja", true },
  { "mafamane.com", true },
  { "maff.scot", false },
  { "magneticanvil.com", true },
  { "mahamed91.pw", true },
  { "mahefa.co.uk", true },
  { "mail-settings.google.com", true },
  { "mail.de", true },
  { "mail.google.com", true },
  { "mail.yahoo.com", false },
  { "mail4you.in", true },
  { "mailbox.org", true },
  { "mailchuck.com", true },
  { "maildragon.com", true },
  { "mailer-dot.de", true },
  { "mailgarant.nl", true },
  { "mailinabox.email", true },
  { "mailmag.net", true },
  { "mainlywrenches.co", true },
  { "majesnix.org", true },
  { "make-pizza.info", true },
  { "makeitdynamic.com", true },
  { "makeyourlaws.org", true },
  { "makowitz.cz", true },
  { "maktoob.search.yahoo.com", false },
  { "malash.me", true },
  { "malaysia.search.yahoo.com", false },
  { "malfait.nl", true },
  { "malinator.net", true },
  { "mall.cz", true },
  { "mall.hr", true },
  { "mall.hu", true },
  { "mall.pl", true },
  { "mall.sk", true },
  { "malnex.de", true },
  { "malwaretips.com", true },
  { "malwre.io", true },
  { "mammaw.com", true },
  { "mammothmail.com", true },
  { "mammothmail.net", true },
  { "mammothmail.org", true },
  { "man3s.jp", true },
  { "manage.cm", true },
  { "manage.zenpayroll.com", false },
  { "management-companie.ro", true },
  { "managemynetsuite.com", true },
  { "manageprojects.com", true },
  { "manager.linode.com", false },
  { "mandala-ausmalbilder.de", true },
  { "manfredimatteo.com", true },
  { "manicode.com", true },
  { "manoirdecontres.com", true },
  { "manowarus.com", true },
  { "mantor.org", false },
  { "manueli.de", true },
  { "maowtm.org", true },
  { "marbogardenlidkoping.se", true },
  { "marcelpreuss.de", true },
  { "marcoececilia.it", true },
  { "marcofinke.de", true },
  { "marcohager.de", true },
  { "marcoslater.com", true },
  { "mareklecian.cz", true },
  { "mariaolesen.dk", true },
  { "marie-curie.fr", true },
  { "marie.club", true },
  { "marikafranke.de", true },
  { "marilsnijders.nl", true },
  { "mark-semmler.de", true },
  { "markaconnor.com", true },
  { "markayapilandirma.com", true },
  { "market.android.com", true },
  { "markhaehnel.de", false },
  { "markprof.ru", true },
  { "markrego.com", true },
  { "markri.nl", true },
  { "marktboten.de", true },
  { "marktcontact.com", true },
  { "markusehrlicher.de", true },
  { "markusueberallassetmanagement.de", true },
  { "marlen.cz", true },
  { "marsble.com", true },
  { "marshut.net", true },
  { "martelange.ovh", true },
  { "martiert.com", true },
  { "martijnvhoof.nl", true },
  { "martineve.com", true },
  { "martinkus.eu", true },
  { "martinp.no", true },
  { "marumagic.com", true },
  { "masa-yoga.com", true },
  { "mascosolutions.com", true },
  { "masjidtawheed.net", true },
  { "massdrop.com", true },
  { "massivum.de", false },
  { "masterhaus.bg", true },
  { "masters.black", true },
  { "matatall.com", false },
  { "mathhire.org", true },
  { "mathiasbynens.be", true },
  { "mathiasgarbe.de", true },
  { "matrip.de", true },
  { "matrix.ac", true },
  { "matspar.com", true },
  { "matspar.se", true },
  { "matt.tf", true },
  { "mattandreko.com", true },
  { "mattberryman.com", false },
  { "matteomarescotti.it", true },
  { "mattfin.ch", true },
  { "matthewohare.com", true },
  { "matthewprenger.com", true },
  { "matthiasschwab.de", true },
  { "mattia98.org", true },
  { "mattmccutchen.net", true },
  { "mattsvensson.com", true },
  { "mattwb65.com", true },
  { "matze.co", true },
  { "maultrom.ml", true },
  { "mavenclinic.com", true },
  { "mavensecurity.com", true },
  { "maveris.com", true },
  { "mavisang.cf", true },
  { "mawe.red", true },
  { "max-moeglich.de", true },
  { "max.gov", true },
  { "maximeferon.fr", true },
  { "maximelouet.me", true },
  { "maximilian-greger.com", true },
  { "maxserver.com", true },
  { "maxwell-english.co.jp", false },
  { "mazz-tech.com", true },
  { "mbasic.facebook.com", false },
  { "mbilker.us", true },
  { "mbinf.de", true },
  { "mblankhorst.nl", true },
  { "mbp.banking.co.at", false },
  { "mbweir.com", true },
  { "mc-venture.net", false },
  { "mca2017.org", true },
  { "mcard.vn", true },
  { "mcatnnlo.org", true },
  { "mcdonalds.ru", true },
  { "mce55.eu", true },
  { "mcgarderen.nl", true },
  { "mchristopher.com", true },
  { "mcl.gg", true },
  { "mclab.su", false },
  { "mcnext.net", true },
  { "mcpart.land", true },
  { "mcrn.jp", true },
  { "mctherealm.net", true },
  { "md5file.com", true },
  { "mdek.at", true },
  { "me.net.nz", true },
  { "meadowviewfarms.org", true },
  { "mealgoo.com", true },
  { "meamod.com", true },
  { "meap.xyz", true },
  { "mebio.us", false },
  { "medallia.io", true },
  { "meddelare.com", true },
  { "medexpress.co.uk", true },
  { "media-courses.com", true },
  { "mediastorm.us", true },
  { "mediawiki.org", true },
  { "mediawikicn.org", true },
  { "medirich.co", true },
  { "meditek-dv.ru", true },
  { "medium.com", true },
  { "medo64.com", true },
  { "medovea.ru", true },
  { "medtehnika.ua", true },
  { "medusa.wtf", true },
  { "meetfinch.com", true },
  { "meetingmanage.nl", true },
  { "meetscompany.jp", true },
  { "mega.co.nz", true },
  { "mega.nz", true },
  { "megaplan.cz", true },
  { "megaplan.ru", true },
  { "megasslstore.com", true },
  { "meghudson.com", true },
  { "mehmetince.net", true },
  { "meifrench.com", true },
  { "mein-gesundheitsmanager.com", true },
  { "meinebo.it", true },
  { "meizufans.eu", false },
  { "melcher.it", true },
  { "melf.nl", true },
  { "melitopol.co.ua", true },
  { "melnikov.ch", true },
  { "melted.pw", true },
  { "memberpress.com", true },
  { "members.nearlyfreespeech.net", false },
  { "memo-linux.com", true },
  { "mentax.net", false },
  { "meozcraft.com", false },
  { "mercamaris.es", true },
  { "merccorp.de", true },
  { "mercuryamericas.com", true },
  { "mercurystorm.co.za", true },
  { "mereckas.com", true },
  { "meritz.rocks", true },
  { "merson.me", true },
  { "mertcangokgoz.com", true },
  { "mesmoque.com", true },
  { "mesvt.com", true },
  { "meta-db.com", true },
  { "meta.sc", true },
  { "metapeen.nl", true },
  { "metebalci.com", true },
  { "meteosky.net", true },
  { "metin2blog.de", true },
  { "metrobriefs.com", true },
  { "mevs.cz", true },
  { "mexicansbook.ru", false },
  { "mfcatalin.com", true },
  { "mfiles.pl", true },
  { "mh-bloemen.co.jp", true },
  { "mhertel.com", false },
  { "mhict.nl", true },
  { "mhx.pw", true },
  { "miasarafina.de", true },
  { "michaelcullen.name", true },
  { "michaelleibundgut.com", true },
  { "michaeltroger.com", true },
  { "michalborka.cz", true },
  { "michalspacek.cz", true },
  { "michasfahrschule.com", true },
  { "michel-wein.de", true },
  { "miconcinemas.com", true },
  { "miconware.de", true },
  { "microme.ga", true },
  { "microvb.com", true },
  { "midonet.org", true },
  { "midwestwomenworkers.org", true },
  { "mig5.net", true },
  { "mightysounds.cz", true },
  { "mijailovic.net", true },
  { "mijcorijneveld.nl", true },
  { "mijn-email.org", true },
  { "mijnkredietpaspoort.nl", true },
  { "mikadoe.nl", true },
  { "mikaela.info", true },
  { "mikaelemilsson.net", true },
  { "mike-bland.com", true },
  { "mikepair.net", true },
  { "miketabor.com", true },
  { "mikewest.org", true },
  { "mikewillia.ms", true },
  { "mikeybot.com", true },
  { "miku.be", true },
  { "milahendri.com", false },
  { "milanpala.cz", true },
  { "millistream.com", true },
  { "mim.properties", true },
  { "mimeit.de", true },
  { "mimovrste.com", true },
  { "mind-moves.es", true },
  { "mindcoding.ro", true },
  { "minecraft-forum.cf", true },
  { "minecraft-forum.ga", true },
  { "minecraft-forum.gq", true },
  { "minecraft-forum.ml", true },
  { "minecraft-forums.cf", true },
  { "minecraft-forums.ga", true },
  { "minecraft-forums.gq", true },
  { "minecraftforum.de", true },
  { "minecraftforum.ovh", true },
  { "minecraftforums.cf", true },
  { "minecraftforums.gq", true },
  { "minecraftforums.ml", true },
  { "minecraftvoter.com", true },
  { "mineover.es", true },
  { "minez-nightswatch.com", false },
  { "minikneet.com", true },
  { "minkondom.nu", true },
  { "minnesotadata.com", true },
  { "minpingvin.dk", true },
  { "mintea-noua.ro", true },
  { "mintrak2.com", true },
  { "mirodasilva.be", true },
  { "mironet.cz", true },
  { "mirtes.cz", true },
  { "miskatonic.org", true },
  { "miss-inventory.co.uk", true },
  { "missdream.org", true },
  { "misskey.xyz", true },
  { "mistacms.com", true },
  { "mister.hosting", true },
  { "misterl.net", true },
  { "mitchellrenouf.ca", true },
  { "mitell.jp", false },
  { "mitnetz-strom.de", true },
  { "mittelunsachlich.de", true },
  { "mittenhacks.com", true },
  { "mitzpettel.com", true },
  { "mizd.at", true },
  { "mjanja.ch", true },
  { "mjec.net", true },
  { "mkcert.org", true },
  { "mkw.st", true },
  { "mlemay.com", true },
  { "mlp.ee", true },
  { "mlpepilepsy.org", true },
  { "mmonit.com", true },
  { "mmucha.de", true },
  { "mnd.sc", true },
  { "mnetworkingsolutions.co.uk", true },
  { "mnium.de", true },
  { "mnsure.org", true },
  { "mobal.com", true },
  { "mobidea.com", true },
  { "mobilcom-debitel-empfehlen.de", true },
  { "mobile.eti.br", true },
  { "mobile.united.com", false },
  { "mobile.usaa.com", false },
  { "mobilemedics.com", true },
  { "mobiletraff.co", true },
  { "mobilpass.no", true },
  { "mobilux.lv", true },
  { "mobobe.com", true },
  { "mobocasino.com", false },
  { "mocloud.eu", true },
  { "modeldimension.com", true },
  { "modmountain.com", true },
  { "modydev.club", true },
  { "moen.io", true },
  { "mojaknjiznica.com", false },
  { "mojapraca.sk", true },
  { "mokhtarmial.com", true },
  { "mokote.com", true },
  { "mondwandler.de", true },
  { "moneromerchant.com", true },
  { "moniquedekermadec.com", true },
  { "monitman.solutions", true },
  { "monitzer.com", true },
  { "monix.io", true },
  { "monnyonle.hu", true },
  { "monobank.no", true },
  { "moonloupe.com", true },
  { "moonraptor.com", true },
  { "moparcraft.com", true },
  { "moparcraft.net", true },
  { "moparcraft.org", true },
  { "moparisthebest.biz", true },
  { "moparisthebest.com", true },
  { "moparisthebest.info", true },
  { "moparisthebest.net", true },
  { "moparisthebest.org", true },
  { "moparscape.org", true },
  { "morbatex.com", true },
  { "morbitzer.de", true },
  { "moreapp.co.uk", true },
  { "morenci.ch", true },
  { "morethanadream.lv", true },
  { "morganino.eu", true },
  { "morganino.it", true },
  { "moriz.de", true },
  { "morningcalculation.com", true },
  { "mornings.com", true },
  { "morteruelo.net", true },
  { "mosstier.com", true },
  { "motd.ch", true },
  { "mothereff.in", true },
  { "motionpicturesolutions.com", true },
  { "motocyklovedily.cz", true },
  { "moula.com.au", false },
  { "mountainmusicpromotions.com", true },
  { "mountainroseherbs.com", true },
  { "moveek.com", true },
  { "movember.com", true },
  { "moviedollars.com", true },
  { "movlib.org", true },
  { "moy-gorod.od.ua", false },
  { "mozoa.net", true },
  { "mp3gratuiti.com", true },
  { "mp3juices.is", true },
  { "mpac.ca", true },
  { "mpc-hc.org", true },
  { "mpetroff.net", true },
  { "mpintaamalabanna.it", true },
  { "mplusm.eu", true },
  { "mpreserver.com", true },
  { "mqas.net", true },
  { "mr-hosting.com", true },
  { "mremallin.ca", true },
  { "mrettich.org", true },
  { "mrs-shop.com", true },
  { "msa-aesch.ch", true },
  { "msebera.cz", true },
  { "msmails.de", true },
  { "mt.me.uk", true },
  { "mtamaki.com", true },
  { "mtasa.com", true },
  { "mtau.com", true },
  { "mtg-tutor.de", true },
  { "mthode.org", true },
  { "mths.be", true },
  { "mtnz.co.za", true },
  { "mtouch.facebook.com", false },
  { "muabannhanh.com", true },
  { "mudcrab.us", true },
  { "muguayuan.com", true },
  { "mujadin.se", false },
  { "multigamecard.com", true },
  { "multigeist.de", true },
  { "multitheftauto.com", true },
  { "munich-rage.de", true },
  { "munki.org", true },
  { "munuc.org", true },
  { "muriburi.land", true },
  { "murraycoin.org", true },
  { "muscleangels.com", true },
  { "mushikabu.net", true },
  { "musi.cx", true },
  { "musicgamegalaxy.de", true },
  { "musicwear.cz", true },
  { "musikkfondene.no", true },
  { "musmann.io", true },
  { "musthavesforreal.com", true },
  { "mutamatic.com", true },
  { "mutantmonkey.in", true },
  { "mutantmonkey.info", true },
  { "mutantmonkey.sexy", true },
  { "mutuelle.fr", true },
  { "mvanmarketing.nl", true },
  { "mvixturismo.com.br", true },
  { "mvno.io", true },
  { "mvsecurity.nl", true },
  { "mwavuli.co.ke", true },
  { "mwe.st", true },
  { "mx.search.yahoo.com", false },
  { "my-pawnshop.com.ua", true },
  { "my.onlime.ch", false },
  { "my.swedbank.se", true },
  { "my.usa.gov", false },
  { "my.xero.com", false },
  { "myaccount.google.com", true },
  { "mybeautyjobs.de", true },
  { "mybudget.xyz", true },
  { "mycieokien.info", true },
  { "myclientsplus.com", true },
  { "myconan.net", true },
  { "mydeos.com", false },
  { "myg21.com", true },
  { "mygadgetguardian.lookout.com", false },
  { "mygreatjobs.de", true },
  { "mygretchen.de", true },
  { "myhostname.net", true },
  { "myiocc.org", true },
  { "mykontool.de", true },
  { "mylookout.com", false },
  { "myni.io", true },
  { "mynigma.org", true },
  { "myonline.hu", true },
  { "mypagella.com", true },
  { "mypagella.eu", true },
  { "mypagella.it", true },
  { "myplaceonline.com", true },
  { "myprintcard.de", true },
  { "myraytech.net", false },
  { "mysecretcase.com", true },
  { "mysecretrewards.com", true },
  { "myshirtsize.com", true },
  { "mysmelly.com", true },
  { "mysoundtalks.com", true },
  { "mytty.net", true },
  { "mytweeps.com", true },
  { "myvpl.com", true },
  { "myworkinfo.com", true },
  { "myzina.cz", false },
  { "myzone.com", true },
  { "mziulu.me", true },
  { "n-pix.com", false },
  { "n2x.in", false },
  { "nabru.co.uk", true },
  { "nabytko.cz", true },
  { "nachsendeauftrag.net", true },
  { "nachsenden.info", true },
  { "nagb.gov", true },
  { "nagb.org", true },
  { "nagelfam.com", true },
  { "nagoya-kyuyo.com", true },
  { "najedlo.sk", true },
  { "nakedalarmclock.me", true },
  { "nakliyatsirketi.biz", true },
  { "nalao-company.com", true },
  { "namacindia.com", true },
  { "nameid.org", true },
  { "namepros.com", true },
  { "nametiles.co", true },
  { "naminam.de", true },
  { "namorico.me", false },
  { "nan.zone", true },
  { "nanderson.me", true },
  { "nanogeneinc.com", true },
  { "nanogi.ga", true },
  { "nansay.cn", true },
  { "narach.com", true },
  { "narfation.org", true },
  { "narodniki.com", true },
  { "narthollis.net", true },
  { "nathancheek.com", true },
  { "nathanmfarrugia.com", true },
  { "nationalpriorities.org", true },
  { "natuurbehangnederland.nl", true },
  { "naval.tf", true },
  { "navjobs.com", true },
  { "navstevnik.sk", true },
  { "navycs.com", true },
  { "nayahe.ru", true },
  { "nb.zone", true },
  { "nbg-ha.de", false },
  { "nbl.org.tw", true },
  { "ncc60205.info", true },
  { "ncrmnt.org", true },
  { "nct.org.uk", true },
  { "ndarville.com", true },
  { "ndbt.com", true },
  { "nder.be", true },
  { "ne-on.org", true },
  { "ne1home.dyndns.org", true },
  { "neap.io", false },
  { "nearby.in.th", true },
  { "necesitodinero.org", true },
  { "nectarleaf.com", true },
  { "nedcdata.org", true },
  { "nedraconsult.ru", true },
  { "neel.ch", true },
  { "neg9.org", false },
  { "negai.moe", true },
  { "neilwynne.com", false },
  { "neko-life.com", true },
  { "neko.li", true },
  { "nekomimi.pl", false },
  { "nekosc.com", true },
  { "nella-project.org", true },
  { "nellacms.com", true },
  { "nellacms.org", true },
  { "nellafw.org", true },
  { "nemno.de", true },
  { "neosolution.ca", true },
  { "nerdjokes.de", true },
  { "nerdydev.net", true },
  { "neris.io", true },
  { "nerull7.info", true },
  { "nestedquotes.ca", true },
  { "net-safe.info", true },
  { "netbox.cc", true },
  { "netbrief.ml", true },
  { "netera.se", true },
  { "netfxharmonics.com", false },
  { "nethackwiki.com", true },
  { "netherwind.eu", true },
  { "netlocal.ru", true },
  { "netmagik.com", true },
  { "netprofile.com.au", true },
  { "netrelay.email", true },
  { "netrider.net.au", false },
  { "netsight.org", true },
  { "netsparker.com", false },
  { "netsystems.pro", true },
  { "nette.org", true },
  { "nettefoundation.com", true },
  { "nettools.link", true },
  { "nettopower.dk", true },
  { "netulo.com", true },
  { "netvizura.co.uk", true },
  { "netwarc.nl", true },
  { "network-notes.com", true },
  { "network23.nl", true },
  { "netzvieh.de", true },
  { "neueonlinecasino2016.com", true },
  { "neuralgic.net", true },
  { "neutralox.com", true },
  { "neuwal.com", true },
  { "nevadafiber.net", true },
  { "neveta.com", true },
  { "new-black-order.com", true },
  { "newmediaone.net", true },
  { "newodesign.com", true },
  { "newportpropertygroup.com", true },
  { "newstarnootropics.com", true },
  { "nex.sx", true },
  { "nexlab.org", true },
  { "nextend.net", true },
  { "nfo.so", true },
  { "ng-security.com", true },
  { "nginxnudes.com", true },
  { "nichthelfer.de", true },
  { "nickloose.de", true },
  { "nickrickard.co.uk", true },
  { "nicky.io", true },
  { "nicoborghuis.nl", true },
  { "nicoknibbe.nl", true },
  { "nicolaeiotcu.ro", true },
  { "nicolaelmer.ch", true },
  { "nicolaw.uk", true },
  { "nidux.com", true },
  { "nieselregen.com", false },
  { "niftiestsoftware.com", true },
  { "nightfirec.at", true },
  { "nijm.nl", true },
  { "nikao-tech.com", true },
  { "nikobradshaw.com", true },
  { "nikolasbradshaw.com", true },
  { "nikomo.fi", true },
  { "niloxy.com", true },
  { "nilrem.org", true },
  { "ninchat.com", true },
  { "nitho.me", true },
  { "nkinka.de", true },
  { "nl.search.yahoo.com", false },
  { "nmctest.net", true },
  { "nmd.so", true },
  { "nnya.cat", true },
  { "no.search.yahoo.com", false },
  { "nobly.de", true },
  { "nocit.dk", true },
  { "nodari.com.ar", true },
  { "nodebrewery.com", true },
  { "nodelia.com", true },
  { "noemax.com", true },
  { "nohats.ca", true },
  { "nohup.se", true },
  { "noima.com", true },
  { "noisetrap.cz", true },
  { "nojestorget.se", true },
  { "nolaviz.org", true },
  { "nolberg.net", true },
  { "nolte.work", true },
  { "nomadproject.io", true },
  { "nomial.co.uk", true },
  { "nomorebytes.de", true },
  { "noname-ev.de", true },
  { "noob-box.net", true },
  { "noop.ch", true },
  { "noordsee.de", true },
  { "nopex.no", true },
  { "nopol.de", true },
  { "norandom.com", true },
  { "norb.at", true },
  { "northcutt.com", true },
  { "northernmuscle.ca", true },
  { "nos-medias.fr", true },
  { "nos-oignons.net", false },
  { "nostraforma.com", false },
  { "notadd.com", true },
  { "notalone.gov", true },
  { "notjustbitchy.com", true },
  { "nottheonion.net", true },
  { "nouvelle-vague-saint-cast.fr", true },
  { "novacoast.com", true },
  { "novafreixo.pt", true },
  { "novelfeed.com", true },
  { "nowhere.dk", true },
  { "noxlogic.nl", true },
  { "npmcdn.com", true },
  { "npw.net", true },
  { "nsboston.org", true },
  { "nsboutique.com", true },
  { "nshost.ro", true },
  { "nsweb.solutions", false },
  { "ntbs.pro", true },
  { "ntppool.org", true },
  { "null-sec.ru", true },
  { "null.tips", true },
  { "number.me", true },
  { "numberoneshoes.co.nz", true },
  { "nuos.org", true },
  { "nusatrip-api.com", true },
  { "nutrienti.eu", true },
  { "nutritionculture.com", true },
  { "nuvini.com", true },
  { "nuxer.fr", true },
  { "nvlop.xyz", true },
  { "nwa.xyz", true },
  { "nwgh.org", true },
  { "nyan.it", true },
  { "nyantec.com", true },
  { "nyffo.com", false },
  { "nyiad.edu", true },
  { "nyip.edu", true },
  { "nymphetomania.net", true },
  { "nyyu.tk", true },
  { "o6asan.com", true },
  { "oaic.gov.au", true },
  { "oakslighting.co.uk", true },
  { "oasis.mobi", true },
  { "obdolbacca.ru", true },
  { "obermeiers.eu", true },
  { "obscuredfiles.com", false },
  { "obsydian.org", false },
  { "oceandns.eu", true },
  { "oceandns.net", true },
  { "oceandns.nl", true },
  { "ochsundjunior.ch", true },
  { "ocotg.com", true },
  { "ocrami.us", true },
  { "octav.name", true },
  { "octothorpe.club", true },
  { "odin.xxx", true },
  { "ofcourselanguages.com", true },
  { "offshoot.rentals", true },
  { "offshore-firma.org", true },
  { "oftn.org", true },
  { "oguya.ch", true },
  { "ohling.org", true },
  { "ohnemusik.com", true },
  { "oiepoie.nl", true },
  { "okane.love", true },
  { "okhrana.agency", true },
  { "okmx.de", true },
  { "okok-rent.com", true },
  { "okok.rent", true },
  { "okonetwork.org.uk", true },
  { "olafnorge.de", true },
  { "olivierlemoal.fr", true },
  { "ollie.io", true },
  { "olliespage.net", true },
  { "ollning.com", true },
  { "olmari.fi", true },
  { "ols.io", true },
  { "omacostudio.com", true },
  { "omgaanmetidealen.com", true },
  { "omifind.com", true },
  { "omitech.co.uk", true },
  { "onaboat.se", true },
  { "ondrej.org", true },
  { "one---line.com", true },
  { "onedot.nl", true },
  { "onedrive.com", true },
  { "onedrive.live.com", false },
  { "onehourloan.sg", true },
  { "onespiritinc.com", true },
  { "onet.space", true },
  { "oneway.ga", true },
  { "onewebdev.info", true },
  { "onixcco.com.br", true },
  { "online-bouwmaterialen.nl", true },
  { "online.swedbank.se", true },
  { "onlinecensorship.org", true },
  { "onlinedemo.hu", true },
  { "onlinekasino.de", true },
  { "onlinelegalmarketing.com", true },
  { "onlinelegalmedia.com", true },
  { "onlinespielothek.com", true },
  { "onlinewetten.de", true },
  { "only-roses.com", true },
  { "onlyshopstation.com", true },
  { "onmarketbookbuilds.com", true },
  { "ono.es", true },
  { "onqproductions.com", true },
  { "onsitemassageco.com", true },
  { "onthebriteside.com", true },
  { "ontimestamp.com", true },
  { "onvori.com", true },
  { "onvori.de", true },
  { "ooonja.de", true },
  { "oopsmycase.com", true },
  { "oost.io", true },
  { "open-bs.com", true },
  { "open-bs.ru", true },
  { "open-mesh.org", true },
  { "openacademies.com", true },
  { "openkvk.nl", true },
  { "opennippon.com", true },
  { "opennippon.ru", true },
  { "openpriv.pw", true },
  { "openstreetmap.is", true },
  { "opentrack.info", true },
  { "opentrash.org", true },
  { "openverse.com", true },
  { "openvz.org", true },
  { "openxmpp.com", true },
  { "opium.io", true },
  { "oplop.appspot.com", true },
  { "opperwall.net", true },
  { "opq.pw", true },
  { "oprechtgezegd.nl", true },
  { "opsbears.com", true },
  { "opsmate.com", false },
  { "optimus.io", true },
  { "optmos.at", true },
  { "optumrxhealthstore.com", true },
  { "opus-codium.fr", true },
  { "orangutan-appeal.org.uk", true },
  { "orbitcom.de", true },
  { "orbograph-hrcm.com", true },
  { "orcahq.com", true },
  { "orcamoney.com", true },
  { "orderswift.com", true },
  { "orf-digitalsatkarte.at", true },
  { "orf-kartentausch.at", true },
  { "organic-superfood.net", true },
  { "oricejoc.com", true },
  { "orionfcu.com", true },
  { "orlives.de", true },
  { "oscarvk.ch", true },
  { "oscsdp.cz", true },
  { "oshayr.com", true },
  { "osm.is", true },
  { "osmosis.org", true },
  { "osquery.io", true },
  { "ossbinaries.com", true },
  { "ostendorf.com", true },
  { "osterkraenzchen.de", true },
  { "osticketawesome.com", true },
  { "oszri.hu", true },
  { "otakurepublic.com", true },
  { "otchecker.com", true },
  { "otoy.com", true },
  { "otrsdemo.hu", true },
  { "ottoproject.io", true },
  { "ourcloud.at", true },
  { "ourevents.net", true },
  { "outdoorproducts.com", true },
  { "outetc.com", true },
  { "ovenapp.io", true },
  { "overclockers.ge", true },
  { "overkillshop.com", true },
  { "override.io", true },
  { "overseamusic.de", true },
  { "oversight.garden", true },
  { "oversight.io", true },
  { "owncloud.help", true },
  { "ownmovies.fr", true },
  { "oxygaming.com", true },
  { "oxymc.com", true },
  { "oxynux.fr", true },
  { "ozvolvo.org", true },
  { "p.linode.com", false },
  { "p1c.pw", true },
  { "p3in.com", true },
  { "p8r.de", true },
  { "pace.car", true },
  { "packagist.org", false },
  { "packer.io", true },
  { "pacoda.de", true },
  { "pactf.com", true },
  { "pagerate.io", true },
  { "pagewizz.com", true },
  { "paginapolitica.ro", true },
  { "pagure.io", true },
  { "pagure.org", true },
  { "pahae.de", true },
  { "pajonzeck.de", true },
  { "pajuvuo.fi", true },
  { "pakke.de", true },
  { "paku.me", true },
  { "palatin.at", true },
  { "palationtrade.com", true },
  { "palava.tv", true },
  { "pamplona.tv", true },
  { "pamsoft.pl", true },
  { "pan.digital", true },
  { "panaceallc.net", true },
  { "panamaequity.com", true },
  { "panamateakforestry.com", true },
  { "paneu.de", true },
  { "panmetro.com", true },
  { "panoti.com", true },
  { "panthur.com.au", false },
  { "pantou.org", true },
  { "pantsu.cat", true },
  { "pap.la", false },
  { "papayapythons.com", true },
  { "paradoxdesigns.org", true },
  { "paragonie.com", true },
  { "paranoxer.hu", true },
  { "parasitologyclub.org", true },
  { "paratlan.hu", true },
  { "parent5446.us", true },
  { "pariga.co.uk", true },
  { "parithy.net", true },
  { "parkingplus.co.il", true },
  { "parkingpoint.co.uk", true },
  { "parsemail.org", true },
  { "particonpsplus.it", true },
  { "partirkyoto.jp", true },
  { "partyhaus.ovh", true },
  { "partyvan.eu", true },
  { "partyvan.it", true },
  { "partyvan.moe", true },
  { "partyvan.nl", true },
  { "partyvan.se", true },
  { "passieposse.nl", true },
  { "passphrase.today", true },
  { "passport.yandex.by", true },
  { "passport.yandex.com", true },
  { "passport.yandex.com.tr", true },
  { "passport.yandex.kz", true },
  { "passport.yandex.ru", true },
  { "passport.yandex.ua", true },
  { "passwd.io", true },
  { "password.codes", true },
  { "passwordrevelator.net", true },
  { "passwords.google.com", true },
  { "pasta-factory.co.il", true },
  { "paste.linode.com", false },
  { "pastebin.linode.com", false },
  { "pataua.kiwi", true },
  { "patechmasters.com", true },
  { "patriksimek.cz", true },
  { "patt.us", true },
  { "paul.reviews", true },
  { "paulchen.at", true },
  { "paulproell.at", true },
  { "paulschreiber.com", true },
  { "paulyang.cn", true },
  { "pauspam.net", true },
  { "pay.gigahost.dk", true },
  { "pay.ubuntu.com", true },
  { "payfreez.com", true },
  { "paylike.io", true },
  { "payment-network.com", true },
  { "paymentaccuracy.gov", true },
  { "payments-reference.org", true },
  { "paymill.com", true },
  { "paymill.de", true },
  { "payoff.com", true },
  { "paypal.com", false },
  { "payroll.xero.com", false },
  { "paysera.com", true },
  { "paytm.in", true },
  { "payupay.ru", true },
  { "pbscreens.com", true },
  { "pcel.com", true },
  { "pcfeuerwehr.de", true },
  { "pcforum.sk", true },
  { "pclob.gov", true },
  { "pcloud.com", true },
  { "pctonic.net", true },
  { "pdf.yt", true },
  { "pe.search.yahoo.com", false },
  { "pear2pear.de", true },
  { "pedicureduiven.nl", true },
  { "pedroventura.com", true },
  { "peercraft.com", true },
  { "peerherrmann.de", true },
  { "peervpn.net", true },
  { "peifi.de", true },
  { "pekkapikkarainen.fi", true },
  { "pekoe.se", true },
  { "pelanucto.cz", true },
  { "penablog.com", true },
  { "penfold.fr", true },
  { "pengi.me", true },
  { "pennergold.net", true },
  { "pennyapp.io", true },
  { "pennylane.me.uk", true },
  { "pensiunealido.ro", true },
  { "pentagram.me", true },
  { "pentesterlab.com", true },
  { "peoplesbankal.com", true },
  { "pepchid.com", false },
  { "pepperworldhotshop.de", true },
  { "per-pedes.at", true },
  { "perdel.cn", true },
  { "perfect.in.th", true },
  { "perfectionis.me", true },
  { "perfektesgewicht.com", true },
  { "perfektesgewicht.de", true },
  { "performaterm.ro", true },
  { "perishablepress.com", true },
  { "perot.me", true },
  { "perplex.nl", false },
  { "pestici.de", true },
  { "petabits.de", true },
  { "petchart.net", true },
  { "peter.org.ua", true },
  { "peterdavehello.org", true },
  { "petersmark.com", false },
  { "pethub.com", true },
  { "petja.me", false },
  { "petko.me", true },
  { "petplum.com", true },
  { "petplus.com", true },
  { "petrachuk.ru", true },
  { "petravdbos.nl", true },
  { "petsittersservices.com", true },
  { "pettsy.com", true },
  { "peytonfarrar.com", true },
  { "pfadfinder-aurich.de", true },
  { "pfd-nz.com", true },
  { "pgmann.cf", true },
  { "pgmsource.com", true },
  { "pgregg.com", true },
  { "ph.search.yahoo.com", false },
  { "pharmaboard.de", true },
  { "pharmgkb.org", true },
  { "phil.tw", true },
  { "philadelphia.com.mx", true },
  { "philadelphiadancefoundation.org", true },
  { "philosopherswool.com", true },
  { "philosophyguides.org", true },
  { "philphonic.de", true },
  { "phoebe.co.nz", true },
  { "phoenix.dj", true },
  { "phoenixlogan.com", true },
  { "photoblogverona.com", true },
  { "php-tuning.de", true },
  { "phparcade.com", true },
  { "phpdorset.co.uk", true },
  { "phperformances.fr", true },
  { "phpfashion.com", true },
  { "phryanjr.com", false },
  { "phryneas.de", true },
  { "phunehehe.net", true },
  { "phurl.de", true },
  { "pi-supply.com", true },
  { "picardiascr.com", true },
  { "pickr.co", true },
  { "picksin.club", true },
  { "picoauto.com", true },
  { "piconepress.com", true },
  { "picotech.com", true },
  { "picscare.co.uk", true },
  { "picsto.re", true },
  { "pieperhome.de", true },
  { "pier28.com", true },
  { "pierre-denoblens.net", true },
  { "pierre-schmitz.com", true },
  { "pieterhordijk.com", true },
  { "pijuice.com", true },
  { "pileofgarbage.net", true },
  { "pilgermaske.org", true },
  { "piligrimname.com", true },
  { "pimpmymac.ru", true },
  { "pincha.com.tw", true },
  { "pindanutjes.be", true },
  { "pinkcasino.co.uk", true },
  { "pipenny.net", true },
  { "pir9.com", true },
  { "pirateproxy.la", true },
  { "pirateproxy.pl", true },
  { "pirateproxy.pw", true },
  { "pirateproxy.sx", true },
  { "pirlitu.com", true },
  { "pirxpilot.me", true },
  { "pisexy.me", true },
  { "pitfire.io", false },
  { "pittonpreschool.com", true },
  { "piwko.co", true },
  { "pixel.facebook.com", false },
  { "pixel.google.com", true },
  { "pixelbash.de", true },
  { "pixelminers.net", true },
  { "pixi.me", true },
  { "pjuu.com", true },
  { "pkgt.de", true },
  { "pl.search.yahoo.com", false },
  { "placefade.com", true },
  { "placehold.co", true },
  { "plaettliaktion.ch", true },
  { "plainjs.com", true },
  { "planboardapp.com", true },
  { "planet-work.com", true },
  { "planete-cocoon.com", true },
  { "play.google.com", true },
  { "playkh.com", true },
  { "playmaker.io", true },
  { "please-deny.me", true },
  { "pleier-it.de", true },
  { "pleier.it", true },
  { "plexusmd.com", true },
  { "plfgr.eu.org", true },
  { "plirt.ru", false },
  { "plogable.co", true },
  { "ploxel.com", true },
  { "pluga.co", true },
  { "plugin-planet.com", true },
  { "plus.google.com", false },
  { "plus.sandbox.google.com", false },
  { "plzenskybarcamp.cz", true },
  { "pm13.cz", true },
  { "pm13.org", true },
  { "pmctire.com", true },
  { "pmg-offshore-company.com", true },
  { "pmg-purchase.com", true },
  { "pmg-purchase.net", true },
  { "pmnts.io", true },
  { "pmponline.de", true },
  { "po.gl", true },
  { "pocloud.homelinux.net", true },
  { "poed.com.au", true },
  { "poedgirl.com", true },
  { "pointiswunderland.de", true },
  { "pokemori.jp", true },
  { "pol.in.th", true },
  { "poleartschool.com", true },
  { "polimat.org", true },
  { "polis.or.at", true },
  { "polis.to", false },
  { "politic.org.ua", true },
  { "politologos.org", true },
  { "pollpodium.nl", true },
  { "polymathematician.com", true },
  { "polynomapp.com", true },
  { "polypet.com.sg", true },
  { "polypho.nyc", true },
  { "ponythread.com", true },
  { "poolvilla-margarita.net", false },
  { "poon.io", true },
  { "poon.tech", true },
  { "port80.hamburg", true },
  { "portal.tirol.gv.at", true },
  { "portalplatform.net", true },
  { "portalzine.de", true },
  { "posobota.cz", true },
  { "post4me.at", true },
  { "postal.dk", true },
  { "postbox.life", true },
  { "postcodewise.co.uk", true },
  { "posteo.de", false },
  { "posterspy.com", true },
  { "postfinance.ch", true },
  { "postn.eu", true },
  { "postpi.com", true },
  { "postscheduler.org", true },
  { "posttigo.com", true },
  { "posylka.de", true },
  { "potbar.com", true },
  { "potbox.com", true },
  { "pothe.com", true },
  { "pothe.de", true },
  { "potlytics.com", true },
  { "poussinooz.fr", true },
  { "povitria.net", true },
  { "power-of-interest.com", true },
  { "powercloud.technology", true },
  { "powerplannerapp.com", true },
  { "powerxequality.com", true },
  { "ppmoon.com", true },
  { "ppro.com", true },
  { "ppy3.com", true },
  { "pr1sm.com", true },
  { "pr2studio.com", true },
  { "practicallabs.com", true },
  { "prakharprasad.com", true },
  { "prayerrequest.com", true },
  { "prediksisydney.com", true },
  { "predoiu.ro", true },
  { "prefis.com", true },
  { "prefontaine.name", true },
  { "preisser-it.de", true },
  { "preissler.co.uk", true },
  { "prekladysanca.cz", true },
  { "preloaded-hsts.badssl.com", true },
  { "premierheart.com", true },
  { "premiumzweirad.de", false },
  { "prepandgo-euro.com", true },
  { "presidentials2016.com", true },
  { "press-anime-nenkan.com", true },
  { "pressrush.com", true },
  { "pretix.eu", true },
  { "pretty.hu", true },
  { "prezola.com", true },
  { "pridetechdesign.com", true },
  { "pridoc.se", true },
  { "principaltoolbox.com", true },
  { "priva.si", true },
  { "privacy.com", true },
  { "privacyinternational.org", true },
  { "privacyrup.net", true },
  { "privategiant.com", true },
  { "privatepokertour.com", true },
  { "privytime.com", true },
  { "pro-bike.ro", true },
  { "pro-link.eu", true },
  { "procensus.com", true },
  { "professionalboundaries.com", true },
  { "profiles.google.com", true },
  { "profpay.com", true },
  { "profundr.com", true },
  { "progblog.net", true },
  { "progg.no", true },
  { "progreso.pl", true },
  { "progressiveplanning.com", true },
  { "projectarmy.net", true },
  { "projectascension.io", true },
  { "projectblackbook.us", true },
  { "projektzentrisch.de", true },
  { "promhadan.com", true },
  { "proofwiki.org", true },
  { "proos.nl", true },
  { "propagandism.org", true },
  { "prospo.co", true },
  { "protonmail.ch", true },
  { "protonmail.com", true },
  { "proustmedia.de", true },
  { "prowhisky.de", true },
  { "proximato.com", true },
  { "proxybay.al", true },
  { "proxybay.co", true },
  { "proxybay.la", true },
  { "prytkov.com", true },
  { "psw-group.de", true },
  { "psw.academy", true },
  { "psw.consulting", true },
  { "psw.net", true },
  { "psxtr.com", true },
  { "pt-server.de", true },
  { "ptbx.co", true },
  { "ptgoldensun.com", true },
  { "ptm.ro", true },
  { "ptn.moscow", true },
  { "puac.de", true },
  { "pubkey.is", true },
  { "publications.qld.gov.au", false },
  { "publicsuffix.org", true },
  { "pucssa.org", true },
  { "puikheid.nl", true },
  { "puiterwijk.org", true },
  { "pult.co", false },
  { "pumpgames.net", true },
  { "punknews.org", true },
  { "pupboss.com", true },
  { "purewebmasters.com", false },
  { "purplebricks.com", true },
  { "purplemoon.ch", true },
  { "purplemoon.mobi", true },
  { "purplestar.ch", true },
  { "purplestar.com", true },
  { "purplestar.mobi", true },
  { "puryearlaw.com", true },
  { "puyblanc.info", true },
  { "pvcvoordeel.nl", false },
  { "pwd.ovh", true },
  { "pwnies.dk", true },
  { "pygarage.com", true },
  { "pypa.io", true },
  { "pypi.python.org", true },
  { "python.org", false },
  { "q2.si", true },
  { "qa.fedoraproject.org", true },
  { "qa.stg.fedoraproject.org", true },
  { "qapital.com", true },
  { "qc.search.yahoo.com", false },
  { "qetesh.de", true },
  { "qewc.com", true },
  { "qgustavor.tk", true },
  { "qikan.net", true },
  { "qiliang.wang", true },
  { "qingpei.me", true },
  { "qinxi1992.com", true },
  { "qionglu.pw", true },
  { "qixxit.de", true },
  { "qlrace.com", false },
  { "qop.io", true },
  { "qorm.co.uk", true },
  { "qtl.me", true },
  { "qtpower.co.uk", true },
  { "qtxh.net", true },
  { "quai10.org", true },
  { "qualityedgarsolutions.com", true },
  { "qualityhomesystems.com", true },
  { "qualityology.com", true },
  { "quantenteranik.eu", true },
  { "quantoras.com", true },
  { "quantumfurball.net", true },
  { "quchao.com", true },
  { "quebecmailbox.com", true },
  { "queercinema.ch", true },
  { "queercoders.com", true },
  { "quera.ir", true },
  { "quire.io", true },
  { "quli.nl", true },
  { "quppa.net", true },
  { "quranserver.net", true },
  { "quuz.org", true },
  { "qvi.st", true },
  { "qvitoo.com", true },
  { "qwant.com", true },
  { "qwilink.me", true },
  { "r0t.co", true },
  { "r3s1stanc3.me", false },
  { "r40.us", true },
  { "r811.de", true },
  { "raah.co", true },
  { "racermaster.xyz", false },
  { "racius.com", true },
  { "raconconsulting.co.uk", true },
  { "rad-route.de", true },
  { "radicaleducation.net", true },
  { "radiormi.com", false },
  { "radtke.bayern", true },
  { "rafaelcz.de", true },
  { "rage4.com", true },
  { "ragingserenity.com", true },
  { "raidstone.com", true },
  { "raidstone.net", true },
  { "railgun.ac", true },
  { "raiseyourflag.com", true },
  { "ramatola.uk", true },
  { "rambitteh.ru", true },
  { "ramon-c.nl", true },
  { "ramsor-gaming.de", true },
  { "rangde.org", true },
  { "rantanda.com", true },
  { "rapenroer.nl", true },
  { "rapidthunder.io", true },
  { "raspass.me", true },
  { "raulfraile.net", true },
  { "rauros.net", true },
  { "ravchat.com", true },
  { "rawoil.com", true },
  { "rawstorieslondon.com", true },
  { "raydan.space", true },
  { "raydobe.me", false },
  { "raymii.org", true },
  { "razlaw.name", true },
  { "rbensch.com", true },
  { "rbhighinc.org", true },
  { "rburchell.com", true },
  { "rc4.io", true },
  { "rcnitrotalk.com", true },
  { "rcpcbd.com", true },
  { "reachr.com", true },
  { "reaconverter.com", true },
  { "reactivarte.es", true },
  { "reader.ga", true },
  { "readonly.de", true },
  { "realcapoeira.ru", true },
  { "realgarant-shop.de", true },
  { "reallifeforums.com", true },
  { "realmic.net", true },
  { "realmofespionage.com", true },
  { "realmofespionage.xyz", true },
  { "recht-freundlich.de", true },
  { "recommended.reviews", true },
  { "recon-networks.com", true },
  { "recyclingpromotions.us", true },
  { "red-t-shirt.ru", true },
  { "redb.cz", true },
  { "redd.it", true },
  { "reddit.com", true },
  { "reddit2kindle.com", true },
  { "redicabo.de", true },
  { "redirect.fedoraproject.org", true },
  { "redirect.stg.fedoraproject.org", true },
  { "redit.com", true },
  { "redletter.link", true },
  { "redlink.de", true },
  { "redmbk.com", true },
  { "rednsx.org", true },
  { "redports.org", false },
  { "redshield.co", true },
  { "redteam-pentesting.de", true },
  { "reedloden.com", true },
  { "reezer.org", true },
  { "refundo.cz", true },
  { "refundo.sk", true },
  { "reg.ru", false },
  { "regar42.fr", false },
  { "regionale.org", true },
  { "regiovertrieb.de", true },
  { "regmyr.se", true },
  { "reishunger.de", true },
  { "reisyukaku.org", true },
  { "rejo.in", true },
  { "release-monitoring.org", true },
  { "reliable-mail.de", true },
  { "rememberthemilk.com", false },
  { "remotestance.com", true },
  { "remoteutilities.com", true },
  { "renderloop.com", true },
  { "rene-schwarz.com", true },
  { "renemoser.net", true },
  { "renkenlaw.com", true },
  { "renlong.org", true },
  { "renrenche.com", true },
  { "rentcarassist.com", false },
  { "rentinsingapore.com.sg", true },
  { "renuo.ch", true },
  { "reox.at", true },
  { "repaxan.com", true },
  { "report-uri.com", true },
  { "report-uri.io", true },
  { "reporturi.com", true },
  { "reporturi.io", true },
  { "research.facebook.com", false },
  { "research.md", true },
  { "residentsinsurance.co.uk", true },
  { "resources.flowfinity.com", true },
  { "respice.xyz", true },
  { "responsibledisclosure.nl", true },
  { "restchart.com", true },
  { "retcor.net", true },
  { "retroarms.com", true },
  { "retroarms.cz", true },
  { "retrofitlab.com", true },
  { "reucon.com", true },
  { "revello.org", true },
  { "revolt.tv", true },
  { "rewrite3.com", true },
  { "rezosup.net", true },
  { "rezosup.org", true },
  { "rgavmf.ru", true },
  { "rhdigital.pro", true },
  { "rheocube.com", true },
  { "rhering.de", true },
  { "rheuma-online.de", true },
  { "rhinelander.ca", true },
  { "rhodri.io", true },
  { "rhymix.org", true },
  { "riccy.org", true },
  { "richardhering.de", true },
  { "richardwarrender.com", true },
  { "richiemail.net", true },
  { "richmondsunlight.com", false },
  { "richsiciliano.com", true },
  { "ricki-z.com", true },
  { "rickyromero.com", true },
  { "ricochet.im", true },
  { "rid-wan.com", false },
  { "ride-up.com", true },
  { "rideworks.com", true },
  { "riesenmagnete.de", true },
  { "riesenweber.id.au", true },
  { "right-to-love.name", true },
  { "rightcapital.com", true },
  { "rigolitch.fr", true },
  { "riiconnect24.net", true },
  { "rika.me", true },
  { "ring0.xyz", false },
  { "ringh.am", true },
  { "ringingliberty.com", true },
  { "rinobroer.nl", true },
  { "rischard.org", true },
  { "riseup.net", true },
  { "riskmitigation.ch", true },
  { "ristioja.ee", true },
  { "rivy.org", true },
  { "rix.ninja", true },
  { "rj.gg", true },
  { "rk6.cz", true },
  { "rlalique.com", true },
  { "rmb.li", true },
  { "rmmanfredi.com", true },
  { "rms.sexy", true },
  { "rmstudio.tw", true },
  { "rngmeme.com", true },
  { "ro.search.yahoo.com", false },
  { "roave.com", true },
  { "robandjanine.com", true },
  { "robertglastra.com", true },
  { "roberthurlbut.com", true },
  { "robertkrueger.de", true },
  { "robertof.ovh", true },
  { "robi-net.it", true },
  { "robigalia.org", true },
  { "robinadr.com", true },
  { "robinsonyu.com", true },
  { "robinwinslow.uk", true },
  { "robohash.org", true },
  { "robspc.repair", true },
  { "robteix.com", true },
  { "robtex.com", true },
  { "robtex.net", true },
  { "robtex.org", true },
  { "robud.info", true },
  { "rocketmill.co.uk", true },
  { "rodehutskors.net", true },
  { "rodney.id.au", true },
  { "rodolfo.gs", true },
  { "rodosto.com", true },
  { "roeckx.be", true },
  { "roeitijd.nl", true },
  { "roelf.org", true },
  { "roeper.party", true },
  { "rohedaten.de", true },
  { "rohlik.cz", true },
  { "rokki.ch", true },
  { "roland.io", true },
  { "rolemaster.net", true },
  { "romab.com", true },
  { "romaimperator.com", true },
  { "romainmuller.xyz", true },
  { "roman-pavlik.cz", true },
  { "romulusapp.com", false },
  { "room-checkin24.de", true },
  { "room208.org", true },
  { "roombase.nl", true },
  { "roomhub.jp", true },
  { "roosterpgplus.nl", true },
  { "rootforum.org", true },
  { "rootrelativity.com", true },
  { "roots.io", true },
  { "rootservice.org", true },
  { "rootwpn.com", true },
  { "rop.io", true },
  { "roquecenter.org", true },
  { "rosenkeller.org", true },
  { "rossen.be", true },
  { "rot47.net", true },
  { "rotunneling.net", true },
  { "rotzonline.com", true },
  { "roundcube.mayfirst.org", false },
  { "roundtheme.com", true },
  { "rous.se", true },
  { "royalacademy.org.uk", true },
  { "royalpalacenogent.fr", true },
  { "royzez.com", true },
  { "rozalisbengal.ro", true },
  { "rpy.xyz", true },
  { "rr.in.th", true },
  { "rrke.cc", true },
  { "rsajeey.info", true },
  { "rsf.io", true },
  { "rsi.im", false },
  { "rssr.se", true },
  { "rtcx.net", true },
  { "rtd.uk.com", true },
  { "ru-sprachstudio.ch", true },
  { "ru.search.yahoo.com", false },
  { "ruanmi.de", true },
  { "rubberfurs.org", true },
  { "rubecodeberg.com", true },
  { "rubendv.be", true },
  { "rubi-ka.net", true },
  { "rubysecurity.org", true },
  { "rudeotter.com", true },
  { "ruderverein-gelsenkirchen.de", true },
  { "rugstorene.co.uk", true },
  { "runementors.com", true },
  { "runtondev.com", true },
  { "runway2street.com", true },
  { "rusadmin.biz", true },
  { "rushball.net", true },
  { "rusl.net", true },
  { "russmarshall.com", true },
  { "rutgerschimmel.nl", true },
  { "ruudkoot.nl", true },
  { "ruxit.com", false },
  { "rwanderlust.com", true },
  { "rws-vertriebsportal.de", true },
  { "rww.name", true },
  { "rxbusiness.com", true },
  { "ryan-goldstein.com", true },
  { "ryanhowell.io", true },
  { "ryanmcdonough.co.uk", true },
  { "ryansmithphotography.com", true },
  { "ryanteck.uk", false },
  { "s-c.se", true },
  { "s13d.fr", true },
  { "sabahattin-gucukoglu.com", true },
  { "safar.sk", true },
  { "safcstore.com", true },
  { "safejourney.education", true },
  { "safematix.com", true },
  { "safeme.ga", true },
  { "safemovescheme.co.uk", true },
  { "safescan.com", true },
  { "sagerus.com", true },
  { "sageth.com", true },
  { "saharalondon.com", true },
  { "saikarra.com", false },
  { "sailormoonevents.org", false },
  { "saintsrobotics.com", true },
  { "salaervergleich.com", true },
  { "sale4ru.ru", true },
  { "saleaks.org", true },
  { "salesmachine.io", true },
  { "salon.io", true },
  { "saltercane.com", true },
  { "saltstack.cz", true },
  { "samaritansnet.org", true },
  { "samba.org", true },
  { "sambeso.net", true },
  { "samegoal.com", true },
  { "samegoal.org", true },
  { "samfunnet.no", false },
  { "samifar.in", true },
  { "samizdat.cz", true },
  { "samkelleher.com", true },
  { "sampoznay.ru", true },
  { "samuelkeeley.com", true },
  { "samwu.tw", false },
  { "sanasport.cz", true },
  { "sanchez.adv.br", true },
  { "sandbagexpress.com", true },
  { "sandbox.mydigipass.com", false },
  { "sanderdorigo.nl", true },
  { "sandervankasteel.nl", true },
  { "sandor.wtf", true },
  { "sanglierhurlant.fr", true },
  { "sanhei.ch", true },
  { "santanderideas.com", true },
  { "santing.net", true },
  { "saorsat.ie", true },
  { "sapience.com", true },
  { "sarahbeckettharpist.com", true },
  { "sarahlicity.co.uk", true },
  { "sarakas.com", true },
  { "sarasturdivant.com", true },
  { "sardegnatirocini.it", true },
  { "sarisonproductions.com", true },
  { "sash.pw", true },
  { "sat4all.com", true },
  { "satmep.com", true },
  { "satrent.se", true },
  { "saulchristie.com", true },
  { "saunas.fr", true },
  { "save.gov", true },
  { "saveaward.gov", true },
  { "savetheinternet.eu", true },
  { "saveyour.biz", true },
  { "savic.com", true },
  { "savvytime.com", true },
  { "sazuz.cz", true },
  { "sb-group.dk", true },
  { "sbssoft.ru", true },
  { "sc4le.com", true },
  { "scaling.solutions", true },
  { "scandicom.fi", true },
  { "schachburg.de", true },
  { "schelberts.de", true },
  { "schlabbi.com", true },
  { "schlarp.com", true },
  { "schmitz.link", true },
  { "schneids.me", true },
  { "schnouki.net", true },
  { "schoepski.de", true },
  { "schokokeks.org", true },
  { "schont.org", true },
  { "schorel.ovh", true },
  { "schorelweb.nl", true },
  { "schreibnacht.de", true },
  { "schrodinger.io", true },
  { "schumanandmonnet.eu", true },
  { "schwarzer.it", true },
  { "schwarzkopfforyou.de", true },
  { "schwarzwaldcon.de", true },
  { "schwinabart.com", true },
  { "schwinger.me", true },
  { "scicasts.com", true },
  { "sciencex.com", true },
  { "scotthel.me", true },
  { "scotthelme.co.uk", true },
  { "scotthelme.com", true },
  { "scottstorey.co.uk", true },
  { "scourt.org.ua", true },
  { "scoutdb.ch", true },
  { "scp-trens.notaires.fr", true },
  { "scrambl.is", true },
  { "scrambler.in", false },
  { "scrap.tf", true },
  { "scrapings.net", true },
  { "scrayos.net", true },
  { "screencaster.io", true },
  { "screenlight.tv", true },
  { "screenresolution.space", true },
  { "scribe.systems", true },
  { "scrion.com", true },
  { "script.google.com", true },
  { "scriptict.nl", true },
  { "scs-simulatoren.de", true },
  { "sdcardrecovery.de", true },
  { "sdrobs.com", true },
  { "sdsl-speedtest.de", true },
  { "se.search.yahoo.com", false },
  { "seanholcroft.co.uk", true },
  { "search-one.de", true },
  { "search.yahoo.com", false },
  { "searchbrothers.com", true },
  { "seatbeltpledge.com", true },
  { "seattlefabrication.com", true },
  { "sebastianboegl.de", true },
  { "sec.gd", true },
  { "secandtech.com", true },
  { "secctexasgiving.org", true },
  { "secpatrol.de", true },
  { "secretserveronline.com", true },
  { "sectia22.ro", true },
  { "section.io", true },
  { "secure-games.us", true },
  { "secure-graphic.de", true },
  { "secure.advancepayroll.com.au", true },
  { "secure.facebook.com", false },
  { "securedevelop.net", true },
  { "securedrop.org", false },
  { "secureideas.com", false },
  { "secureradio.net", true },
  { "securesuisse.ch", true },
  { "securify.nl", true },
  { "security-carpet.com", true },
  { "security.google.com", true },
  { "securityheaders.com", true },
  { "securityheaders.io", true },
  { "securitysnobs.com", false },
  { "securitystreak.com", true },
  { "securiviera.ch", true },
  { "secuvera.de", true },
  { "sedoexperts.nl", true },
  { "seele.ca", false },
  { "segurosocial.gov", false },
  { "seifried.org", true },
  { "seiko-dojo.com", true },
  { "selcusters.nl", true },
  { "selecadm.name", true },
  { "selectel.ru", true },
  { "selectorders.com", true },
  { "selent.me", true },
  { "self-injury.net", true },
  { "selfici.com", true },
  { "selfici.cz", true },
  { "sellme.biz", true },
  { "sellocdn.com", true },
  { "seminariruum.ee", true },
  { "semyonov.us", true },
  { "sendc.at", true },
  { "sendcat.com", true },
  { "sendmeback.de", true },
  { "sendya.me", true },
  { "seo-nerd.de", true },
  { "seo.consulting", true },
  { "sephr.com", true },
  { "septakkordeon.de", true },
  { "seq.tf", true },
  { "sequencing.com", true },
  { "serbanpaun.ro", true },
  { "serfdom.io", true },
  { "serized.pw", true },
  { "serveradminz.com", true },
  { "serverco.com", true },
  { "servercode.ca", true },
  { "serveroffline.net", false },
  { "serverstuff.info", true },
  { "servertastic.com", true },
  { "servethecity-karlsruhe.de", false },
  { "seryo.moe", true },
  { "seryo.net", true },
  { "seryovpn.com", true },
  { "sessionslogning.dk", true },
  { "setfix.de", true },
  { "setuid.io", true },
  { "sevsopr.ru", true },
  { "sexwork.net", true },
  { "seyahatsagliksigortalari.com", true },
  { "seyr.me", true },
  { "sftool.gov", true },
  { "sg.search.yahoo.com", false },
  { "sgcaccounts.co.uk", true },
  { "sh-network.de", true },
  { "shaaaaaaaaaaaaa.com", true },
  { "shadex.net", true },
  { "shadowkitsune.net", true },
  { "shaitan.eu", true },
  { "shakepeers.org", true },
  { "shan.io", true },
  { "shanewadleigh.com", true },
  { "shannoneichorn.com", true },
  { "sharepic.xyz", true },
  { "shasso.com", true },
  { "shaundanielz.com", true },
  { "shaunwheelhou.se", true },
  { "shawnh.net", true },
  { "sheilasdrivingschool.com", true },
  { "shellvatore.us", true },
  { "shenyuqi.com", true },
  { "sherbers.de", true },
  { "shft.cl", true },
  { "shiftins.com", false },
  { "shiftplanning.com", true },
  { "shiinko.com", false },
  { "shinju.moe", true },
  { "shiona.xyz", true },
  { "shipard.com", true },
  { "shipcloud.io", true },
  { "shiroki-k.net", true },
  { "shodan.io", true },
  { "shome.de", true },
  { "shopapi.cz", true },
  { "shopbakersnook.com", true },
  { "shoplandia.co", true },
  { "shortdiary.me", true },
  { "shortr.li", true },
  { "showsonar.com", true },
  { "shtorku.com", true },
  { "shulan.moe", true },
  { "shv25.se", true },
  { "si-benelux.nl", true },
  { "siciliadigitale.pro", true },
  { "siddhant.me", true },
  { "sideshowbarker.net", true },
  { "sidium.de", true },
  { "sidnicio.us", true },
  { "siebens.net", true },
  { "siewert-kau.de", true },
  { "sig6.org", true },
  { "sigabrt.org", true },
  { "sightcure.jp", true },
  { "sighup.nz", true },
  { "signere.com", true },
  { "signing-milter.org", true },
  { "signtul.com", false },
  { "sigterm.sh", true },
  { "sikatehtaat.fi", true },
  { "sikayetvar.com", true },
  { "silentcircle.com", false },
  { "silentkernel.fr", true },
  { "silentlink.io", true },
  { "silentundo.org", true },
  { "silkebaekken.no", true },
  { "silver-heart.co.uk", true },
  { "silverdragonart.com", true },
  { "silvergoldbull.com", true },
  { "silvergoldbull.de", true },
  { "silverhome.ninja", true },
  { "silverwind.io", true },
  { "simbolo.co.uk", false },
  { "simod.org", false },
  { "simonkjellberg.com", true },
  { "simonwessel.net", true },
  { "simphony.cz", true },
  { "simple.com", false },
  { "simpleai.net", true },
  { "simplednscrypt.org", true },
  { "simplelearner.com", true },
  { "simpletax.ca", false },
  { "simplexsupport.com", false },
  { "simplia.cz", true },
  { "simply-premium.com", true },
  { "simplycharlottemason.com", true },
  { "simplyfixit.co.uk", true },
  { "simplystudio.com", true },
  { "sin30.net", true },
  { "sincron.org", true },
  { "singul4rity.com", true },
  { "sinoscandinavia.se", true },
  { "siraweb.org", true },
  { "sirenslove.com", true },
  { "siriuspup.com", true },
  { "sistemy48.ru", false },
  { "sisv.eu", true },
  { "sitehost.io", true },
  { "sites.google.com", true },
  { "sitesko.de", true },
  { "sitesten.com", true },
  { "sixt.ch", true },
  { "sixt.co.uk", true },
  { "sixt.com", true },
  { "sixt.com.br", true },
  { "sixt.de", true },
  { "sizingservers.be", true },
  { "sizzle.co.uk", true },
  { "sjoorm.com", true },
  { "skanvordoff.ru", true },
  { "skatn.de", true },
  { "skeeley.com", true },
  { "skhoop.cz", true },
  { "skhosting.eu", true },
  { "skia.org", true },
  { "skilletfood.com", true },
  { "skills2services.com", true },
  { "skimming.net", true },
  { "skipfault.com", true },
  { "skoda-clever-lead.de", true },
  { "skoda-im-dialog.de", true },
  { "skoda-nurdiebesten.de", true },
  { "skoda-service-team-cup.de", true },
  { "skogsbruket.fi", true },
  { "skogskultur.fi", true },
  { "skoleniphp.cz", true },
  { "skou.dk", true },
  { "skullhouse.nyc", true },
  { "skydrive.live.com", false },
  { "skyminds.net", true },
  { "skyoy.com", true },
  { "skyway.capital", true },
  { "slack-files.com", true },
  { "slack.com", true },
  { "sladic.si", true },
  { "slainvet.net", true },
  { "slamdjapan.com", true },
  { "slamix.nl", true },
  { "slaps.be", true },
  { "slashdesign.it", true },
  { "slattery.co", true },
  { "slauber.de", true },
  { "sleio.com", true },
  { "slever.cz", true },
  { "slevomat.cz", true },
  { "sliceone.com", true },
  { "slidebatch.com", true },
  { "slightfuture.click", true },
  { "slightfuture.com", true },
  { "slix.io", true },
  { "slope.haus", true },
  { "slotboss.co.uk", true },
  { "slse.ca", true },
  { "slycurity.de", true },
  { "smalldata.tech", true },
  { "smares.de", true },
  { "smartairkey.com", true },
  { "smartcleaningcenter.nl", true },
  { "smartlend.se", true },
  { "smartlocksmith.com", true },
  { "smartmessages.net", true },
  { "smartphone.continental.com", false },
  { "smartpolicingplatform.com", true },
  { "smartship.co.jp", true },
  { "smartsparrow.com", true },
  { "smartwurk.nl", true },
  { "smb445.com", true },
  { "smiatek.name", true },
  { "smirkingwhorefromhighgarden.pro", true },
  { "smith.is", true },
  { "smittix.co.uk", true },
  { "smm.im", true },
  { "smoothics.com", true },
  { "smove.sg", true },
  { "sms1.ro", true },
  { "snailing.org", true },
  { "snakehosting.dk", false },
  { "snapappointments.com", true },
  { "snapappts.com", true },
  { "snazel.co.uk", true },
  { "sneakynote.com", true },
  { "sneberger.cz", true },
  { "sneezry.com", true },
  { "snelwerk.be", true },
  { "sniep.net", true },
  { "snille.com", true },
  { "snl.no", true },
  { "snoozedds.com", true },
  { "snoqualmiefiber.org", true },
  { "snowcrestdesign.com", true },
  { "sny.no", true },
  { "sobabox.ru", true },
  { "sobie.ch", true },
  { "sobotkama.eu", true },
  { "soci.ml", true },
  { "social-media-strategies.it", true },
  { "socialgrowing.cl", true },
  { "socialhams.net", false },
  { "socialhead.io", true },
  { "socialnous.co", true },
  { "socialrank.com", true },
  { "socialspirit.com.br", false },
  { "societyhilldance.com", true },
  { "socioambiental.org", true },
  { "sockeye.cc", false },
  { "sodi.nl", true },
  { "sofort.com", true },
  { "sofortueberweisung.de", true },
  { "softwarebetrieb.de", true },
  { "sogutma.com.tr", true },
  { "soia.ca", true },
  { "soju.fi", true },
  { "soldecom.com", true },
  { "soleus.nu", true },
  { "solidus.systems", true },
  { "solihullcarnival.co.uk", true },
  { "solihulllionsclub.org.uk", true },
  { "solsystems.ru", true },
  { "somebodycares.org", true },
  { "sonafe.info", true },
  { "soondy.com", true },
  { "soph.us", true },
  { "soply.com", true },
  { "soporte.cc", true },
  { "sorz.org", true },
  { "sosaka.ml", true },
  { "sosecu.red", true },
  { "souki.cz", true },
  { "soulfulglamour.uk", true },
  { "soulogic.com", false },
  { "soumikghosh.com", true },
  { "soundforsound.co.uk", true },
  { "soundgasm.net", true },
  { "soundtalks.com", true },
  { "sourceway.de", true },
  { "southernutahinfluencers.com", true },
  { "southside-crew.com", true },
  { "souvik.me", true },
  { "souyidai.com", true },
  { "soved.eu", true },
  { "sovereignshare.com", true },
  { "sown.dyndns.org", true },
  { "sowncloud.de", true },
  { "sp.rw", true },
  { "spacedust.xyz", true },
  { "spacefish.biz", true },
  { "sparelib.com", true },
  { "sparklebastard.com", true },
  { "sparklingsparklers.com", true },
  { "sparsa.army", true },
  { "spawn.cz", true },
  { "spdf.net", true },
  { "spectrosoftware.de", true },
  { "speed-mailer.com", true },
  { "speedcounter.net", true },
  { "speedtest-russia.com", true },
  { "speedy.lt", true },
  { "speich.net", true },
  { "sperrstun.de", true },
  { "spicydog.org", true },
  { "spicymatch.com", true },
  { "spideroak.com", true },
  { "spiegels.nl", true },
  { "spielcasinos.com", true },
  { "spiet.nl", true },
  { "spillmaker.no", true },
  { "spira.io", true },
  { "spiritbionic.ro", true },
  { "splikity.com", true },
  { "sportifik.com", true },
  { "sportwette.eu", true },
  { "spot-events.com", true },
  { "spreadsheets.google.com", true },
  { "spreed.me", true },
  { "spritchard.photos", true },
  { "sprueche-zum-valentinstag.de", true },
  { "sprueche-zur-geburt.info", true },
  { "sprueche-zur-hochzeit.de", true },
  { "sprueche-zur-konfirmation.de", true },
  { "spuffin.com", true },
  { "spydersec.com", true },
  { "spyroszarzonis.com", true },
  { "square-gaming.org", true },
  { "square.com", false },
  { "square.gs", true },
  { "squareup.com", false },
  { "squawk.cc", true },
  { "srevilak.net", true },
  { "sritest.io", true },
  { "sro.center", true },
  { "srpdb.com", true },
  { "srrr.ca", true },
  { "ss.lv", false },
  { "ssbrm.ch", true },
  { "sscd.no", true },
  { "ssl-zertifikate.de", true },
  { "ssl.google-analytics.com", true },
  { "ssl.rip", true },
  { "sslcertificaten.nl", true },
  { "sslcheck.nl", true },
  { "ssldecoder.org", true },
  { "sslmate.com", true },
  { "sslpoint.com", true },
  { "sslzilla.de", true },
  { "sstewartgallus.com", true },
  { "ssworld.ga", true },
  { "staack.com", true },
  { "stablelib.com", true },
  { "stackptr.com", true },
  { "stadtbauwerk.at", true },
  { "stage.wepay.com", false },
  { "stalder.work", true },
  { "stalker-shop.com", true },
  { "stalkerhispano.com", true },
  { "stanandjerre.org", true },
  { "standardssuck.org", true },
  { "standingmist.com", true },
  { "star-citizen.wiki", true },
  { "starapple.nl", true },
  { "starcomproj.com", true },
  { "starpeak.org", true },
  { "starsam80.net", true },
  { "starstreak.net", true },
  { "startupsort.com", true },
  { "stassi.ch", true },
  { "static.wepay.com", false },
  { "staticisnoise.com", true },
  { "stationary-traveller.eu", true },
  { "stationaryjourney.com", true },
  { "statuscode.ch", true },
  { "stay.black", true },
  { "stbennett.org", true },
  { "stderr.cc", true },
  { "steakovercooked.com", true },
  { "steamdb.info", true },
  { "steelephys.com.au", true },
  { "stefanovski.io", true },
  { "stefanweiser.de", true },
  { "stefany.eu", true },
  { "stellenticket.de", true },
  { "stemsims.com", true },
  { "stephanierxo.com", true },
  { "stephenandburns.com", true },
  { "stereochro.me", false },
  { "sternplastic.com", true },
  { "stesti.cz", true },
  { "stevegrav.es", true },
  { "steventress.com", true },
  { "stewartremodelingadvantage.com", true },
  { "stichtingsticky.nl", true },
  { "stick2bike.de", true },
  { "sticklerjs.org", true },
  { "stigharder.com", true },
  { "stinkytrashhound.com", true },
  { "stirling.co", true },
  { "stirlingpoon.com", true },
  { "stirlingpoon.xyz", true },
  { "stjohnin.com", true },
  { "stjohnmiami.org", true },
  { "stkbn.com", true },
  { "stmbgr.com", true },
  { "stn.me.uk", true },
  { "stnl.de", true },
  { "stocktrade.de", false },
  { "stocktrader.com", true },
  { "stoffelen.nl", true },
  { "stoianlawfirm.com", true },
  { "stolina.de", true },
  { "stolkschepen.nl", true },
  { "stomt.com", true },
  { "stopwoodfin.org", true },
  { "storedsafe.com", true },
  { "storefrontify.com", true },
  { "stormhub.org", true },
  { "stormyyd.com", true },
  { "storvann.net", true },
  { "storvann.no", true },
  { "storycollective.nl", true },
  { "strasweb.fr", false },
  { "streampanel.net", false },
  { "streams.dyndns.org", true },
  { "stressfreehousehold.com", true },
  { "stretchmyan.us", true },
  { "stricted.net", true },
  { "strijkshop.be", true },
  { "stripe.com", true },
  { "strobeltobias.de", true },
  { "strobeto.de", true },
  { "strom.family", true },
  { "strongest-privacy.com", true },
  { "structurally.net", true },
  { "strugee.net", true },
  { "stuartbaxter.co", false },
  { "stuartbell.co.uk", true },
  { "student.andover.edu", true },
  { "studentloans.gov", true },
  { "studentskydenik.cz", true },
  { "studer.su", true },
  { "studienportal.eu", true },
  { "studlan.no", true },
  { "studyhub.cf", true },
  { "stugb.de", true },
  { "stulda.cz", true },
  { "stumf.si", true },
  { "stuntmen.xyz", true },
  { "stupus.com", true },
  { "stygium.net", true },
  { "styles.pm", true },
  { "suave.io", true },
  { "subdimension.org", false },
  { "subeesu.com", true },
  { "sublevel.net", true },
  { "subrosa.io", true },
  { "suche.org", true },
  { "sudo.im", true },
  { "sudo.ws", true },
  { "sufix.cz", true },
  { "suian.or.jp", true },
  { "suite73.org", true },
  { "sulek.eu", true },
  { "sumoscout.de", true },
  { "sunbritetv.com", true },
  { "sundayfundayjapan.com", true },
  { "suneilpatel.com", true },
  { "sunflyer.cn", false },
  { "sunjaydhama.com", true },
  { "sunnyfruit.ru", true },
  { "suos.io", true },
  { "supcro.com", true },
  { "superbabysitting.ch", true },
  { "superbart.nl", true },
  { "superbshare.com", true },
  { "supereight.net", true },
  { "supermarx.nl", true },
  { "supersalescontest.nl", true },
  { "supplies24.at", true },
  { "supplies24.es", true },
  { "support.mayfirst.org", false },
  { "suprlink.net", true },
  { "surkatty.org", true },
  { "surveypirate.com", true },
  { "survivalmonkey.com", true },
  { "susanbpilates.co", true },
  { "susanbpilates.com", true },
  { "sushifrick.de", true },
  { "svager.cz", true },
  { "svallee.fr", false },
  { "svarovani.tk", true },
  { "sveneckelmann.de", true },
  { "svijet-medija.hr", true },
  { "swansdoor.org", true },
  { "swapadoodle.com", true },
  { "sway-cdn.com", true },
  { "sway.com", true },
  { "swedishhost.com", true },
  { "swedishhost.se", true },
  { "sweetll.me", true },
  { "sweetstreats.ca", true },
  { "swehack.org", false },
  { "swift-devedge.de", true },
  { "swimming.ca", true },
  { "swiss-cyber-experts.ch", true },
  { "swite.com", true },
  { "swyn.net", true },
  { "sx3.no", true },
  { "syam.cc", true },
  { "sychov.pro", true },
  { "syezd.com.au", true },
  { "sykepleien.no", true },
  { "sylaps.com", true },
  { "sylvan.me", true },
  { "synackr.com", true },
  { "synatra.co", true },
  { "syncappate.com", true },
  { "synchrocube.com", true },
  { "syncmylife.net", true },
  { "syncserve.net", true },
  { "synony.me", true },
  { "syntaxnightmare.com", true },
  { "sysadmins.ro", true },
  { "sysctl.se", true },
  { "sysdb.io", true },
  { "sysmike.de", true },
  { "syso.name", true },
  { "syss.de", true },
  { "system.is", true },
  { "systemintegra.ru", true },
  { "systemreboot.net", true },
  { "syzygy-tables.info", true },
  { "szagun.net", true },
  { "szaszm.tk", true },
  { "szaydon.me", false },
  { "szongott.net", true },
  { "t0dd.eu", false },
  { "t23m-navi.jp", false },
  { "t7e.de", true },
  { "tablotv.com", false },
  { "taborsky.cz", true },
  { "tacticalsquare.com", true },
  { "tadigitalstore.com", true },
  { "tahf.net", true },
  { "tailpuff.net", true },
  { "taken.pl", true },
  { "takeshifujimoto.com", true },
  { "takkaaaaa.com", true },
  { "talado.gr", false },
  { "talentcast.nl", true },
  { "talideon.com", false },
  { "talk.google.com", true },
  { "talkgadget.google.com", true },
  { "talktwincities.com", true },
  { "tallr.se", true },
  { "tallshoe.com", true },
  { "taniesianie.pl", true },
  { "tankski.co.uk", true },
  { "tannenhof-moelln.de", true },
  { "tantalos.nl", true },
  { "tappublisher.com", true },
  { "taranis.re", true },
  { "tarhauskielto.fi", true },
  { "tartaneagle.org.uk", false },
  { "tartaros.fi", true },
  { "tas2580.net", true },
  { "taskotron.fedoraproject.org", true },
  { "taskotron.stg.fedoraproject.org", true },
  { "taskstats.com", true },
  { "taskstream.com", true },
  { "taskulu.com", true },
  { "tasmansecurity.com", true },
  { "tatort-fanpage.de", true },
  { "tauchkater.de", true },
  { "taxaroo.com", true },
  { "taxbench.com", true },
  { "taxsquirrel.com", true },
  { "tazemama.biz", true },
  { "tazj.in", false },
  { "tazz.in", true },
  { "tbrss.com", true },
  { "tbspace.de", true },
  { "tc-bonito.de", true },
  { "tcao.info", true },
  { "tcdw.net", true },
  { "tcgrepublic.com", true },
  { "tcomms.org", true },
  { "tdelmas.eu", true },
  { "tdelmas.ovh", true },
  { "tdrs.info", true },
  { "teachercreatedmaterials.com", true },
  { "teachforcanada.ca", true },
  { "teamblueridge.org", true },
  { "teamnorthgermany.de", true },
  { "teampaddymurphy.ie", true },
  { "teampoint.cz", true },
  { "teamtouring.net", true },
  { "teamupturn.com", true },
  { "teamzeus.cz", true },
  { "tecart-cloud.de", true },
  { "tecart-system.de", true },
  { "tecartcrm.de", true },
  { "tech-seminar.jp", true },
  { "techandtux.de", true },
  { "techassist.io", true },
  { "techcavern.ml", true },
  { "techcentric.com", false },
  { "techelements.co", true },
  { "techhipster.net", true },
  { "techhub.ml", true },
  { "techllage.com", true },
  { "techloaner.com", true },
  { "techmatehq.com", true },
  { "technoparcepsilon.fr", true },
  { "technosavvyport.com", true },
  { "technotonic.com.au", false },
  { "techpivot.net", true },
  { "techvalue.gr", true },
  { "tecture.de", true },
  { "teddy.ch", true },
  { "teemperor.de", true },
  { "tehotuotanto.net", true },
  { "tehrabbitt.com", false },
  { "tekshrek.com", false },
  { "telekollektiv.org", true },
  { "teleogistic.net", true },
  { "telescam.com", true },
  { "tellingua.com", true },
  { "temizmama.com", true },
  { "temp.pm", true },
  { "tempus-aquilae.de", true },
  { "tendertool.nl", true },
  { "tent.io", true },
  { "tenyx.de", true },
  { "teodio.cl", true },
  { "terrab.de", true },
  { "terraelectronica.ru", true },
  { "terraform.io", true },
  { "terrastaffinggroup.com", true },
  { "terraweb.net", true },
  { "terrax.info", true },
  { "terrax.net", true },
  { "terrty.net", true },
  { "tescoirelandpayslips.com", true },
  { "testandroid.xyz", true },
  { "testbawks.com", true },
  { "testnode.xyz", true },
  { "testsuite.org", true },
  { "tetsumaki.net", true },
  { "textburst.com", true },
  { "texte-zur-taufe.de", true },
  { "texter-linz.at", true },
  { "textracer.dk", true },
  { "textualapp.com", true },
  { "texy.info", true },
  { "tezcam.tk", true },
  { "tf-network.de", true },
  { "tf2b.com", true },
  { "tfnapps.de", true },
  { "th.search.yahoo.com", false },
  { "thca.ca", true },
  { "the-construct.com", true },
  { "the-earth-yui.net", true },
  { "the-gist.io", true },
  { "the-paddies.de", true },
  { "theamateurs.net", true },
  { "theamp.com", true },
  { "theater.cf", true },
  { "thebigwave.de", true },
  { "thebikeinsurer.co.uk", true },
  { "thebimhub.com", true },
  { "thebreakroom.org", true },
  { "thebrotherswarde.com", true },
  { "thecandidforum.com", true },
  { "thecloudmigrator.com", true },
  { "thecustomizewindows.com", true },
  { "thedark1337.com", true },
  { "thedisc.nl", true },
  { "thedreamtravelgroup.co.uk", true },
  { "theescapistswiki.com", true },
  { "thefrozenfire.com", false },
  { "thego2swatking.com", true },
  { "thegoldregister.co.uk", true },
  { "thegraciousgourmet.com", true },
  { "thehackerblog.com", true },
  { "thehiddenbay.me", true },
  { "thehiddenbay.net", true },
  { "thehonorguard.org", true },
  { "thehotfix.net", true },
  { "theinitium.com", true },
  { "theintercept.com", true },
  { "theinvisibletrailer.com", true },
  { "theitsage.com", true },
  { "thejserver.de", true },
  { "thekelvinliu.com", true },
  { "thelapine.ca", true },
  { "thelocals.ru", true },
  { "themarshallproject.org", true },
  { "themeaudit.com", true },
  { "themicrocapital.com", true },
  { "themoep.at", true },
  { "themostexpensiveworkofart.com", true },
  { "thenocman.com", true },
  { "theodorejones.info", true },
  { "theojones.name", true },
  { "thepaymentscompany.com", true },
  { "thepb.in", true },
  { "thepiratebay.al", true },
  { "therapynotes.com", true },
  { "therewill.be", true },
  { "therockawaysny.com", true },
  { "thescientists.nl", true },
  { "theseed.io", true },
  { "theseletarmall.com", true },
  { "thesession.org", false },
  { "theshadestore.com", true },
  { "thesled.net", true },
  { "thestagchorleywood.co.uk", true },
  { "thestory.ie", true },
  { "thetechnical.me", true },
  { "thetomharling.com", true },
  { "thetradinghall.com", true },
  { "thetuxkeeper.de", true },
  { "theunitedstates.io", true },
  { "theweilai.com", false },
  { "theworldsend.eu", true },
  { "theyosh.nl", true },
  { "thezero.org", true },
  { "thezonders.com", true },
  { "thibautcharles.net", true },
  { "thierryhayoz.ch", true },
  { "thijsalders.nl", true },
  { "thinkcoding.de", true },
  { "thinkcoding.org", true },
  { "thinkindifferent.net", true },
  { "thinklikeanentrepreneur.com", true },
  { "thisisforager.com", true },
  { "thisserver.dontexist.net", true },
  { "thiswebhost.com", true },
  { "thkb.net", true },
  { "thom4s.info", true },
  { "thomas-grobelny.de", true },
  { "thomasbreads.com", true },
  { "thomasgriffin.io", true },
  { "thomashunter.name", false },
  { "thomasnet.fr", true },
  { "thomastimepieces.com.au", true },
  { "thomspooren.nl", true },
  { "thorbis.com", true },
  { "thorbiswebsitedesign.com", true },
  { "thorgames.nl", true },
  { "thouni.de", true },
  { "threedpro.me", true },
  { "threelions.ch", true },
  { "throwpass.com", true },
  { "thrx.net", true },
  { "thusoy.com", true },
  { "thyngster.com", false },
  { "tianshili.me", true },
  { "ticketmates.com.au", true },
  { "tickopa.co.uk", true },
  { "tictactux.de", true },
  { "tid.jp", false },
  { "tidycustoms.net", true },
  { "tiendavertigo.com", true },
  { "tiendschuurstraat.nl", true },
  { "tiens-ib.cz", true },
  { "tiensnet.com", true },
  { "tifan.net", true },
  { "tiffnix.com", true },
  { "tigerchef.com", true },
  { "tikutiku.pl", true },
  { "timetab.org", true },
  { "timmy.ws", true },
  { "timtaubert.de", true },
  { "tinastahlschmidt.de", true },
  { "tinfoilsecurity.com", false },
  { "tinkertry.com", false },
  { "tinte24.de", true },
  { "tintenfix.net", true },
  { "tinylan.com", true },
  { "tinyvpn.net", true },
  { "tinyvpn.org", true },
  { "tiplanet.org", true },
  { "tipps-fuer-den-haushalt.de", true },
  { "tipsyk.ru", true },
  { "tit.systems", true },
  { "tittelbach.at", true },
  { "tlach.cz", true },
  { "tlo.hosting", true },
  { "tlo.link", true },
  { "tlo.network", true },
  { "tlo.xyz", true },
  { "tls.builders", true },
  { "tls.li", true },
  { "tls1914.org", true },
  { "tm-solutions.eu", true },
  { "tmaward.net", true },
  { "tmitchell.io", true },
  { "tmprod.com", true },
  { "tmpsantos.com.br", true },
  { "tmtopup.com", true },
  { "tncnanet.com.br", true },
  { "tnes.dk", true },
  { "tno.io", true },
  { "tnrsca.jp", false },
  { "tobias-kluge.de", true },
  { "tobiasmathes.com", true },
  { "tobiasmathes.name", true },
  { "tobiassachs.de", true },
  { "tobiassattler.com", true },
  { "toccoig.com", true },
  { "todesschaf.org", true },
  { "todo.is", true },
  { "todoist.com", true },
  { "tokke.dk", true },
  { "tollsjekk.no", true },
  { "tom.horse", true },
  { "tomasjacik.cz", true },
  { "tomask.info", true },
  { "tomaspialek.cz", true },
  { "tomatenaufdenaugen.de", true },
  { "tomaw.net", true },
  { "tombrossman.com", true },
  { "tomcort.com", true },
  { "tomeara.net", true },
  { "tomfisher.eu", true },
  { "tomharling.co.uk", true },
  { "tomharling.uk", true },
  { "tomli.me", true },
  { "tommyads.com", true },
  { "tomo.gr", false },
  { "tomrei.com", true },
  { "tomrichards.net", true },
  { "tomudding.nl", true },
  { "tomvote.com", true },
  { "tomwiggers.nl", true },
  { "tonage.de", true },
  { "tonburi.jp", true },
  { "toncusters.nl", true },
  { "toner24.at", true },
  { "toner24.co.uk", true },
  { "toner24.es", true },
  { "toner24.fr", true },
  { "toner24.it", true },
  { "toner24.nl", true },
  { "toner24.pl", true },
  { "tonerdepot.de", true },
  { "tonerjet.at", true },
  { "tonerjet.co.uk", true },
  { "tonerklick.de", true },
  { "tonerkurier.de", true },
  { "tonermaus.de", true },
  { "tonermonster.de", true },
  { "tonex.de", true },
  { "tonex.nl", true },
  { "tonsit.com", true },
  { "tonsit.org", true },
  { "tonymanning.com", true },
  { "tonytan.cn", true },
  { "tonytan.io", true },
  { "tonywebster.com", true },
  { "toolbox.ninja", true },
  { "toomanypillows.com", true },
  { "tooolroc.org", true },
  { "top-stage.net", true },
  { "topmarine.se", true },
  { "topnewstoday.org", true },
  { "topnovini.com", true },
  { "toptexture.com", true },
  { "toptranslation.com", true },
  { "tor2web.org", true },
  { "torahanytime.com", true },
  { "tormentedradio.com", true },
  { "torproject.org", false },
  { "torprojects.com", true },
  { "torquato.de", false },
  { "torrent.is", true },
  { "tosecure.link", false },
  { "toshnix.com", true },
  { "tosteberg.se", true },
  { "totalcarcheck.co.uk", true },
  { "totalchecklist.com", true },
  { "totch.de", true },
  { "totem-eshop.cz", true },
  { "toucedo.de", true },
  { "touch.facebook.com", false },
  { "touch.mail.ru", true },
  { "touhou.cc", true },
  { "toutart.ch", true },
  { "townhousedevelopments.com.au", true },
  { "tox.im", true },
  { "toxme.se", true },
  { "toysperiod.com", true },
  { "tpbproxy.co", true },
  { "tpe-edu.com", true },
  { "tppleague.me", true },
  { "tr.search.yahoo.com", false },
  { "traas.org", true },
  { "trabbel.org", true },
  { "trackchair.com", true },
  { "tradeacademy.in", true },
  { "tradedesk.co.za", true },
  { "trainex.org", true },
  { "transformify.org", true },
  { "transitpoint.us", true },
  { "translate.fedoraproject.org", true },
  { "translate.googleapis.com", true },
  { "translate.stg.fedoraproject.org", true },
  { "transverify.com", true },
  { "trashnothing.com", true },
  { "trauertexte.info", true },
  { "travador.com", true },
  { "travisf.net", true },
  { "treebaglia.xyz", true },
  { "treeby.net", true },
  { "treeschat.com", true },
  { "trell.co.in", true },
  { "trendkraft.de", true },
  { "tresorit.com", true },
  { "tresorsecurity.com", true },
  { "tribaldos.com", true },
  { "tribut.de", true },
  { "trik.es", true },
  { "trimage.org", true },
  { "trineco.com", true },
  { "trineco.fi", true },
  { "triop.se", true },
  { "triple-mmm.de", true },
  { "trollme.me", true },
  { "trophee-discount.com", true },
  { "truckstop-magazin.de", true },
  { "trueblueessentials.com", true },
  { "trufflemonkey.co.uk", true },
  { "truserve.org", true },
  { "trustedinnovators.com", true },
  { "trusteecar.com", true },
  { "trustmeimfancy.com", true },
  { "tryoneday.co", true },
  { "trywesayyes.com", true },
  { "trzepak.pl", true },
  { "ts3.consulting", true },
  { "tssouthernpower.com", true },
  { "tsumi.it", true },
  { "ttcf.ca", true },
  { "tty.space", true },
  { "ttz.im", true },
  { "tuamoronline.com", true },
  { "tucny.com", true },
  { "tucuxi.org", true },
  { "tuingereedschappen.net", true },
  { "tuitle.com", true },
  { "tumutanzi.com", true },
  { "tunebitfm.de", true },
  { "tuningblog.eu", true },
  { "tunnelblick.net", true },
  { "tuntitili.fi", true },
  { "tuvalie.com", true },
  { "tuxcall.de", true },
  { "tuxgeo.com", false },
  { "tuxplace.nl", true },
  { "tuxz.net", true },
  { "tuzaijidi.com", true },
  { "tw.search.yahoo.com", false },
  { "twaka.com", true },
  { "twentymilliseconds.com", true },
  { "twist.party", true },
  { "twisto.cz", true },
  { "twitter.com", false },
  { "twitteroauth.com", true },
  { "twofactorauth.org", true },
  { "twolinepassbrewing.com", true },
  { "twopif.net", true },
  { "ty2u.com", true },
  { "tyche.io", true },
  { "typecodes.com", true },
  { "typeonejoe.com", true },
  { "typewolf.com", true },
  { "typing.com", true },
  { "typingrevolution.com", true },
  { "tzappa.net", true },
  { "u-blox.com", true },
  { "uae-company-service.com", true },
  { "uangteman.com", true },
  { "uasmi.com", true },
  { "uat-activesg.com", true },
  { "ub3rk1tten.com", false },
  { "ubanquity.com", true },
  { "ubertt.org", true },
  { "ubicv.com", true },
  { "ucfirst.nl", true },
  { "uerdingen.info", true },
  { "ufotable.uk", false },
  { "ui8.net", true },
  { "uk.search.yahoo.com", false },
  { "ukdefencejournal.org.uk", true },
  { "ukhas.net", true },
  { "ukrainians.ch", true },
  { "ukrgadget.com", true },
  { "ukwct.org.uk", true },
  { "ulabox.cat", true },
  { "ulabox.com", true },
  { "ulabox.es", true },
  { "ulmo.dk", true },
  { "ulrik.moe", true },
  { "umassfive.coop", true },
  { "umgardi.ca", true },
  { "umwandeln-online.de", true },
  { "un-zero-un.fr", true },
  { "unapp.me", true },
  { "unblocked-networks.org", true },
  { "undernet.uy", true },
  { "undone.me", true },
  { "unexpected.nu", true },
  { "uni-games.com", true },
  { "unicef.pl", true },
  { "unicredit.ba", true },
  { "unicredit.ro", true },
  { "unicreditbank.hu", true },
  { "unicreditbank.rs", true },
  { "unicreditbank.ru", true },
  { "uniekglas.nl", true },
  { "unila.edu.br", true },
  { "unionplat.ru", true },
  { "unionstationapp.com", true },
  { "unison.com", true },
  { "united.com", false },
  { "unitedadmins.com", true },
  { "unitel2000.de", true },
  { "unixadm.org", false },
  { "unknownphenomena.net", true },
  { "uno-pizza.ru", true },
  { "unoccupyabq.org", true },
  { "unpossible.xyz", true },
  { "unpr.dk", true },
  { "unravel.ie", true },
  { "uns.vn", true },
  { "unseen.tw", true },
  { "unterfrankenclan.de", true },
  { "unterschicht.tv", true },
  { "untoldstory.eu", true },
  { "unun.fi", true },
  { "unwiredbrain.com", true },
  { "unyq.me", false },
  { "uonstaffhub.com", true },
  { "uow.ninja", true },
  { "up1.ca", true },
  { "upboard.jp", true },
  { "upitnik.rs", true },
  { "upload.facebook.com", false },
  { "uploadbeta.com", true },
  { "upstats.eu", true },
  { "uptic.net", true },
  { "uptrends.com", true },
  { "uptrends.de", true },
  { "ur-lauber.de", true },
  { "urandom.eu.org", true },
  { "urban.melbourne", true },
  { "urbanmelbourne.info", true },
  { "uripura.de", true },
  { "urphp.com", true },
  { "us-immigration.com", true },
  { "usaa.com", false },
  { "usakitchensandflooring.com", true },
  { "usbcraft.com", true },
  { "usbtypeccompliant.com", true },
  { "uscitizenship.info", true },
  { "uscntalk.com", true },
  { "usd.de", true },
  { "use.be", true },
  { "useresponse.com", true },
  { "userify.com", true },
  { "usgande.com", true },
  { "usimmigration.us", true },
  { "usitcolours.bg", true },
  { "usparklodging.com", true },
  { "uspsoig.gov", true },
  { "ust.space", true },
  { "utdsgda.com", true },
  { "utilia.tools", true },
  { "utilityapi.com", true },
  { "utleieplassen.no", true },
  { "utonia.ch", true },
  { "utopians.dk", true },
  { "uvarov.pw", false },
  { "v0tti.com", false },
  { "vaddder.com", true },
  { "vagrantup.com", true },
  { "val-sec.com", true },
  { "valentin-sundermann.de", true },
  { "validbrands.com", true },
  { "valis.sx", true },
  { "valkohattu.fi", true },
  { "valmagus.com", true },
  { "valopv.be", true },
  { "valordolarblue.com.ar", true },
  { "valshamar.is", true },
  { "valsk.is", true },
  { "valtoaho.com", true },
  { "vanderkley.it", true },
  { "vanestack.com", true },
  { "vanetv.com", true },
  { "vangeluwedeberlaere.be", true },
  { "vanhoutte.be", true },
  { "vanitas.xyz", true },
  { "vanlaanen.com", true },
  { "vansieleghem.com", true },
  { "vantru.is", true },
  { "vapemania.eu", true },
  { "vapordepot.jp", true },
  { "varden.info", true },
  { "varghese.de", true },
  { "varunagw.com", false },
  { "varvy.com", true },
  { "vat-eu.com", true },
  { "vattulainen.fi", true },
  { "vaultproject.io", true },
  { "vazue.com", true },
  { "vbh2o.com", true },
  { "vbhelp.org", true },
  { "vbulletin-russia.com", true },
  { "vbulletinrussia.com", true },
  { "vcsjones.com", true },
  { "vdcomp.cz", true },
  { "ve.search.yahoo.com", false },
  { "veblen.com", true },
  { "vechkasov.ru", true },
  { "vegalitarian.org", true },
  { "veggiesbourg.fr", true },
  { "veil-framework.com", true },
  { "velasense.com", true },
  { "vemokin.net", true },
  { "venicerealdeal.com", true },
  { "verifikatorindonesia.com", true },
  { "veriny.tf", true },
  { "verizonguidelines.com", true },
  { "versbeton.nl", true },
  { "versia.ru", true },
  { "versicherungskontor.net", true },
  { "veryhax.de", true },
  { "vespacascadia.com", true },
  { "vetinte.eu", false },
  { "vfdworld.com", true },
  { "vfree.org", true },
  { "vgatest.nl", true },
  { "vglimg.com", true },
  { "vhost.co.id", true },
  { "viaprinto.de", true },
  { "viasinc.com", false },
  { "viciousviscosity.xyz", true },
  { "victorcanera.com", true },
  { "vid-immobilien.de", true },
  { "vide-greniers.org", true },
  { "videomail.io", false },
  { "vieclam24h.vn", false },
  { "viemeister.com", true },
  { "viennan.net", true },
  { "viewmyrecords.com", true },
  { "vigo-krankenversicherung.de", true },
  { "vijos.org", true },
  { "vikashkumar.me", true },
  { "vikings.net", true },
  { "villenvinkit.com", true },
  { "vimeo.com", true },
  { "vincentcox.com", true },
  { "vincentkooijman.at", true },
  { "vincentkooijman.nl", true },
  { "viperdns.com", true },
  { "vipnettikasinoklubi.com", true },
  { "virtualsanity.com", true },
  { "viscopic.com", true },
  { "visionless.me", false },
  { "visiontree-beta.eu", true },
  { "visiontree.eu", true },
  { "vistb.me", true },
  { "vitalorange.com", true },
  { "vitkausk.as", true },
  { "vitrado.de", true },
  { "vitta.me", true },
  { "vivaldi.club", true },
  { "vivatv.com.tw", true },
  { "vivendi.de", true },
  { "vjirovsky.cz", true },
  { "vleij.com", true },
  { "vleij.se", true },
  { "vm0.eu", true },
  { "vmem.jp", true },
  { "vmoagents.com", false },
  { "vmrdev.com", true },
  { "vn.search.yahoo.com", false },
  { "vnvisa.ru", true },
  { "vocaloid.my", true },
  { "vogt.tech", true },
  { "voidi.ca", true },
  { "vokeapp.com", true },
  { "volcrado.com", true },
  { "vomitb.in", true },
  { "vonedelmann.de", true },
  { "vop.li", true },
  { "vorlif.org", true },
  { "vorodevops.com", true },
  { "votocek.cz", true },
  { "votockova.cz", true },
  { "vpl.me", true },
  { "vpn.ht", true },
  { "vpnhot.com", true },
  { "vpnzoom.com", true },
  { "vrobert.fr", false },
  { "vrtak-cz.net", true },
  { "vsean.net", true },
  { "vserver-preis-vergleich.de", true },
  { "vsund.de", true },
  { "vulnerability.ch", true },
  { "vulners.com", true },
  { "vumetric.com", true },
  { "vvl.me", true },
  { "vyber-odhadce.cz", true },
  { "vyberodhadce.cz", true },
  { "vyplnto.cz", true },
  { "vzk.io", false },
  { "w-spotlight.appspot.com", true },
  { "w.wiki", true },
  { "w4a.fr", true },
  { "w4nvu.org", true },
  { "w4xzr.xyz", true },
  { "wachter.biz", true },
  { "wail.net", true },
  { "wait.jp", true },
  { "walkeryoung.ca", true },
  { "walkingforhealth.org.uk", true },
  { "wallet.google.com", true },
  { "wallpapers.pub", true },
  { "walnutgaming.co.uk", false },
  { "walnutgaming.com", false },
  { "wan.pp.ua", true },
  { "wanban.io", true },
  { "wander.al", true },
  { "wangqiliang.cn", true },
  { "wangqiliang.com", true },
  { "warandpeace.xyz", true },
  { "warekon.com", true },
  { "warr.ath.cx", true },
  { "warrencreative.com", false },
  { "warsentech.com", true },
  { "warsh.moe", true },
  { "wartorngalaxy.com", true },
  { "wasema.com", true },
  { "wasserspucker.de", true },
  { "wassim.is", true },
  { "waterfedpole.com", true },
  { "watersb.org", true },
  { "watertrails.io", true },
  { "watsonhall.uk", true },
  { "wbg-vs.de", true },
  { "wdbgroup.co.uk", true },
  { "wdesk.com", true },
  { "wealthprojector.com", true },
  { "wealthprojector.com.au", true },
  { "wearvr.com", true },
  { "weather-and-climate.com", true },
  { "weathermyway.rocks", true },
  { "web.cc", true },
  { "web4all.fr", true },
  { "webandmore.de", false },
  { "webandwords.com.au", true },
  { "webassadors.com", false },
  { "webcollect.org.uk", true },
  { "webdesigneauclaire.com", true },
  { "webdevops.io", true },
  { "webeau.com", true },
  { "webelement.sk", true },
  { "webfilings-eu-mirror.appspot.com", true },
  { "webfilings-eu.appspot.com", true },
  { "webfilings-mirror-hrd.appspot.com", true },
  { "webfilings.appspot.com", true },
  { "weblogzwolle.nl", true },
  { "webm.to", true },
  { "webmail.gigahost.dk", false },
  { "webmail.onlime.ch", false },
  { "webmail.schokokeks.org", false },
  { "webmaniabr.com", true },
  { "webmarketingfestival.it", true },
  { "webnosql.com", true },
  { "webogram.org", true },
  { "webrebels.org", true },
  { "webscale.nl", true },
  { "webseitendesigner.com", false },
  { "websenat.de", true },
  { "webstore.be", true },
  { "webstory.xyz", true },
  { "webstudio-n.com", true },
  { "webswitch.io", true },
  { "webtalis.nl", true },
  { "webtasarim.pw", true },
  { "webtiles.co.uk", true },
  { "webtobesocial.de", true },
  { "webtorrent.io", true },
  { "webtrh.cz", true },
  { "webyazilimankara.com", true },
  { "webzanem.com", true },
  { "weeblr.com", true },
  { "weekdone.com", true },
  { "weekly-residence.com", true },
  { "weggeweest.nl", true },
  { "wegner.no", true },
  { "weirdesigns.com", true },
  { "weisse-liste.de", true },
  { "welches-kinderfahrrad.de", true },
  { "wellacapability.com", true },
  { "welldrake.com", true },
  { "welovemail.com", true },
  { "welpy.com", false },
  { "welteneroberer.de", true },
  { "weltengilde.de", true },
  { "weltenhueter.de", true },
  { "weltmeisterschaft.net", true },
  { "wenjs.me", true },
  { "wepay.com", false },
  { "wepay.in.th", true },
  { "wer-kommt-her.de", true },
  { "werally.com", true },
  { "wesecom.com", false },
  { "wesleycabus.be", true },
  { "wesleyharris.ca", true },
  { "wessner.org", true },
  { "westcountrystalking.com", true },
  { "westeros.hu", true },
  { "westsuburbanbank.com", true },
  { "wetofu.top", true },
  { "wettbuero.de", true },
  { "wetten.eu", true },
  { "wettertoertchen.com", true },
  { "wetthost.com", true },
  { "wetttipps.com", true },
  { "wetttipps.de", true },
  { "wevahoo.com", true },
  { "wevolver.com", true },
  { "wf-bigsky-master.appspot.com", true },
  { "wf-demo-eu.appspot.com", true },
  { "wf-demo-hrd.appspot.com", true },
  { "wf-dogfood-hrd.appspot.com", true },
  { "wf-hosting.de", true },
  { "wf-pentest.appspot.com", true },
  { "wf-staging-hr.appspot.com", true },
  { "wf-training-hrd.appspot.com", true },
  { "wf-training-master.appspot.com", true },
  { "wf-trial-hrd.appspot.com", true },
  { "wfh.ovh", true },
  { "wfh.se", true },
  { "wftda.com", true },
  { "whatnext.limited", true },
  { "whatsapp.com", true },
  { "whatsmychaincert.com", true },
  { "whatsupgold.com.tw", true },
  { "whatwg.org", true },
  { "whd-guide.de", true },
  { "when-release.ru", false },
  { "when.fm", true },
  { "whereisjason.com", true },
  { "wherephoto.com", true },
  { "whey-protein.ch", true },
  { "whiskeyriver.co.uk", true },
  { "whisp.ly", true },
  { "whispeer.de", true },
  { "whitehouse.gov", true },
  { "whocalld.com", true },
  { "whocalled.us", true },
  { "wholebites.com", true },
  { "whonix.org", true },
  { "whoshotya.de", true },
  { "wideboxmacau.com", true },
  { "widememory.com", true },
  { "wienholding.at", true },
  { "wieninternational.at", true },
  { "wifimask.com", true },
  { "wifirst.net", true },
  { "wiimotion.de", true },
  { "wiire.me", true },
  { "wiki.python.org", true },
  { "wikibooks.org", true },
  { "wikidata.org", true },
  { "wikidsystems.com", false },
  { "wikimediafoundation.org", true },
  { "wikimilk.org", true },
  { "wikinews.org", true },
  { "wikipedia.org", true },
  { "wikiquote.org", true },
  { "wikisource.org", true },
  { "wikiversity.org", true },
  { "wikivoyage.org", true },
  { "wiktionary.org", true },
  { "wiktoriaslife.com", true },
  { "wildbee.org", true },
  { "wilddog.com", true },
  { "wilf1rst.com", true },
  { "williamfeely.info", true },
  { "williamsapiens.com", true },
  { "williamsonshore.com", true },
  { "willnorris.com", true },
  { "willosagiede.com", true },
  { "wills.co.tt", true },
  { "wind.moe", true },
  { "windscribe.com", true },
  { "winebid.com", true },
  { "winecodeavocado.com", true },
  { "winhistory-forum.net", true },
  { "winmodels.org", true },
  { "winmodels.ru", true },
  { "winpack.cf", true },
  { "winpack.eu.org", true },
  { "winsec.nl", true },
  { "winshiplending.com", true },
  { "winter.engineering", false },
  { "winterfeldt.de", true },
  { "wipply.com", true },
  { "wirc.gr", true },
  { "wis.no", true },
  { "wisv.ch", true },
  { "wisweb.no", true },
  { "wit.ai", true },
  { "witae.com", true },
  { "withgoogle.com", true },
  { "withinsecurity.com", true },
  { "withmy.beer", true },
  { "withyoutube.com", true },
  { "wittcher.com", true },
  { "wittydonut.com", true },
  { "wizzley.com", true },
  { "wje-online.de", true },
  { "wjglerum.nl", true },
  { "wkv.com", true },
  { "wlaws.com", true },
  { "wlzhiyin.cn", true },
  { "wm-talk.net", true },
  { "wnu.com", true },
  { "wo2forum.nl", true },
  { "wodka-division.de", true },
  { "wohlgemuth.rocks", false },
  { "wohnsitz-ausland.com", true },
  { "wolfachtal-alpaka.de", true },
  { "wolfemg.com", true },
  { "wolfesden.com", true },
  { "wolfsden.cz", true },
  { "wolfwings.us", true },
  { "womb.city", true },
  { "womf.org", true },
  { "wonderhost.info", true },
  { "wondermags.com", true },
  { "wondershift.biz", true },
  { "woodbury.io", true },
  { "woodlandschurch.net", true },
  { "woodlandsmetro.church", true },
  { "woodomat.com", true },
  { "woording.com", true },
  { "wootton95.com", true },
  { "worcesterfestival.co.uk", true },
  { "word-grabber.com", true },
  { "wordsmart.it", true },
  { "woresite.jp", true },
  { "workingclassmedia.com", true },
  { "workray.com", true },
  { "workwithgo.com", true },
  { "worldcubeassociation.org", true },
  { "woutergeraedts.nl", true },
  { "wownmedia.com", true },
  { "wp-tao.com", true },
  { "wpac.de", true },
  { "wpfortify.com", true },
  { "wphostingblog.nl", true },
  { "wpletter.de", false },
  { "wpmeetup-berlin.de", true },
  { "wpostats.com", true },
  { "wpserp.com", true },
  { "wpvulndb.com", true },
  { "wql.zj.cn", true },
  { "wrara.org", true },
  { "wrgms.com", true },
  { "wrightdoumawedding.com", true },
  { "wrldevelopment.com", true },
  { "wrwg.ca", true },
  { "wscales.com", true },
  { "wss.com.ve", true },
  { "wtfismyip.com", true },
  { "wubthecaptain.eu", true },
  { "wunderkarten.de", true },
  { "wunderlist.com", true },
  { "wundi.net", true },
  { "wurzelzwerg.net", true },
  { "wvr-law.de", false },
  { "ww2onlineshop.com", false },
  { "www.aclu.org", false },
  { "www.airbnb.com", true },
  { "www.apollo-auto.com", true },
  { "www.banking.co.at", false },
  { "www.braintreepayments.com", false },
  { "www.capitainetrain.com", false },
  { "www.captaintrain.com", false },
  { "www.cloudflare.com", false },
  { "www.cyveillance.com", true },
  { "www.dropbox.com", true },
  { "www.dropcam.com", false },
  { "www.entropia.de", false },
  { "www.eternalgoth.co.uk", true },
  { "www.etsy.com", true },
  { "www.evernote.com", false },
  { "www.facebook.com", false },
  { "www.fastmail.com", true },
  { "www.gamesdepartment.co.uk", false },
  { "www.getcloak.com", false },
  { "www.gmail.com", false },
  { "www.googlemail.com", false },
  { "www.gov.uk", false },
  { "www.gpo.gov", false },
  { "www.grc.com", false },
  { "www.healthcare.gov", false },
  { "www.heliosnet.com", true },
  { "www.honeybadger.io", false },
  { "www.icann.org", false },
  { "www.intercom.io", false },
  { "www.irccloud.com", false },
  { "www.lastpass.com", false },
  { "www.linode.com", false },
  { "www.lookout.com", false },
  { "www.makeyourlaws.org", true },
  { "www.mydigipass.com", false },
  { "www.mylookout.com", false },
  { "www.noisebridge.net", false },
  { "www.opsmate.com", true },
  { "www.paypal.com", false },
  { "www.python.org", true },
  { "www.rememberthemilk.com", true },
  { "www.schokokeks.org", true },
  { "www.simbolo.co.uk", false },
  { "www.simple.com", false },
  { "www.therapynotes.com", true },
  { "www.tinfoilsecurity.com", false },
  { "www.torproject.org", false },
  { "www.twitter.com", false },
  { "www.united.com", false },
  { "www.usaa.com", false },
  { "www.viasinc.com", true },
  { "www.vino75.com", false },
  { "www.wepay.com", false },
  { "www.zenpayroll.com", false },
  { "wxcafe.net", true },
  { "wxster.com", true },
  { "wyeworks.com", true },
  { "wzrd.in", true },
  { "wzyboy.org", true },
  { "x.io", true },
  { "x.st", true },
  { "x64architecture.com", true },
  { "xandocs.com", true },
  { "xatr0z.org", false },
  { "xbind.io", true },
  { "xbrlsuccess.appspot.com", true },
  { "xbt.co", true },
  { "xcoop.me", true },
  { "xd.cm", true },
  { "xdd.io", true },
  { "xellos.ga", true },
  { "xellos.ml", true },
  { "xenesisziarovky.sk", true },
  { "xerhost.de", true },
  { "xetown.com", true },
  { "xett.com", true },
  { "xf-liam.com", true },
  { "xgclan.com", true },
  { "xho.me", true },
  { "xiangweiqing.co.uk", true },
  { "xiaody.me", true },
  { "xiaofengsky.com", true },
  { "xiaoguo.net", true },
  { "xiaolan.me", true },
  { "xiaolvmu.me", true },
  { "xichtsbuch.de", true },
  { "xiyu.moe", true },
  { "xkviz.net", true },
  { "xmerak.com", true },
  { "xmppwocky.net", true },
  { "xmr.to", true },
  { "xn--3lqp21gwna.xn--fiqs8s", true },
  { "xn--3lqt7ir4md4tzwa.cn", true },
  { "xn--3lqt7ir4md4tzwa.xn--fiqs8s", true },
  { "xn--4dbjwf8c.cf", true },
  { "xn--4dbjwf8c.ga", true },
  { "xn--4dbjwf8c.ml", true },
  { "xn--4dbjwf8c.tk", true },
  { "xn--7xa.google.com", true },
  { "xn--datenrettung-mnchen-jbc.com", true },
  { "xn--hfk-allgu-schwaben-stb.de", true },
  { "xn--jobbrse-d1a.de", true },
  { "xn--jp-6l5cs1yf3ivjsglphyv.net", true },
  { "xn--knstler-n2a.tips", false },
  { "xn--lgb3a8bcpn.cf", true },
  { "xn--lgb3a8bcpn.ga", true },
  { "xn--lgb3a8bcpn.gq", true },
  { "xn--lgb3a8bcpn.ml", true },
  { "xn--ls8hi7a.tk", true },
  { "xn--maraa-rta.org", true },
  { "xn--mgbbh2a9fub.xn--ngbc5azd", true },
  { "xn--qckss0j.tk", true },
  { "xn--t8j4aa4nyhxa7duezbl49aqg5546e264d.net", true },
  { "xn--u9jv84l7ea468b.com", true },
  { "xng.io", true },
  { "xolphin.nl", true },
  { "xotika.tv", true },
  { "xpd.se", true },
  { "xps2pdf.co.uk", true },
  { "xqin.net", true },
  { "xss.ht", true },
  { "xss.sk", true },
  { "xtremegaming.it", true },
  { "xtrim.ru", true },
  { "xtronics.com", true },
  { "xuexb.com", true },
  { "xunn.io", true },
  { "xuntier.ch", true },
  { "xwalck.se", true },
  { "xwaretech.info", true },
  { "yafuoku.ru", true },
  { "yagihiro.tech", true },
  { "yahvehyireh.com", true },
  { "yakmade.com", true },
  { "yakmoo.se", true },
  { "yamadaya.tv", true },
  { "yamaken.jp", true },
  { "yanaduday.com", true },
  { "yanovich.net", true },
  { "yanwh.xyz", true },
  { "yaporn.tv", false },
  { "yatesun.com", true },
  { "yawnbox.com", true },
  { "yaxim.org", true },
  { "ycc.wtf", true },
  { "yecl.net", true },
  { "yello.website", true },
  { "yellowcar.website", true },
  { "yenniferallulli.com", true },
  { "yenniferallulli.de", true },
  { "yenniferallulli.es", true },
  { "yenniferallulli.moda", true },
  { "yenniferallulli.nl", true },
  { "yetcore.io", true },
  { "yetzt.me", true },
  { "yhaupenthal.org", true },
  { "yingyj.com", true },
  { "yippie.nl", true },
  { "yjsw.sh.cn", true },
  { "yksityisyydensuoja.fi", true },
  { "ymarion.de", true },
  { "yobst.tk", true },
  { "yolobert.de", true },
  { "yoloprod.fr", true },
  { "yoloseo.com", true },
  { "yombo.net", true },
  { "yoramvandevelde.net", true },
  { "yorcom.nl", true },
  { "yorname.ml", true },
  { "yosemo.de", true },
  { "youcancraft.de", true },
  { "youcontrol.ru", true },
  { "youdowell.com", true },
  { "youkok2.com", true },
  { "yoursecondphone.co", true },
  { "yourstrongbox.com", true },
  { "youtous.me", true },
  { "youyoulemon.com", true },
  { "ypart.eu", true },
  { "ypiresia.fr", true },
  { "yplanapp.com", true },
  { "ys-shop.biz", true },
  { "ytvwld.de", true },
  { "yuan.ga", true },
  { "yufan.me", true },
  { "yunity.org", true },
  { "yunzhu.li", true },
  { "yunzhu.org", true },
  { "yusa.me", false },
  { "yutabon.com", true },
  { "yuyu.io", true },
  { "yyyy.xyz", true },
  { "z.ai", true },
  { "z0rro.net", true },
  { "z1h.de", true },
  { "z33.ch", true },
  { "zacarias.com.ar", true },
  { "zadieheimlich.com", true },
  { "zadroweb.com", true },
  { "zakmccrac.de", true },
  { "zalan.do", true },
  { "zapier.com", true },
  { "zaufanatrzeciastrona.pl", true },
  { "zbasenem.pl", true },
  { "zberger.com", true },
  { "zcarot.com", false },
  { "zcarrot.com", true },
  { "zcon.nl", true },
  { "zdbl.de", true },
  { "zdrojak.cz", true },
  { "ze3kr.com", true },
  { "zebrababy.cn", true },
  { "zefu.ca", true },
  { "zehntner.ch", true },
  { "zelfstandigemakelaars.net", true },
  { "zellari.ru", true },
  { "zen-trader.com", false },
  { "zenithmedia.ca", true },
  { "zeno-system.com", true },
  { "zenpayroll.com", false },
  { "zentraler-kreditausschuss.de", true },
  { "zentralwolke.de", true },
  { "zeplin.io", true },
  { "zera.com.au", true },
  { "zerocool.io", true },
  { "zeropush.com", true },
  { "zett4.me", true },
  { "zgrep.org", true },
  { "zhang-hao.com", true },
  { "zhanghao.me", true },
  { "zhangyuhao.com", true },
  { "zhaofeng.li", true },
  { "zhaojin97.cn", true },
  { "zhihua-lai.com", true },
  { "zhovner.com", true },
  { "zifb.in", true },
  { "zima.io", true },
  { "zirtue.io", true },
  { "zixiao.wang", true },
  { "zizoo.com", true },
  { "zju.tv", true },
  { "zjubtv.com", true },
  { "zlatosnadno.cz", true },
  { "zlavomat.sk", true },
  { "zmy.im", true },
  { "znation.nl", true },
  { "zocken.com", true },
  { "zoe.vc", true },
  { "zoeller.me", true },
  { "zoneminder.com", true },
  { "zonglovani.info", true },
  { "zoomingin.net", true },
  { "zooom.azurewebsites.net", true },
  { "zooparadies.eu", true },
  { "zorntt.fr", true },
  { "zortium.report", true },
  { "zorz.info", true },
  { "zotero.org", true },
  { "zoznamrealit.sk", true },
  { "zravypapir.cz", true },
  { "zrn.in", true },
  { "zscales.com", true },
  { "ztan.tk", true },
  { "zulu7.com", true },
  { "zvps.uk", true },
  { "zwerimex.com", true },
  { "zx6rninja.de", true },
  { "zzsec.org", true },
  { "zzw.ca", true },
};
